/* 	File: PSRDEF.H 						*/
/*								*/
/*	SAIL RUNTIME  PROGRAM CONTROL PROCEDURES		*/
/*								*/
/*								*/
/*	P. Lemkin						*/
/*	Image Processing Section				*/
/*	National Cancer Institute, DCBD, LTB			*/
/*	FCRF, Build 469 Room 150B				*/
/*	Frederick, MD 21701					*/
/*
*    COPYRIGHT NOTICE - Copyright (c) 1983-1987 by Peter F. Lemkin.
*                     All rights reserved.
*       Permission is granted to any individual or institution to
*       copy, use or modify this program, except for explicitly
*       commercial purposes, provided this copyright notice is
*       included in its entirety in all derived works.  No warranty
*       of the software or of the accuracy of any documentation
*       surrounding it is expressed or implied, and the author does
*       not acknowledge any liability resulting from program or
*       documentation errors.
*/
/*								*/
/*	Version: 57.10						*/
/*                                                              */
/*      Revised October 10, 1987                                */
/*      Revised September 8, 1987                               */
/*      Revised September 7, 1987                               */
/*      Revised September 3, 1987                               */
/*      Revised August 12, 1987                                 */
/*      Revised June 30, 1987                                   */
/*      Revised June 27, 1987                                   */
/*	Revised February 28, 1987				*/
/*	Revised December 21, 1986				*/
/*	Revised September 26, 1986				*/
/*	Revised September 20, 1986				*/
/*	Revised September 19, 1986				*/
/*	Revised August 15, 1986					*/
/*	Revised August 14, 1986					*/
/*	Revised August 12, 1986					*/
/*	Revised August 11, 1986					*/
/*	Revised August 7, 1986					*/
/*	Revised June 22, 1986  					*/
/*	Revised May 7, 1986  					*/
/*	Revised April 6, 1986  					*/
/*	Revised March 29, 1986  				*/
/*	Revised March 8, 1986  					*/
/*	Revised January 18, 1986  				*/
/*	Revised January 3, 1986  				*/
/*	Revised December 18, 1985 				*/
/*	Revised December 13, 1985 				*/
/*	Revised December 12, 1985 				*/
/*	Revised December 6, 1985 				*/
/*	Revised November 26, 1985 				*/
/*	Revised November 22, 1985 				*/
/*	Revised November 21, 1985 B.S.				*/
/*	Revised November 21, 1985				*/
/*	Revised August 6, 1985					*/
/*	Revised March 8, 1985					*/
/*	June 29, 1984						*/
/*								*/
/*	This macro package includes the following standard 	*/
/*	macros necessary the <psrun-.c> files.			*/


/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/

#define IS_BUILDING_RUNTIMES 1		/* for testing standalone */
/*	+    C O M P I L E   T I M E   M A C R O S              */
/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/

#ifndef HASCONFIG
#include "config.h"	/* declare primary HAS... macros */
#endif

#ifndef HAS2CONFIG
#include "confg2.h"	/* declare 2ndary HAS... macros */
#endif


#include <stdio.h>      /* for everyone !!! */

#ifdef HASSARGASSOC	/* need bits for use with SARGASSO */
#ifndef IO_READ
#include <iodefs.hdr>
#endif
#endif

#ifdef HASX3J11			/* ANSI X3J11 C standard */
#ifdef HASLOCALFILE
#include "ctype.h" 
#include "setjmp.h"
#include "signal.h"
#include "stdarg.h"
#include "stdefs.h"
#include "stdlib.h"
#include "string.h"
#include "time.h"
#endif
#ifndef HASLOCALFILE
#include <ctype.h> 
#include <setjmp.h>
#include <signal.h>
#include <stdarg.h>
#include <stdefs.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#endif
#endif             /* end of HASX3J11 */


#ifdef HASSYSTEMV		   /* SYSTEM V - C standard */
#ifdef HASLOCALFILE
#include "ctype.h" 
#include "setjmp.h"
#include "signal.h"
#include "stdefs.h"
#include "string.h"
#include "time.h"
#include "types.h"		  
#endif
#ifndef HASLOCALFILE
#include <ctype.h> 
#include <setjmp.h>
#include <signal.h>
#include <stdefs.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#endif
#endif             /* end of SYSTEM V */


#ifdef HASBSD			/* BSD C standard */
#ifdef HASLOCALFILE
#include "ctype.h" 
#include "setjmp.h"
#include "signal.h"
#include "string.h"
#include "time.h"
#include "types.h"
#endif
#ifndef HASLOCALFILE
#include <ctype.h> 
#include <setjmp.h>
#include <signal.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#endif
#endif             /* end of BSD */

#ifndef HASPMATH	/* to define trig fcts in terms of <math.h> */
			/* We assume that your <math.h> pkg has the
			 * following functions - if not, then use 
			 * PSAIL's. Note: that PSAIL will assume
			 * (double) and cast accordingly.
			*/
#include <math.h>
#endif

#ifndef GC_RUN
#include "psrung.h"	/* bring in string G.C. macros and set flag */
#endif

/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/
/*	+     M A C R O S				+	*/
/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/



/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/
/*	+    DEBUGGING MACROS                           +       */
/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/
/*	The following macros temporarily replace the functions  */


/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/
/*	+     V A R I A B L E S / M A C R O S	                */
/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/

#ifndef PNULL
#define ABS(x)	((x)<0 ? -(x) : (x))
#define ABSF(x)	((x)<0.0 ? -(x) : (x))
#define CTRLZ	027
#define FALSE	((INTEGER)0)
#define FLOOR(x) ((INTEGER)(x))	/* ... do floor() fnct */
#define MAX(x,y) ( ( (x) > (y) ) ? (x) : (y))
#define MIN(x,y) ( ( (x) < (y) ) ? (x) : (y))
#define PNULL	""
#define TRUE	((INTEGER)1)

/* The following three definitions are used for variable arg lists
 * These definitions are taken from a discussion of ANSI C by Allen
 * Holub in DDJ, Aug 1987 pp100-108 entitled:
 *   "Subroutines with A Variable Number of Arguments"
 * It is used as fang("format-spec",a1,a2,...,an)
 * and the fct looks like
 *        fang(format)
 *            PS_VA_DCL format;
 *        { PS_VA_LIST argp;
 *          PS_VA_START(argp,format);
 *          ...
 *         --- for a type T (i.e. (char, short or int) use int
 *                                (long) use long
 *                                (float or double use double)
 *         ---
 *             ... PS_VA_ARG(argp,T) ...
 *        }
*/
#define PS_VA_ARG(argp,type) (((type *)(argp += sizeof(type)))[-1])
typedef char *PS_VA_DCL;
typedef char *PS_VA_LIST;
#define PS_VA_START(argp,format) ((char *)&format + sizeof(format))

#define MAXTTYLINE 256          /* max size of INCHWL() buffer */
#define TMPBUFSIZE 255			/* used only in input() */

#endif


/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/
/*	+    PSRUNi MACROS                              +       */
/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/
/*	NOTE: If you MUST use an EBCDIC machine with its archaic */
/*	character set instead of ASCII, then you MUST also	 */
/*	rewrite the following macro functions possibly using a	 */
/*	table lookup of character properties as is currently     */
/*	done for some C compilers! 				 */
#define cvlower(c) ((('A' <= c) && (c <= 'Z')) ? c+'a'-'A' : c)
#define cvupper(c) ((('a' <= c) && (c <= 'z')) ? c+'A'-'a' : c)
#define EXTRAHEADERFIELDS 10 
#ifdef HASMVARGS
#define INC_ARG_PTR(t) t--;	/* variable arg stack counts down */
#endif
#ifdef HASPVARGS
#define INC_ARG_PTR(t) t++;	/* variable arg stack counts up */
#endif
#ifndef isdigit
#define isdigit(c) (('0' <= c) && (c <= '9'))
#endif
#ifndef ishex
#define ishex(c) (('0' <= c) && (c <= '9')||('a' <= c) && (c <= 'z') || \
		   ('A' <= c) && (c <= 'Z'))
#endif
#ifndef islower
#define islower(c) (('a' <= c) && (c <= 'z'))
#endif
#ifndef isoctal
#define isoctal(c) (('0' <= c) && (c <= '7'))
#endif
#ifndef isupper
#define isupper(c) (('A' <= c) && (c <= 'Z'))
#endif
#ifdef HAS_EXIT
#define PEXIT _exit(000)	/* may change bits */
#endif
#ifdef HASEXIT
#define PEXIT  exit()
#endif
#ifdef HASANSIC
#define PEXIT  exit()
#endif
#define PROCEDURE /* NO-OP */


		/* used for extra header info in dynamic arrays */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/*	The following bits are used in the <psrun5.c> SCAN() package */
/*	and other library packages which worry about scan mode bits. */
#define Abit 01
#define Bbit 02
#define Cbit 04
#define Dbit 010
#define Ebit 020
#define Fbit 040
#define Gbit 0100
#define Hbit 0200
#define Ibit 0400
#define Jbit 01000
#define Kbit 02000
#define Lbit 04000
#define Mbit 010000
#define Nbit 020000
#define Obit 040000
#define Pbit 0100000
#define Qbit 0200000
#define Rbit 0400000
#define Sbit 01000000
#define Tbit 02000000
#define Ubit 04000000
#define Vbit 010000000
#define Wbit 020000000
#define Xbit 040000000
#define Ybit 0100000000
#define Zbit 0200000000

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

/*	salloc() string space data structures	*/

typedef struct P_snode { /* string space list of spaces */
	struct P_snode *prevSnode; /* prev ptr==>Linked list of SNODEs */
	struct P_snode *nextSnode; /* next ptr==>Linked list of SNODEs */
	STRING bot;	/* Bottom of AVAIL string list */
	STRING next;	/* next free ptr of string list */
	STRING top;	/* top ptr of AVAIL string list */
	STRING *rho;	/* ptr to GC sorted str ptr list*/
	INTEGER topRho;	/* index to above list*/
	INTEGER lthRho;	/* size of rho[] list*/
	} snode_t;

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/*	PSAIL Descriptor word status bits @V.56.35		 */
#define DWitemArray	040
#define DWfsm		0100
#define DWarray		0200
#define DWstatic	0400
#define DWfragment	01000
#define DWmacro		02000
#define DWexternal	04000
#define DWinternal	010000
#define DWleap		020000
#define DWformalArg	040000
#define DWprocedure	0100000
#define DWcArray	0200000
#define DWsafe		0400000
#define DWrecMem	01000000
#define DWforwardRef	02000000
#define DWgenericProc	04000000
#define DWreference	010000000
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */


/* The following table corresponds to PSGLBV.SAI table sCVtype[0:31] */
/* If it is changed, then so must the table defined here ...	     */
/* These are the Primary Data types in the DW @V.56.35.		     */

#define CODEarray 'a'
#define CODEinterrupt 'b'
#define CODEstring 'c'
#define CODEdouble 'd'
#define CODEevent 'e'
#define CODEreal 'f'
#define CODElabel 'g'
#define CODEatomLisp 'h'
#define CODEinteger 'i'
#define CODEobject 'j'
#define CODEsExprLisp 'k'
#define CODElist 'l'
#define CODEmacro 'm'
#define CODEvoid 'n'
#define CODEoptional 'o'
#define CODEprocedure 'p'
#define CODErecPtr 'q'
#define CODEreference 'r'
#define CODEset 's'
#define CODErecClass 't'
#define CODEunspecified 'u'
#define CODEitemvar 'v'
#define CODEown 'w'
#define CODEitem 'x'
#define CODErecMem 'y'
#define CODEsafe 'z'
#define CODEitemArray '{'
#define CODEshort '|'
#define CODEbyte '}'
#define CODEcArray '~'
#define CODEboolean '\177'

/*	The following are useful constants for MATH packages */
#define baseE	2.7182818284590452354	/* exponential base e */
#define LOG2e	1.4426950408889634074	/* log(e) base 2 constant */
#define LOG10e	0.43429448190325182765	/* log(e) base 10 constant */
#define LOGe2	0.69314718055994530942	/* ln(2) constant */
#define LN2     LOGe2
#define LN10	2.30258509299404568402
#define maxFACTORIAL	14 		/* 14! ok, 15! blows 26 bits */
#define PI	3.14159265358979323846
#define PIover2	1.57079632679489661923
#define PIover4	0.78539816339744830962
#define SQRT1half 0.70710678118654752440
#define SQRT2	1.41421356237309504880	 /* sqrt(2) const */
#define SQRT10	3.16227766016837	 /* sqrt(10) const */
#define oneDivPI 0.31830988618379067154	 /* 1.0/PI */
#define twoDivPI 0.63661977236758134308  /* 2.0/PI */
#define twoPI	6.28318530717958347692	 /* 2*PI */

/*	The following typedef can be used to convert data types */
union CVT {
	   INTEGER i;
	   float f;
	   double d;
	   STRING s;
	   INTEGER *ip;
	   float *fp;
	   double *dp;
	   STRING *sp;
	   INTEGER **ipp;
	   float **fpp;
	   double **dpp;
	   STRING **spp;
	  };
typedef union CVT cvt_t;

	/* This is how we will use it:
				 * Eg.    cvt_t cvt;
					  INTEGER x;
					  STRING *y;
					  cvt.sp = y;  x = cvt.i;
			 or   #define cvsp2i(i,sp) {cvt.sp = sp; i = cvt.i;}
        */
/* ---> END OF PSRDEF.H <--- */
