
/* 	File: PSRUN1.C 						*/
/*								*/
/*	SAIL RUNTIME  STORAGE ALLOCATION PROCEDURES		*/
/*								*/
/*								*/
/*	P. Lemkin						*/
/*	Image Processing Section				*/
/*	National Cancer Institute, DCBD, LTB			*/
/*	FCRF, Build 469 Room 150B				*/
/*	Frederick, MD 21701					*/
/*
*    COPYRIGHT NOTICE - Copyright (c) 1983-1987 by Peter F. Lemkin.
*                     All rights reserved.
*       Permission is granted to any individual or institution to
*       copy, use or modify this program, except for explicitly
*       commercial purposes, provided this copyright notice is
*       included in its entirety in all derived works.  No warranty
*       of the software or of the accuracy of any documentation
*       surrounding it is expressed or implied, and the author does
*       not acknowledge any liability resulting from program or
*       documentation errors.
*/
/*								*/
/*	Version: 57.10						*/
/*                                                              */
/*      Revised October 4, 1987                                 */
/*      Revised September 7, 1987                               */
/*      Revised July 23, 1987                                   */
/*      Revised July 1, 1987                                    */
/*      Revised June 30, 1987                                   */
/*      Revised June 27, 1987                                   */
/*	Revised June 26, 1987				        */
/*	Revised March 10, 1987				        */
/*	Revised December 21, 1986				*/
/*	Revised September 26, 1986				*/
/*	Revised August 14, 1986				*/
/*	Revised August 12, 1986				*/
/*	Revised August 11, 1986				*/
/*	Revised August 8, 1986				*/
/*	Revised August 6, 1986				*/
/*	Revised August 3, 1986				*/
/*	Revised July 8, 1986				*/
/*	Revised June 26, 1986				*/
/*	Revised May 7, 1986				*/
/*	Revised April 6, 1986				*/
/*	Revised March 29, 1986				*/
/*	Revised March 21, 1986				*/
/*	Revised March 15, 1986				*/
/*	Revised March 8, 1986				*/
/*	Revised February 28, 1986				*/
/*	Revised February 26, 1986				*/
/*	Revised January 9, 1986					*/
/*	Revised January 7, 1986					*/
/*	Revised December 19, 1985				*/
/*	Revised December 13, 1985				*/
/*	Revised December 12, 1985				*/
/*	Revised December 2, 1985				*/
/*	Revised November 26, 1985				*/
/*	Revised November 21, 1985				*/
/*	Revised November 5, 1985				*/
/*	Revised August 8, 1985					*/
/*	Revised August 6, 1985					*/
/*	Revised July 19, 1985					*/
/*	Revised June 19, 1985					*/
/*	Revised June 10, 1985					*/
/*	Revised May 30, 1985					*/
/*	Revised April 26, 1985					*/
/*	Revised March 8, 1985					*/
/*	June 29, 1984						*/
/*								*/
/*								*/
/*	This procedure package includes the following standard 	*/
/*	runtime functions necessary for easy use of the PSAIL	*/
/*	compiler in a UNIX environment.				*/
/*								*/
/*  1. Storage allocation procedures: sub-module <psrun1.c>	*/
/*	*aAdr(ptr,n,a1,a2,...,an) -  return array datum ptr    */
/*	*aAdrB(ptr,n,a1,...,an)- return array LISP!ATOM datum ptr */
/*	*aAdrC(ptr,n,a1,...,an)- return array STRING datum ptr */
/*	*aAdrD(ptr,n,a1,...,an)- return array DOUBLE datum ptr */
/*	*aAdrE(ptr,n,a1,...,an)- return array EVENT datum ptr */
/*	*aAdrF(ptr,n,a1,...,an)- return array REAL datum ptr */
/*	*aAdrI(ptr,n,a1,...,an)- return array INTEGER datum ptr */
/*	*aAdrJ(ptr,n,a1,...,an)- return array OBJECT datum ptr */
/*	*aAdrK(ptr,n,a1,...,an)- return array LISP!SEXPR datum ptr */
/*	*aAdrL(ptr,n,a1,...,an)- return array LIST datum ptr */
/*	*aAdrS(ptr,n,a1,...,an)- return array SET datum ptr */
/*	*aAdrV(ptr,n,a1,...,an)- return array ITEMVAR datum ptr */
/*	*aAdrX(ptr,n,a1,...,an)- return array ITEM datum ptr */
/*	*aChk(typ,ptr,n,a1,...,an)-check arg type/bounds, return ptr */
/*	*aChkB(ptr,n,a1,...,an)- cmput/chk array LISP!ATOM datum ptr */
/*	*aChkC(ptr,n,a1,...,an)- cmput/chk array STRING datum ptr */
/*	*aChkD(ptr,n,a1,...,an)- cmput/chk array DOUBLE datum ptr */
/*	*aChkE(ptr,n,a1,...,an)- cmput/chk array EVENT datum ptr */
/*	*aChkF(ptr,n,a1,...,an)- cmput/chk array REAL datum ptr */
/*	*aChkI(ptr,n,a1,...,an)- cmput/chk array INTEGER datum ptr */
/*	*aChkJ(ptr,n,a1,...,an)- cmput/chk array OBJECT datum ptr */
/*	*aChkK(ptr,n,a1,...,an)- cmput/chk array LISP!SEXPR datum ptr */
/*	*aChkL(ptr,n,a1,...,an)- cmput/chk array LIST datum ptr */
/*	*aChkS(ptr,n,a1,...,an)- cmput/chk array SET datum ptr */
/*	*aChkV(ptr,n,a1,...,an)- cmput/chk array ITEMVAR datum ptr */
/*	*aChkX(ptr,n,a1,...,an)- cmput/chk array ITEM datum ptr */
/*	arrblt(dPtr,sPtr,cnt) - do SAIL ARRBLT			*/
/*	arrclr(dPtr,value) - do SAIL ARRCLR dynamic array	*/
/*	arrinfo(buf,param) - do SAIL ARRINFO			*/
/*	arrtran(dPtr,sPtr) - do SAIL ARRTRAN dynamic arrays	*/
/*	aryel(ptr) - release dynamic array ptr      		*/
/*	aryfree() - free list of dynamically allocated arrays  */
/*	*aryHdr(&P_id,l1,u1,...,n,pName,type) - create dyn hdr ptr*/
/*	LISP_ATOM *aryHdrB() -  Create static array dyn-hdr LISP!ATOM*/
/*	STRING *aryHdrC() -  Create static array dyn-hdr STRING*/
/*	double *aryHdrD() -  Create static array dyn-hdr DOUBLE*/
/*	EVENT *aryHdrE() -  Create static array dyn-hdr EVENT*/
/*	float *aryHdrF() -  Create static array dyn-hdr REAL*/
/*	INTEGER *aryHdrI() -  Create static array dyn-hdr INTEGER*/
/*	OBJECT *aryHdrJ() -  Create static array dyn-hdr OBJECT*/
/*	LISP_SEXPR *aryHdrK() -  Create static arry dyn-hdr LISP!SEXPR*/
/*	LIST *aryHdrL() -  Create static array dyn-hdr LIST*/
/*	SET *aryHdrS() - Create static array dyn-hdr SET*/
/*	ITEMVAR *aryHdrV() -  Create static array dyn-hdr ITEMVAR*/
/*	ITEM *aryHdrX() -  Create static array dyn-hdr ITEM*/
/*	*arymk(n,l1,u1,l2,u2,...,pName,type) - make dynamic array ptr */
/*	LISP_ATOM *arymkB() -  Create dynamic array LISP!ATOM*/
/*	STRING *arymkC() -  Create dynamic array STRING*/
/*	double *arymkD() -  Create dynamic array DOUBLE*/
/*	EVENT *arymkE() -  Create dynamic array EVENT*/
/*	float *arymkF() -  Create dynamic array REAL*/
/*	INTEGER *arymkI() -  Create dynamic array INTEGER*/
/*	OBJECT *arymkJ() -  Create dynamic array OBJECT*/
/*	LISP_SEXPR *arymkK() -  Create static arry dyn-hdr LISP!SEXPR*/
/*	LIST *arymkL() -  Create dynamic array LIST*/
/*	SET *arymkS() - Create dynamic array SET*/
/*	ITEMVAR *arymkV() -  Create dynamic array ITEMVAR*/
/*	ITEM *arymkX() -  Create dynamic array ITEM*/
/*	Carrclr(dPtr,value,cnt) - do C ARRCLR			*/
/*	Carrtran(dPtr,sPtr,cnt) - do C ARRTRAN			*/
/*	chkversion(ptr-list,0) - check module version #s consistency */
/*	del_record(ptr) - delete record allocated with new_record */
/*	*new_record(nBytes,clasNam) - allocate a record size nBytes. */
/*	Phash(s,t,m) - lookup/enter string s in table t of size m */
/*	*salloc(nbytes) - allocate nbyte string GC'able string space */
/*	*Pmalloc(nbytes) - allocate nbyte storage from heap.	*/
/*	Pfree(ptr) - return block pointed to by ptr to heap.*/
/*								*/
/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/
/*	+    C O M P I L E   T I M E   M A C R O S              */
/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/

#ifndef HASCONFIG
#include "config.h"	/* declare HAS... macros */
#endif

#ifndef PNULL		/* need following if not compiling <sairun.c>*/
#include "psrdef.h"	/* need <sairun.c> & <psrung.h> compile-time macros */
#include "psrglb.h"	/* need <sairun.c> global variables */


/*	The following are found in PSRUN3.C			*/
#ifndef __SABER__
STRING catlist();  /* return concat of list of strings */
#else
STRING catlist(INTEGER, char *, ...);
#endif
INTEGER length();  /* return length of string */
STRING Pcpystr();  /* return salloc() string copy */

/*	The following are found in PSRUN4.C			*/
INTEGER equ();     /* return (s1[1:inf]==s2[1:inf]) ? 1 : 0 */
STRING cvs();      /* cvt. decimal integer to STRING, return ptr */

/*	The following are found in PSRUN7.C			*/
#ifndef __SABER__
void PSprintf();   /* PSAIL printf() type function */
#else
void PSprintf(char *, ...);
#endif

void usererr();    /* do SAIL USERERR */
#endif	       	/* end of code brought in if compiling alone */

/*	The following are FORWARD definitions in PSRUN1.C	*/
INTEGER arrinfo();	/* do SAIL ARRINFO of dynamic array*/
void Pfree(); 		/* return block pointed to by free store ptr*/
STRING Pmalloc(); 	/* allocate nbyte storage from heap */
STRING salloc();        /* allocate nbyte string from GC space. */

/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/
/*	+    G L O B A L    V A R I A B L E S / M A C R O S	*/
/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/

#ifdef hasALLOC
#undef hasALLOC
#endif

static INTEGER doingGC=FALSE;	/* TRUE while doing GC in salloc() */


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/*	*salloc() string space data structures	*/
static snode_t *strAvail=0;	/* Linked list of SNODE */
static snode_t *lastStrAvail=0;	/* last ptr to Linked list of SNODE */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/*	Pmalloc() storage space data structures	*/
typedef INTEGER ALIGN;	/* Forces alignment of blocks */
static union header {	/* Free block HEADER */
		    struct {
			   union header  *ptr; /* next free block */
			   unsigned size; /* size of this free block */
			   } s;
		    ALIGN x;  /* force alignment of blocks */
		    };

typedef union header HEADER;
static HEADER base;	     /* empty list to be started */
static HEADER *allocp=0;     /* last allocated block */
#define NALLOC 512	     /* # units to allocate at once */



/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* The following table corresponds to PSGLBV.SAI table sCVtype[0:31] */
/* If it is changed, then so must the table defined here ...	     */
/* and also in PSRDEF.H						     */
static STRING sCVtype[32]={
	"--NONE--",	/* -- 0 -- */
	"array",	/* -- a -- */
	"interrupt",	/* -- b -- */
	"string",	/* -- c -- */
	"double",	/* -- d -- */
	"event",	/* -- e -- */
	"real",		/* -- f -- */
	"label",	/* -- g -- */
	"atomLisp",	/* -- h -- */
	"integer",	/* -- i -- */
	"object",	/* -- j -- */
	"sExprLisp",	/* -- k -- */
	"list",		/* -- l -- */
	"macro",	/* -- m -- */
	"void",		/* -- n -- */
	"optional",	/* -- o -- */
	"process",	/* -- p -- */
	"record!pointer",  /* -- q -- */
	"reference",	/* -- r -- */
	"set",		/* -- s -- */
	"record!class", /* -- t -- */
	"unspecified", 	/* -- u -- */
	"itemvar",	/* -- v -- */
	"own",		/* -- w -- */
	"item",		/* -- x -- */
	"record!field",	/* -- y -- */
	"safe",		/* -- z -- */
	"item!Array",	/* -- { -- */
	"short",	/* -- | -- */
	"byte",		/* -- } -- */
	"cArray",	/* -- ~ -- */
	"boolean"     /* --DEL-- */ };

static char codMap[32] = {0,	/* -- 0 -- */
		 CODEarray,	/* -- a -- */
		 CODEinterrupt,	/* -- b -- */
		 CODEstring,	/* -- c -- */
		 CODEdouble,	/* -- d -- */
		 CODEevent,	/* -- e -- */
		 CODEreal,	/* -- f -- */
		 CODElabel,	/* -- g -- */
		 CODEatomLisp,	/* -- h -- */
		 CODEinteger,	/* -- i -- */
		 CODEobject,	/* -- j -- */
		 CODEsExprLisp,	/* -- k -- */
		 CODElist,	/* -- l -- */
		 CODEmacro,	/* -- m -- */
		 CODEvoid,	/* -- n -- */
		 CODEoptional,	/* -- o -- */
		 CODEprocedure,	/* -- p -- */
		 CODErecPtr,	/* -- q -- */
		 CODEreference,	/* -- r -- */
		 CODEset,	/* -- s -- */
		 CODErecClass,	/* -- t -- */
		 CODEunspecified, /* -- u -- */
		 CODEitemvar,	/* -- v -- */
		 CODEown,	/* -- w -- */
		 CODEitem,	/* -- x -- */
		 CODErecMem,	/* -- y -- */
		 CODEsafe,	/* -- z -- */
		 CODEitemArray,	/* -- { -- */
		 CODEshort,	/* -- | -- */
		 CODEbyte,	/* -- } -- */
		 CODEcArray,	/* -- ~ -- */
		 CODEboolean    /* --DEL-- */ };


/*	 --------------------------------------------	*/
/*		Layout of dynamic array header		*/
/*	 --------------------------------------------	*/

/*
@V.53.92

	The PSAIL dynamic array header, which is DIFFERENT from
the SAIL header ([ReisJ76] page 157) primarily because of the
different amount of space available in 32-bits versus 36-bits used in
the SAIL header, is currently defined as follows:

Let p be the pointer to the start of the data space of the array,
Let pHeader be the pointer to the start of header region below the
	data space of the array,
Let headerSize be the size of the header and is 3*n+10 where n is
	the number of dimensions of the array.
Let totalSize be the size of the array data segment and is the
	product of the differences of the bounds pairs:
		totalSize = (ub1-lb1+1) * (ub2-lb2+1) *  . . .
Then,

	*(p-1) = pHeader;
	*(p-2) = headerSize;
	*(p-3) = totalSize;
	*(p-4) = n;
	*(p-5) = name;	 # -- (char *) string name of array;
	*(p-6) = typeDW; # -- DW, descriptor word, type code of array;
	*(p-7) = baseword;
	*(p-8) = <free...>;
	*(p-9) = <free...>;
	*(p-10) = <free...>;
	for(ptmp=pHeader,i=1; i<=n; i++)
		{*(ptmp++) = lb[i];
		 *(ptmp++) = ub[i];
		}
	*(ptmp++) = mult = *(pHeader+2*n+n) = 1;
	*(ptmp++) = mult = *(pHeader+2*n+(n-1)) = (ub[n]-lb[n]+1)*mult;
		. . .
	*(ptmp++) = mult = *(pHeader+2*n+1) = (ub[2]-lb[2]+1)*mult;


This is illustrated below.

For example, the address computed for an array A with arguments
A[i,j,k] as:

	address(A[I,J,K]) = address(A) +
		(I-lb[1]*mult[1]) +
		(J-lb[2]*mult[2]) +
		(K-lb[3]).

where:
	mult[m] is the product of the total number of elements of
	dimensions m+1 through n (number of dimensions). Mult[n] for
	the last dimension n is always 1.

This expands to:
	address(A[I,J,K]) = address(A) +
		I*mult[1] + J*mult[2] + K 
		  -lb[1]*mult[1] +
		    lb[2]*mult[2] +
		      lb[3].

which is finally reduced to what we actually compute:
	address(A[I,J,K]) = baseword(A) + I*mult[1] + J*mult[2] + K.
where:
	baseword(A) = address(A) - (lb[1]*mult[1] +
				    lb[2]*mult[2] +
				    lb[3]).

            -----------------------------------------
  pHeader-->| lb1                                   |
            -----------------------------------------
            | ub1                                   |
            -----------------------------------------
			. . .
            -----------------------------------------
            | lbn                                   |
            -----------------------------------------
            | ubn                                   |
            -----------------------------------------
            | mult1                                 |
            -----------------------------------------
			. . .
            -----------------------------------------
            | multn                                 |
            -----------------------------------------
  (p-10)--->| <free>                                |
            -----------------------------------------
			. . .
            -----------------------------------------
   (p-8)--->| <free>                                |
            -----------------------------------------
   (p-7)--->| baseword                              |
            -----------------------------------------
   (p-6)--->| Descriptor word type code of array    |
            -----------------------------------------
   (p-5)--->| String name of array (char *) pointer |
            -----------------------------------------
   (p-4)--->| n (number of dimensions of array)     |
            -----------------------------------------
   (p-3)--->| totalSize (size of array data area)   |
            -----------------------------------------
   (p-2)--->| headerSize = (3*n + 10)               |
            -----------------------------------------
   (p-1)--->| pHeader (ptr to start of header)      |
            -----------------------------------------
       p--->| first word of data region             |
            -----------------------------------------
			. . .
            -----------------------------------------
 p+size-1-->| last word of data region              |
            -----------------------------------------

*/

/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/
/*	+    S T O R A G E   A L L O C A T I O N	+	*/
/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aAdr(ptr,n,a1,...,an) -  return array datum ptr 	*/
/*								*/
INTEGER PROCEDURE *aAdr(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{
	INTEGER	
		*baseWord,	/* base word pointer for array access */
		*datumPtr,	/* computed array datum pointer */
		i,		/* temp variable */
		index,		/* current index value from arg list */
		nActual,	/* number of args */
		nExpected,	/* expected number of args */
		*p,		/* ptr to data of dynamic array header*/
		*pHeader,	/* ptr to base of dynamic array header*/
		*pMult,		/* multiplier pointer */
		*ptr,		/* ptr to next formal arg */
		**t;		/* ptr to formal arg list ptr */

	t = &vPtr;		/* set up to point to list of ptrs */

	ptr = (INTEGER *)*t;	/* get the ptr to array data  */
	INC_ARG_PTR(t);		/* increment variable arg pointer */

	pHeader = (INTEGER *)*(ptr-1);
	nExpected = *(ptr-4);
	baseWord= (INTEGER *)*(ptr-7);

	nActual = **t;		/* get the actual # of args to array*/
	INC_ARG_PTR(t);		/* increment variable arg pointer */

	datumPtr = baseWord;

	pMult = (pHeader+ 2*nExpected);	    /* offset into header */
	for (i=1; i<=nActual; i++)
		{ /* compute final datum pointer */
		p = *t;		/* let p point to current arg */
		INC_ARG_PTR(t);	/* increment variable arg pointer */

		index = *p;	/* get i'th index value */
		datumPtr += index * (*(pMult++));  
				/* i.e. SUM arg(i)*mult(i) */
		} /* compute final datum pointer */
	return(datumPtr);
}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aAdrB(ptr,n,a1,...,an) - return array LISP_ATOM datum ptr */
/*								*/
LISP_ATOM PROCEDURE *aAdrB(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{
        INTEGER *ip;
     	LISP_ATOM *lispAtom;
	ip = aAdr(vPtr);
        lispAtom = (LISP_ATOM *)ip;
        return(lispAtom);
}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aAdrC(ptr,n,a1,...,an) - return array STRING datum ptr */
/*								*/
STRING PROCEDURE *aAdrC(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{
	INTEGER *ip;
	STRING s;
	ip = aAdr(vPtr);                /* get INTEGER * to entry */
        s = (STRING)((STRING *)ip);
/* 6-27-87 GC_SRETURN(s) - problem was returns (STRING) not (STRING *) */
	GC_UNMARKSSTKFRAME;
	GC_PUSHS(s);
	return((STRING *)gc_sRpdl[gc_sRtop]);
}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aAdrD(ptr,n,a1,...,an)- return array DOUBLE datum ptr */
/*								*/
double PROCEDURE *aAdrD(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{	return((double *)aAdr(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aAdrE(ptr,n,a1,...,an)- return array EVENT datum ptr */
/*								*/
EVENT PROCEDURE *aAdrE(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{	return((EVENT *)aAdr(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aAdrF(ptr,n,a1,...,an)- return array REAL datum ptr */
/*								*/
float PROCEDURE *aAdrF(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{	return((float *)aAdr(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aAdrI(ptr,n,a1,...,an)- return array INTEGER datum ptr */
/*								*/
INTEGER PROCEDURE *aAdrI(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{	return((INTEGER *)aAdr(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aAdrJ(ptr,n,a1,...,an)- return array OBJECT datum ptr */
/*								*/
OBJECT PROCEDURE *aAdrJ(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{	return((OBJECT *)aAdr(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aAdrK(ptr,n,a1,...,an)- return array LISP_SEXPR datum ptr */
/*								*/
LISP_SEXPR PROCEDURE *aAdrK(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{
	INTEGER *ip;
	LISP_SEXPR *lispSexpr;
	ip = aAdr(vPtr);
	lispSexpr = (LISP_SEXPR *)ip;
        return(lispSexpr);
}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aAdrL(ptr,n,a1,...,an)- return array LIST datum ptr */
/*								*/
LIST PROCEDURE *aAdrL(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{	return((LIST *)aAdr(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aAdrS(ptr,n,a1,...,an)- return array SET datum ptr */
/*								*/
SET PROCEDURE *aAdrS(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{	return((SET *)aAdr(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aAdrV(ptr,n,a1,...,an)- return array ITEMVAR datum ptr */
/*								*/
ITEMVAR PROCEDURE *aAdrV(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{	return((ITEMVAR *)aAdr(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aAdrX(ptr,n,a1,...,an)- return array ITEM datum ptr */
/*								*/
ITEM PROCEDURE *aAdrX(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{	return((ITEM *)aAdr(vPtr));}



/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aChk(typ,ptr,n,a1,...,an) - check arg type/bounds, return */
/*	ptr if ok, otherwise print error message and exit.	   */
/*								   */
INTEGER PROCEDURE *aChk(typeExpected, vPtr)
	char	typeExpected;		/* type of array expected */
	INTEGER *vPtr;			/* pointer to arg list*/
{
	/* code to be written */
	INTEGER 
		*baseWord,	/* base word pointer for array access */
		*datumPtr,	/* computed array datum pointer */
		i,		/* temp variable */
		index,		/* current index value from arg list */
		headerSize,	/* size of array header area*/
		lb,		/* lower bound*/
		nActual,	/* number of args */
		nExpected,	/* expected number of args */
		*p,		/* ptr to data of dynamic array header*/
		*pHeader,	/* ptr to base of dynamic array header*/
		*pMax,		/* temporary ptr maximum datum ptr */
		*pMult,		/* multiplier pointer */
		*ptr,		/* ptr to formal arg */
		totalSize,	/* total size of array data area*/
		typeAry,	/* type (PSAIL primary DW) of array */
		ub,		/* upper bound*/
		**t;		/* ptr to formal arg list ptr */
	STRING	pName,		/* Print name of array  */
		sType;		/* Print name of array type*/
	char	typeCode;	/* letter code data type */

	GC_MARKSSTKFRAME;	/* Mark string GC stack frame */
	GC_NOTESTRING(pName);	/* mark pName for G.C. */
	GC_NOTESTRING(sType);	/* mark sType for G.C. */

	t = &vPtr;		/* set up to point to list of ptrs */

	ptr = (INTEGER *)*t;	/* get the ptr to array data ptr  */
	INC_ARG_PTR(t);		/* increment variable arg pointer */

	pHeader = (INTEGER *)(*(ptr-1)); /* point to header base address*/
	headerSize = *(ptr-2);
	totalSize = *(ptr-3);
	nExpected = *(ptr-4);
	pName = (STRING) (*(ptr-5));   /* get print n         ame */
	typeAry = *(ptr-6);	       /* expe         cted DW type */
	baseWord= (INTEGER *)(*(ptr-7));

	typeCode = codMap[typeAry & 037];       /* primary unpacked code */
	pMax = ptr + totalSize-1;		/* max datum address */
	pMult = (pHeader+ 2*nExpected);		/* offset into header */

	if (typeExpected != typeCode)
		{ /* ERROR - type code mismatch */
		sType = sCVtype[typeAry];	/* look it up */
		PSprintf("Actual type (%s) is not that expected (%c)",
			  GC_PUSHS(sType), typeCode);
		PSprintf(" for array '%s\n",GC_PUSHS(pName));
		PEXIT;		/* take exit to system */
		} /* ERROR - type code mismatch */

	if (pHeader + headerSize != ptr)
		{ /* ERROR - Header DRYROT checksum */
		PSprintf("\nDRYROT aChk() header array is glomixed!\n");
		PEXIT;		/* take exit to system */
		} /* ERROR - Header DRYROT checksum */

	nActual = **t;		/* get the actual # of args to array*/
	INC_ARG_PTR(t);		/* increment variable arg pointer */

	if (nActual != nExpected)
		{ /* ERROR - wrong number of arguments */
		PSprintf("Actual # args %l for array '%s' ",
				nActual,GC_PUSHS(pName));
		PSprintf("do not match # %l expected\n",nExpected);
		PEXIT;		/* take exit to system */
		} /* ERROR - wrong number of arguments */

	datumPtr = baseWord;    /* start with array base address */

	for (i=1; i<=nActual; i++)
		{ /* compute datumPtr */
		p = *t;		/* let p point to current arg */
		index = *p;	/* get i'th index value */
		INC_ARG_PTR(t);	/* increment variable arg pointer */

		lb = *(pHeader++);		/* get the bounds */
		ub = *(pHeader++);
		if ((index < lb) || (index > ub))
			{ /* ERROR - bad index */
			PSprintf(
	"Arg no. %l with value %l for array [%s] is out of bounds\n",
				i, index, GC_PUSHS(pName));
			PSprintf("Expected range is [%l:%l]\n",
					lb, ub);
			PEXIT;		/* exit to system */
			} /* ERROR - bad index */

		datumPtr += index * (*(pMult++));
				/* i.e. SUM arg(i)*mult(i) */
		} /* compute datumPtr */


	if ((datumPtr < ptr) || (datumPtr > pMax))
		{ /* ERROR - datum ptr out of bounds */
		PSprintf(
	"[aChk()] DRYROT.  datumPtr=0%l legal range[0%l : 0%l]\n",
				datumPtr, ptr, pMax);
		PEXIT;		/* exit to system */
		} /* ERROR - datum ptr out of bounds */


	GC_NRETURN(datumPtr)
}

/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aChkB(ptr,n,a1,...,an) - chk arg bounds LISP_ATOM datum ptr */
/*								*/
LISP_ATOM PROCEDURE *aChkB(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{
	INTEGER *ip;
	LISP_ATOM *lispAtom;
	ip = aChk(CODEatomLisp,vPtr);
        lispAtom = (LISP_ATOM *)ip;
        return(lispAtom);
}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aChkC(ptr,n,a1,...,an) - chk arg bounds STRING datum ptr */
/*								*/
STRING PROCEDURE *aChkC(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{
	INTEGER *ip;
	STRING s;
	ip = aChk(CODEstring,vPtr);
	s = (STRING)((STRING *)ip);
/* 6-27-87   GC_SRETURN(s) - can't use since (STRING) not (STRING *) */
	GC_UNMARKSSTKFRAME;
	GC_PUSHS(s);
	return((STRING *)gc_sRpdl[gc_sRtop]);

}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aChkD(ptr,n,a1,...,an)- chk arg bounds DOUBLE datum ptr */
/*								*/
double PROCEDURE *aChkD(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{	return((double *)aChk(CODEdouble,vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aChkE(ptr,n,a1,...,an)- chk arg bounds EVENT datum ptr */
/*								*/
EVENT PROCEDURE *aChkE(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{	return((EVENT *)aChk(CODEevent,vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aChkF(ptr,n,a1,...,an)- chk arg bounds REAL datum ptr */
/*								*/
float PROCEDURE *aChkF(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{	return((float *)aChk(CODEreal,vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aChkI(ptr,n,a1,...,an)- chk arg bounds INTEGER datum ptr */
/*								*/
INTEGER PROCEDURE *aChkI(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{	return((INTEGER *)aChk(CODEinteger,vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aChkJ(ptr,n,a1,...,an)- chk arg bounds OBJECT datum ptr */
/*								*/
OBJECT PROCEDURE *aChkJ(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{	return((OBJECT *)aChk(CODEobject,vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aChkK(ptr,n,a1,...,an)- chk arg bounds LISP_SEXPR datum ptr */
/*								*/
LISP_SEXPR PROCEDURE *aChkK(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{
	INTEGER *ip;
	LISP_SEXPR *lispSexpr;
	ip = aChk(CODEsExprLisp,vPtr);
        lispSexpr = (LISP_SEXPR *)ip;
        return(lispSexpr);
}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aChkL(ptr,n,a1,...,an)- chk arg bounds LIST datum ptr */
/*								*/
LIST PROCEDURE *aChkL(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{	return((LIST *)aChk(CODElist,vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aChkS(ptr,n,a1,...,an)- chk arg bounds SET datum ptr */
/*								*/
SET PROCEDURE *aChkS(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{	return((SET *)aChk(CODEset,vPtr));}



/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aChkV(ptr,n,a1,...,an)- chk arg bounds ITEMVAR datum ptr */
/*								*/
ITEMVAR PROCEDURE *aChkV(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{	return((ITEMVAR *)aChk(CODEitemvar,vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aChkX(ptr,n,a1,...,an)- chk arg bounds ITEM datum ptr */
/*								*/
ITEM PROCEDURE *aChkX(vPtr)
	INTEGER *vPtr;			/* pointer to arg list*/
{	return((ITEM *)aChk(CODEitem,vPtr));}




/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	arrblt(dPtr,sPtr,cnt) - do SAIL ARRBLT			*/
/* Move 'cnt' INTEGER words from source sPtr to destination dPtr*/
/*								*/
void PROCEDURE arrblt(dPtr,sPtr,cnt)
	INTEGER *dPtr, *sPtr;
	INTEGER cnt;
{
	register INTEGER i, *dest, *src, nBytes;

	if (cnt<=0 || dPtr<=0 || sPtr<=0)
	        return;   /* FAILED! */
        nBytes = cnt * sizeof(INTEGER);

#ifdef HASMEMCPY	/* use efficient call to C library*/
	memcpy(dPtr,sPtr,nBytes);	/* BLIT nbytes */
	return;
#endif
#ifdef HASANSIC	/* use efficient call to C library*/
	memcpy((void *)dPtr,(void *)sPtr,(int)nBytes);	/* BLIT nbytes */
	return;
#endif

#ifndef HASMEMCPY
	dest = dPtr;
	src = sPtr;
	/* Copy top to bottom if it is an overlapping array. */
	if (dest >= src)
		for (i=0; i<nBytes; i++)
		     *(dest++) = *(src++);
	else for (i=nBytes; i<0; i--)
	             *(dest--) = *(src--);
	return;
#endif
}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	arrclr(dPtr,value) - do SAIL ARRCLR of dynamic array	*/
/*								*/
void PROCEDURE arrclr(dPtr,value)
	INTEGER *dPtr, value;
{
	register INTEGER cnt, i, *dest, cVal;

	cnt = arrinfo(dPtr,0L);	/* get total size of array */
	if (cnt<=0)
	        return;
	dest = dPtr;
	for (i=0, cVal=value; i<cnt; i++)
		*(dest++) = cVal;
	return;
}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	arrinfo(aPtr,param) - do SAIL ARRINFO			*/
/*	This is similar but not quite the same as SAILS since	*/
/*	the PSAIL array header is different than that of SAIL.  */
/*	Additional calls added with PSAIL which have negative	*/
/*	function codes.						*/
/*	If param==-5, then is string pointer to type of array	*/
/*	If param==-4, then is string pointer to name of array	*/
/*	If param==-3, then is type DECLARATION WORD index	*/
/*	If param==-2, then is DECLARATION Primary type code	*/
/*	If param==-1, then is # dimensions and is < 0 for strings */
/*	If param==0, then is total size of array in words */
/*	If param==1, then is LOWER bound for 1st dimension	 */
/*	If param==2, then is UPPER bound for 1st dimension	 */
/*	If param==3, then is LOWER bound for 2nd dimension	 */
/*	If param==4, then is UPPER bound for 2nd dimension	 */
/*		. . . E T C. . .				*/
/*      Note: we pass all array pointers as (INTEGER *) since   */
/*      that is how the array header is stored.                 */
/*								*/
INTEGER PROCEDURE arrinfo(aPtr,param)
	INTEGER *aPtr, param;
{
	int n;
	INTEGER value;
	INTEGER *headerPtr;

	if (aPtr==0 || param < -5)
		 return(0L);   /* must be legal array header ptr & param */

	if (param == -5) 
		value = (INTEGER)sCVtype[*(aPtr-6) & 037];   
				/* string ptr to type */

	else if (param == -4) 
		value = *(aPtr-5);   	/* string ptr to name*/

	else if (param == -3) 
		value = *(aPtr-6);   	/* TYPE DW index */

	else if (param == -2) 
		value = codMap[*(aPtr-6) & 037]; /* TYPE CODE*/

	else if (param == -1) 
		{value = *(aPtr-4);   /* # dimensions */
		if (codMap[*(aPtr-6) & 037] == CODEstring) 
		   value = -value; /* STRINGS are < 0 for SAIL compatibility */
		}

	else if (param == 0)
		value = *(aPtr-3);   	/* total size*/

	else	{ /* get the lower or upper bound, make sure it is ok
		  * and that the target array has space */
		headerPtr = (INTEGER *)*(aPtr-1);  /* get header 
						    * base address 
						   */
		n = *(aPtr-4);		/* # dimensions */
		if (param > 2*n) 
			value = 0; 	/* bullshit parameter */
		else value = *(headerPtr + (param-1));
		}
	return(value);
}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	arrtran(dPtr,sPtr) - do SAIL ARRTRAN of dynamic array	*/
/*								*/
void PROCEDURE arrtran(dPtr,sPtr)
	INTEGER *dPtr, *sPtr;
{
	INTEGER cnt, cntS, cntD;

	cntS = arrinfo(sPtr,0L);	/* size of array */
	cntD = arrinfo(dPtr,0L);	/* size of array */
	cnt = (cntS > cntD) ? cntD : cntS;  /* take minimum size */
	if (cnt<=0 || dPtr<=0 || sPtr<=0 || dPtr==sPtr) 
		return;   /* FAILED */
	arrblt(dPtr,sPtr,cnt);
	return;
}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	aryel(ptr) - release dynamic array ptr      		*/
/*								*/
INTEGER PROCEDURE aryel(p)
	INTEGER *p;	/* pointer to base data of array*/
{
	STRING pHeader;  /* pointer to header of dynamic array */
	STRING pName;	 /* pointer to print name */

	pHeader = (STRING)(*(p-1));	/* array header base address */
	pName = (STRING)(*(p-5));	/* print name */

	Pfree(pName);
	Pfree(pHeader);
}



/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	aryfree(ptr) - release LIST of dynamic array ptrs     	*/
/*	The list contains dynamic array pointers to arrays 	*/
/*	created with arymk().					*/
/*	The last element of the list is a 0.			*/
/* NOTE: 9-6-87 should change arg passing to use PS_VA... macros*/
/*								*/
INTEGER PROCEDURE aryfree(ptr)
	INTEGER *ptr;	/* pointer to base data of array*/
{
	INTEGER **t;	    /* pointer to LIST of pointers */
	INTEGER *p;  	   /* pointer to next array array */

	t = &ptr;	/* set up to point to LIST of ptrs */

	while ((p = *t) != 0)
		{
		aryel(p);	/* free this array */
		INC_ARG_PTR(t);	/* increment variable arg pointer */
		}
}



/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	aryHdr(&P_id,n,l1,u1,l2,u2,...,un,pName,type) - create   */
/*	array ptr header in EXISTING static array created by the */
/*	C compiler previously. Return the dynamic pointer to this */
/*	array which points to the start of the data region rather */
/*	than to the start of the array. We use the old front of   */
/*	the array to hold the dynamic header. NOTE: we NEVER      */
/*	NEVER Pfree() this array - only the whole thing!	  */
/* NOTE: 9-6-87 should change arg passing to use PS_VA... macros*/
/*								*/
INTEGER PROCEDURE *aryHdr(ptr)
	INTEGER **ptr;	/* pointer to variable arg list */
{
        INTEGER *baseWord,	/* baseWord for later addr calc */
		headerSize,	/* size of array header area */
		i,		/* temporary variable */
		lb,		/* current lower bound arg */
		n,		/* number of bounds */
		mult,	        /* array offset used for later retrieval*/
		*p,		/* ptr to data of dynamic array header*/
		*pB,		/* temp bounds value pointer */
		*pHeader,	/* ptr to base of dynamic array header*/
		*ptmp,		/* temporary ptr used here */
		totalSize,	/* total size of array data area */
		typeAry,	/* array DW type */
		typeCode,	/* typeCode of array */
		ub,		/* current upper bound arg */
		**t;		/* ptr to list ptr */
	STRING	pName,		/* Print name of array  */
		sTmp1,		/* temp string variable */
		sTmp2;		/* temp string variable */

	t = ptr;		/* set up to point to list of ptrs */

	pHeader = *t;	/* get the address of the static array */
	INC_ARG_PTR(t);		/* increment variable arg pointer */

	if (pHeader=0) 
		{PSprintf("[aryHdr()] Illegal base address=%l!\n",
				pHeader);
		PEXIT;		/* return to system */
		}
	totalSize=1;		/* default array data area size */
	n = **t;		/* get the number of args */
	INC_ARG_PTR(t);		/* increment variable arg pointer */

	if (n<1 || n>20) 
		{ /* ERROR - illegal # subscripts */
		PSprintf("# subscripts %l is illegal [1:20] allowed!\n",
				n);
		PEXIT;		/* return to system */
		} /* ERROR - illegal # subscripts */

	pB = pHeader;		/* pB points to lower bound 1 */
				/* NOTE: t pnt to cur. arg*/
	for (i=1; i<=n; i++)
		{ /*copy the bounds into local arrays */
		lb = *(pB++) = **t;
		INC_ARG_PTR(t);	/* increment variable arg pointer */

		ub = *(pB++) = **t;
		INC_ARG_PTR(t);	/* increment variable arg pointer */

		totalSize *= (ub-lb+1);  /* i.e. (ub[i]-lb[i]+1) */
		} /*copy the bounds into local arrays */

	pName = (STRING)**t;
	INC_ARG_PTR(t);		/* increment variable arg pointer */

	sTmp1 = GC_EPOPS(pName);  /* pop string variable pdl */
	sTmp2 = pName = Pmalloc(length(GC_PUSHS(sTmp1))+1);
	while (*(sTmp2++) = *(sTmp1)++);  /* copy to pName */

	typeCode = **t;
	INC_ARG_PTR(t);		/* increment variable arg pointer */

	for (typeAry=31; typeAry>0; typeAry--)
		if (typeCode == codMap[typeAry]) break;  /*match*/

	headerSize=3*n + EXTRAHEADERFIELDS;

	p = pHeader + headerSize;

	/* Now, stuff the header */
	*(p-1) = (INTEGER)pHeader;
	*(p-2) = headerSize;
	*(p-3) = totalSize;
	*(p-4) = n;
	*(p-5) = (INTEGER)pName;
	*(p-6) = typeAry;

	baseWord = (INTEGER *)(*(p-0));	/* compute the baseword */
	mult = 1;		/* compute and store the multipliers */
	pB = (pHeader + n + n);
	ptmp = (pB + n);
	for(i=n; i<=1; i--)
		{ /* compute and store the mult[i] */
		*(ptmp--) = mult;
		ub = *(--pB);
		lb = *(--pB);
		mult *= (ub-lb+1);  /* compute: (ub[n+1]-lb[n+1]+1) */
		baseWord += mult;
		} /* compute and store the mult[i] */

	*(p-7)=(INTEGER)baseWord;	/* baseWord calculated as specified in 
				 * SAIL manual [ReisJ76] page 158].
				*/

	for(ptmp=p,i=1; i<=totalSize; i++)
		*(ptmp++) = 0; 	/*ZERO ARRAY*/
	
	GC_NRETURN(p)
}



/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aryHdrB(<aryHdr-argList>) - creat static array hdr LISP_ATOM*/
/*								*/
LISP_ATOM PROCEDURE *aryHdrB(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{
	INTEGER *ip;
	LISP_ATOM *lispAtom;
	ip = aryHdr(vPtr);
	lispAtom = (LISP_ATOM *)ip;
	return(lispAtom);
}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aryHdrC(<aryHdr-argList>) - creat static array hdr STRING*/
/*								*/
STRING PROCEDURE *aryHdrC(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{
	INTEGER *ip;
	STRING s;
	ip = aryHdr(vPtr);
	s = (STRING)((STRING *)ip);
/* 6-27-87 GC_SRETURN(s) - can't use since (STRING) not (STRING *) */
	GC_UNMARKSSTKFRAME;
	GC_PUSHS(s);
	return((STRING *)gc_sRpdl[gc_sRtop]);
}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aryHdrD(<aryHdr-argList>) - creat static array hdr DOUBLE*/
/*								*/
double PROCEDURE *aryHdrD(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{	return((double *)aryHdr(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aryHdrE(<aryHdr-argList>) - creat static array hdr EVENT*/
/*								*/
EVENT PROCEDURE *aryHdrE(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{	return((EVENT *)aryHdr(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aryHdrF(<aryHdr-argList>) - creat static array hdr REAL*/
/*								*/
float PROCEDURE *aryHdrF(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{	return((float *)aryHdr(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aryHdrI(<aryHdr-argList>) - creat static array hdr INTEGER*/
/*								*/
INTEGER PROCEDURE *aryHdrI(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{	return((INTEGER *)aryHdr(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aryHdrJ(<aryHdr-argList>) - creat static array hdr OBJECT*/
/*								*/
OBJECT PROCEDURE *aryHdrJ(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{	return((OBJECT *)aryHdr(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aryHdrK(<aryHdr-argList>) - creat static array hdr LISP_SEXPR*/
/*								*/
LISP_SEXPR PROCEDURE *aryHdrK(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{
	INTEGER *ip;
	LISP_SEXPR *lispSexpr;
	ip = aryHdr(vPtr);
        lispSexpr = (LISP_SEXPR *)ip;
        return(lispSexpr);
}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aryHdrL(<aryHdr-argList>) - creat static array hdr LIST*/
/*								*/
LIST PROCEDURE *aryHdrL(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{	return((LIST *)aryHdr(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aryHdrS(<aryHdr-argList>) - creat static array hdr SET*/
/*								*/
SET PROCEDURE *aryHdrS(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{	return((SET *)aryHdr(vPtr));}



/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aryHdrV(<aryHdr-argList>) - creat static array hdr ITEMVAR*/
/*								*/
ITEMVAR PROCEDURE *aryHdrV(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{	return((ITEMVAR *)aryHdr(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*aryHdrX(<aryHdr-argList>) - creat static array hdr ITEM*/
/*								*/
ITEM PROCEDURE *aryHdrX(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{	return((ITEM *)aryHdr(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	arymk(n,l1,u1,l2,u2,...,un,pName,type) - make dynamic  */
/*	array ptr getting storage using Pmalloc(). Return the 	*/
/*	pointer for this array.					*/
/* NOTE: 9-6-87 should change arg passing to use PS_VA... macros*/
/*								*/
INTEGER PROCEDURE *arymk(ptr)
	INTEGER **ptr;	/* pointer to variable arg list */
{
	INTEGER *baseWord,	/* baseWord ptr for later addr calc */
		headerSize,	/* size of array header area */
		i,		/* temp variable */
		lb,		/* current lower bound arg */
		mult,	        /* offset arrry used for later retrieval*/
		n,		/* number of bounds */
        	nBytes,         /* # bytes fo Pmalloc() */
		*p,		/* ptr to data of dynamic array header*/
		*pB,		/* temp bounds value pointer */
		*pHeader,	/* ptr to base of dynamic array header*/
		*ptmp,		/* temporary ptr used here */
		totalSize,	/* total size of array data area*/
		typeAry,	/* array DW type */
		typeCode,	/* primary type Code of array */
		ub;		/* current upper bound arg */
	STRING	pName,		/* Print name of array  */
		sTmp1,		/* temp string variable */
		sTmp2;		/* temp string variable */
	INTEGER **t;		/* ptr to arg list ptr */

	t = ptr;		/* set up to point to list of ptrs */

	totalSize=1;		/* default array data area size */
	n = **t;		/* get the number of args */
	INC_ARG_PTR(t);		/* increment variable arg pointer */

	if (n<1 || n>20) 
		{ /* ERROR - illegal # args */
		PSprintf("# subscripts %l is illegal [1:20] allowed!\n",
				n);
		PEXIT;		/* return to system */
		} /* ERROR - illegal # args */


	pName = (STRING)**t;
	INC_ARG_PTR(t);		/* increment variable arg pointer */

	sTmp1 = GC_EPOPS(pName);  /* pop string variable pdl */
	sTmp2 = pName = Pmalloc(length(GC_PUSHS(sTmp1))+1);
	while (*(sTmp2++) = *(sTmp1)++);  /* copy to pName */

	typeCode = **t;
	INC_ARG_PTR(t);		/* increment variable arg pointer */


	for(typeAry=31; typeAry>=0; typeAry--)
		if (typeCode == codMap[typeAry]) break;  /*match*/

	headerSize=3*n + EXTRAHEADERFIELDS;

	nBytes = (headerSize + totalSize) * sizeof(INTEGER);
	pHeader =(INTEGER *)Pmalloc(nBytes);	/* get ptr to storage*/

	pB = pHeader;		/* pB points to lower bound 1 */
				/* NOTE: t pnt to cur. arg*/
	for (i=1; i<=n; i++)
		{ /* copy the bounds into local arrays */
		lb = *(pB++) = **t;
		INC_ARG_PTR(t);	/* increment variable arg pointer */

		ub = *(pB++) = **t;
		INC_ARG_PTR(t);	/* increment variable arg pointer */

		totalSize *= (ub-lb+1);  /* i.e. (ub[i]-lb[i]+1) */
		} /* copy the bounds into local arrays */

	p = pHeader + headerSize;     /* point to start of data area */

	/* Now stuff the header */
	*(p-1) = (INTEGER)pHeader;
	*(p-2) = headerSize;
	*(p-3) = totalSize;
	*(p-4) = n;
	*(p-5) = (INTEGER)pName;
	*(p-6) = typeAry;

	baseWord = (INTEGER *)(*(p-0));	/* compute the baseword */
	mult = 1;		/* compute and store the multipliers */
	pB = (pHeader + n + n);
	ptmp = (pB + n);
	for(i=n; i<=1; i--)
		{ /* compute and store the mult[i] */
		*(ptmp--) = mult;
		ub = *(--pB);
		lb = *(--pB);
		mult *= (ub-lb+1);  /* compute: (ub[n+1]-lb[n+1]+1) */
		baseWord += mult;
		} /* compute and store the mult[i] */

	*(p-7)=(INTEGER)baseWord; /* baseWord calculated as specified in 
				 * SAIL manual [ReisJ76] page 158].
				*/

	for (ptmp=p,i=1; i<=totalSize; i++)
		*(ptmp++) = 0;  	/*ZERO ARRAY*/
	
	return(p);
}



/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*arymkB(<arymk-argList>) - creat static array hdr LISP_ATOM*/
/*								*/
LISP_ATOM PROCEDURE *arymkB(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{
	INTEGER *ip;
	LISP_ATOM *lispAtom;
	ip = arymk(vPtr);
        lispAtom = (LISP_ATOM *)ip;
        return(lispAtom);
}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*arymkC(<arymk-argList>) - creat static array hdr STRING*/
/*								*/
STRING PROCEDURE *arymkC(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{
	INTEGER *ip;
	STRING s;
	ip = arymk(vPtr);
	s = (STRING)((STRING *)ip);
/* 6-27-87  GC_SRETURN(s) - can't use since (STRING) not (STRING *) */
	GC_UNMARKSSTKFRAME;
	GC_PUSHS(s);
	return((STRING *)gc_sRpdl[gc_sRtop]);
}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*arymkD(<arymk-argList>) - creat static array hdr DOUBLE*/
/*								*/
double PROCEDURE *arymkD(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{	return((double *)arymk(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*arymkE(<arymk-argList>) - creat static array hdr EVENT*/
/*								*/
EVENT PROCEDURE *arymkE(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{	return((EVENT *)arymk(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*arymkF(<arymk-argList>) - creat static array hdr REAL*/
/*								*/
float PROCEDURE *arymkF(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{	return((float *)arymk(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*arymkI(<arymk-argList>) - creat static array hdr INTEGER*/
/*								*/
INTEGER PROCEDURE *arymkI(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{	return((INTEGER *)arymk(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*arymkJ(<arymk-argList>) - creat static array hdr OBJECT*/
/*								*/
OBJECT PROCEDURE *arymkJ(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{	return((OBJECT *)arymk(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*arymkK(<arymk-argList>) - creat static array hdr LISP_SEXPR*/
/*								*/
LISP_SEXPR PROCEDURE *arymkK(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{
	INTEGER *ip;
	LISP_SEXPR *lispSexpr;
	ip = arymk(vPtr);
        lispSexpr = (LISP_SEXPR *)ip;
	return(lispSexpr);
}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*arymkL(<arymk-argList>) - creat static array hdr LIST*/
/*								*/
LIST PROCEDURE *arymkL(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{	return((LIST *)arymk(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*arymkS(<arymk-argList>) - creat static array hdr SET*/
/*								*/
SET PROCEDURE *arymkS(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{	return((SET *)arymk(vPtr));}



/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*arymkV(<arymk-argList>) - creat static array hdr ITEMVAR*/
/*								*/
ITEMVAR PROCEDURE *arymkV(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{	return((ITEMVAR *)arymk(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	*arymkX(<arymk-argList>) - creat static array hdr ITEM*/
/*								*/
ITEM PROCEDURE *arymkX(vPtr)
	INTEGER **vPtr;			/* pointer to arg list*/
{	return((ITEM *)arymk(vPtr));}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Carrclr(dPtr,value,cnt) - do C ARRCLR			*/
/*								*/
void PROCEDURE Carrclr(dPtr,value,cnt)
	INTEGER *dPtr, value;
	INTEGER cnt;
{
	register INTEGER i, *dest, cVal;

	if (cnt<=0)
	        return;
	dest = dPtr;
	for (i=0, cVal=value; i<cnt; i++)
		*(dest++) = cVal;
	return;
}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Carrtran(dPtr,sPtr,cnt) - do C ARRTRAN			*/
/*								*/
void PROCEDURE Carrtran(dPtr,sPtr,cnt)
	INTEGER *dPtr, *sPtr;
	INTEGER cnt;
{
	register INTEGER i, *dest, *src;

	if (cnt<=0) return;
	dest = dPtr;   src = sPtr;
	for (i=0; i<cnt; i++)
		*(dest++) = *(src++);
	return;
}



/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	chkversion(ptr list) - check module version		*/
/*	numbers consistency. The list consists of STRING	*/
/*	list of string pointers which are INTERNAL declarations	*/
/*	declared as string constants in the separate modules.	*/
/*	Each string is of the form:				*/
/*			ABCD.SAI@45.152				*/
/*	Where the first part to the left of the '@' is the	*/
/*	file in which the version number is declared. The	*/
/*	number to the right of the '@' is the version number	*/
/*	NOTE: it is assumed that the version numbers are string	*/
/*	constants and so we don't bother with the string	*/
/*	temporary variable PDL.					*/
/*								*/
void PROCEDURE chkversion(ptr)
	STRING ptr;
{
	int n;
	char ch;
	STRING *t;		/* ptr to list ptr */
	STRING p, q;
	char name[40], vnbr[40], firstVersion[40];

	t = &ptr;		/* set up to point to list  of ptrs */
	*firstVersion = '\0';

	n = 0;
	while ((p = *t) != '\0')    /* let p point to current arg */
		{
		INC_ARG_PTR(t);	/* increment variable arg pointer */

		n++;		/* count entries */

		q = &name[0];	/* copy name of entry into name[] */
		*q = '\0';
		while ((ch = *(p++))!='@')
			{*(q++) = ch;
			*q = '\0';
			};

		q = &vnbr[0];	/* copy version # into vnbr[] */
		*q = '\0';
		while ((ch = *(p++))!='\0')
			{*(q++) = ch;
			*q = '\0';
			};

		if (n==1)
			{ /* copy it into firstVersion */
			p = &vnbr[0]; q = &firstVersion[0];
			while (*(q++) = *(p++));
			}
		else if (! equ(GC_PUSHS(vnbr),GC_PUSHS(firstVersion)))
			   { /* ERROR -- version conflict */
			   PSprintf("VERSION CONFLICT! %s with %s\n",
						GC_PUSHS(firstVersion),
						GC_PUSHS(q));
			   PEXIT; 	/* take exit to system */
			   } /* ERROR -- version conflict */
		}
	return;
}



/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	del_record(recPtr) - return a cunk of memory to the heap */
/*	which was a record pointed to by a recor pointer. In	  */
/*	the future we could also worry about STRING members but	  */
/*	this involves a lot more stuff like deallocating dynamic  */
/*	structures in the record necessitating keeping the record */
/*	class infor around at runtime. So Not-Implemented for now. */
/*                                                                */
void PROCEDURE del_record(recPtr)
	INTEGER *recPtr; /* pointer to  RECORD i.e. struct */
{
	Pfree((STRING)recPtr);
}



/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	new_record(nBytes,clasNam) - get a chunk of memory from heap */
/*	for a record and return the record pointer.		  */
/*                                                                */
INTEGER PROCEDURE *new_record(nBytes,clasNam)
	INTEGER nBytes; /* number of bytes in RECORD i.e. struct */
	STRING clasNam;	/* string name of RECORD!CLASS */
{
	INTEGER lthName;
	STRING p;
	GC_POPS(clasNam);	/* from GC temp string PDL */

	lthName = length(GC_PUSHS(clasNam));

	p = Pmalloc(nBytes + lthName + 2);

	p = (p+nBytes+1);
	while (*p++ = *clasNam++) ; 	/* copy name at end */

	return((INTEGER *)p);
}



/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Phash(s,t,m) - lookup/enter string s in table t of size m */
/*                                                                */
INTEGER PROCEDURE Phash(s,t,m)
	STRING s;   /* string to hash and enter in table if not found */
	STRING t[]; /* string array hash table */
	INTEGER m; /* size of table t[]. m MUST BE A PRIME # */
{
/*	Lookup existing hash entry pointer in the range (1 to m-1) for
*	STRING  's' if exists else enter s into the table and return
*	the new value. If the table is full return 0..
*/

	INTEGER h0, h, ch, lastHfree, lastHcnt;
	STRING sCopy, s1;

	GC_POPS(s);
	GC_POPAS(t);
	GC_MARKSSTKFRAME;
	GC_NOTESTRING(s);
	GC_NOTEASTRING(t);
	GC_NOTESTRING(sCopy);
	GC_NOTESTRING(s1);

	lastHfree = lastHcnt = h0 = 0;
	if (*s=='\0') GC_NRETURN(0L)
	sCopy = s;	/* Make copy of 'STRING ' to eat up */
	while (*sCopy != '\0') 
		{ /* build hash number */
		ch = *(sCopy++);	/* get next character */
		ch=cvupper(ch);   /* only use UPPER case */
		h0 += ch;
		} /* build hash number*/

	h0 = (h0 % m);	/* compute next value module prime # */
	h = h0 = ((h0 > 0) ? h0 : 1);	/* Never start at zero! */

	while ((h != 0) && (lastHcnt < m)) 
		{ /*Hash it*/
		lastHfree = h;	/* may be used later to add s to t[] */
		s1 = t[h];	/* copy entry to h'th entry of table */
		if ((*sCopy==*s1) && equ(GC_PUSHS(sCopy),GC_PUSHS(s1))) 
			break; 	/* found it */
		lastHcnt++;	/* in case table full! */
		h = ((h+h0) % m); /* compute next hash probe */
		if (*s1=='\0') h=0; /* does not exist for
				     * RETRIEVAL only */
		} /* Hash it */;

	if (lastHcnt==m)
		usererr(0L,0L, catlist(4L,
				  GC_PUSHS("DRYROT!! Phash()("),
				  GC_PUSHS(s), 
			   GC_PUSHS(")] table overflow failure. lastHcnt="),
				   cvs(lastHcnt)));

	if (lastHfree==0 && lastHcnt<m)
		usererr(0L,0L,catlist(9L,
			GC_PUSHS("[Phash()] DRYROT! Phash()("),
			GC_PUSHS(s),
			GC_PUSHS(")]=0 with table NOT full!\n"),
			GC_PUSHS(" lastHcnt="),
			cvs(lastHcnt),
			GC_PUSHS(" lastHfree="),
			cvs(lastHfree),
			GC_PUSHS(" h="), cvs(h)));
	if (! ((0 < h) || (h < m)))
		{ /* symbol not found, enter it */
		h=lastHfree;
		s1 = t[h] = salloc(length(GC_PUSHS(s)));
		while ((*s1++ = *s++) != '\0') ;  /* copy string to 
						   * hash table */
		} /* symbol not found, enter it */

	GC_NRETURN(h)
}


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Allocate a string of nByte size from GC string space. */
/*	Return char pointer to n chars (using STACK	*/
/*	allocation mechanism)				*/
/*
*	The string space consists of a set of blocks of storage
*	acquired from Pmalloc(). Each is pointed to by a node
*	in a linked list pointed to by strAvail. If there
*	is not enough storage in any of the lists to satisfy a 
*	block of size n, garbage collect and try again. If there 
*	is still not enough memory, then call Pmalloc() for another 
*	block of at least n large and add this block to the 'strAvail'
*	linked list.
*
*	Each node of the strAvail list is a struct called SNODE
*
*	Argument n is the number of character bytes require.
* @V.52.120 Make sure that we are working with BYTES not WORDS...
*/
/*							*/
STRING PROCEDURE salloc(n)
	INTEGER n;
{ /* SALLOC */
	snode_t *cp;	/* Current SNODE pointer */
	INTEGER i, nBytes;
#ifdef HASNOGC
	return(Pmalloc(n+1));
#endif

#ifndef HASNOGC
	if (n > gc_allocsize)	/* only need it getting new SNODE */
		{ /* only need it getting new SNODE */
		i = (n / gc_allocsize) + 1;
		if ((i * gc_allocsize - n) < gc_saftyfactor) i++;
		nBytes = i * gc_allocsize;
		} /* only need it getting new SNODE */

	else if ((gc_allocsize - n) < gc_saftyfactor) 
		{ /* we fell below the saftyfactor - get new node */
		nBytes = 2 * gc_allocsize;
		} /* we fell below the saftyfactor - get new node */

	else nBytes = gc_allocsize;	/* standard allocation */

	if (*strAvail->next==0)
		{ /* Do initial allocation! */
		strAvail = (snode_t *)Pmalloc(sizeof(snode_t));
		cp = lastStrAvail = strAvail;
		cp->nextSnode = 0;   /* end of linked list of SNODES */
		cp->bot = Pmalloc(nBytes);
		cp->next = cp->bot;
		cp->top = cp->bot + n-1;
		} /* Do initial allocation! */

	else 	{ /* do standard allocation */
			/*
			* If strAvail is not NULL, then it check
                        * lastStrAvail->nextStr SNODE for space. If
                        * there is not enough space, keep
                        * checking'nextStr' SNODES. If there is still
                        * not enough space, then call the garbage
                        * collector str_GC. Then try the whole process
                        * again. If there is still not enough space,
                        * then set up a new SNODE in the strAvail list
                        * chain with corresponding core space. If this
                        * fails because Pmalloc() can not give you any
                        * more core, then GIVE UP ....
			*/
		cp = lastStrAvail;	/* set up SNODE ptr */
		} /* do standard allocation */

	if (cp->next + n <= cp->top - gc_saftyfactor)
		{ /* needed string fits */
		doingGC=FALSE;
		cp->next = cp->next + n;
		return(cp->next-n); /*old ptr */
		} /* needed string fits */

	else 	{ /* need to call G.C. - see you later (much-later) */
		if (doingGC)
			{ /* ERROR - real trouble */
			usererr(0L,0L,GC_PUSHS(
"Even after Garbage Collection there is not enough string space!\n"));
			return(PNULL);
			} /* ERROR - real trouble */
		doingGC=TRUE;
/* @V.53.93	for(cp=strAvail; cp!=0; cp=cp->nextSnode)
 *			str_GC(cp);
*/
			str_GC(); /* Go call the Garbage Collector! */
		return(salloc(n));	/* recursive call! */
		} /* need to call G.C. - see you later (much-later) */
#endif     /* end of ! HASNOGC */
} /* SALLOC */



/* # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # */

/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*								*/
/*	*Pmalloc(nbytes) general purpose storage allocator	*/
/*	Derived from K&R alloc() page 175.			*/
/* @V.52.119 NOTE: this allocator uses a ring buffer and should */
/* be rewritten to used the buddy system, binary search or a 	*/
/* bit map for speedup.						*/
/*								*/
STRING PROCEDURE Pmalloc(nbytes)
	INTEGER nbytes;
{ /* PMALLOC */
	HEADER *PSmorecore();	/* procedure to get more O.S. core */
	register HEADER *p, *q;
	register INTEGER nunits, v;

#ifdef HASCALLOC
	return((STRING)calloc((unsigned)nbytes,
			      (unsigned)sizeof(unsigned char)));
#define hasALLOC 1
#endif

#ifdef HASMALLOC
	return((STRING)malloc((unsigned)nbytes));
#define hasALLOC 1
#endif

#ifdef HASALCORE
	return((STRING)alcore((nbytes/4)+1));
#define hasALLOC 1
#endif

#ifndef hasALLOC   /* this is used if we need to do our own allocation */
	nunits = 1+(nbytes+sizeof(HEADER)-1)/sizeof(HEADER);
	if ((q=allocp) == 0)
		{ /* no free list yet */
		base.s.ptr = allocp = q = &base;  /* i.e. empty list */
		base.s.size = 0;
		} /* no free list yet */

	for (p=q->s.ptr; ; q=p, p=p->s.ptr)
		{
		if (p->s.size >= nunits)
			{ /* big enough */
			if (p->s.size == nunits)
				q->s.ptr = p->s.ptr;  /* exactly */
			else	{ /* allocate tail end */
				p->s.size -= nunits;
			       v = p->s.size;
				p += v;
					 /* added 'v' since some C
					  * compiles barf on doing this
					  * type of arithmetic !!! */
				p->s.size = nunits;
				} /* allocate tail end */
			allocp = q;
			return((STRING)(p+1));
			} /* big enough */

		if (p == allocp) /* wrapped around free list */
			if ((p = PSmorecore(nunits)) == 0)
				return((STRING)0);	/* none left */
		}
#endif     /* end of ! hasALLOC */

#ifdef hasALLOC
#undef hasALLOC
#endif
} /* PSMALLOC */


/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
/*								*/
/*	*PSmorecore(nu) - obtain storage from operating system	*/
/*	Derived from K&R PSmorecore() page 176.			*/
/*								*/
static HEADER PROCEDURE *PSmorecore(nu)  /* ask system for memory */
	INTEGER nu;
{ /* PSMORECORE */
	register STRING cp;
	register HEADER *up;
	register INTEGER rnu;

	rnu = NALLOC * ((nu+NALLOC-1) / NALLOC);
#ifdef HASSBRK
	cp = sbrk(rnu * sizeof(HEADER));
#endif
#ifdef HASACORE
	cp = acore(rnu * sizeof(HEADER));
#endif
#ifdef HASANSIC
	cp = (STRING)malloc((INTEGER)rnu * sizeof(HEADER));
#endif
#ifdef HASMALLOC
	cp = (STRING)malloc(rnu * sizeof(HEADER));
#endif
#ifdef HASCALLOC

	cp = (STRING)calloc((unsigned)(rnu * sizeof(HEADER)),
		    (unsigned)sizeof(char));
#endif
	if ((INTEGER)cp == -1) /* no space at all!!! */
		return((HEADER *)0);
	up = (HEADER *) cp;
	up->s.size = rnu;
	Pfree((STRING)(up+1));
	return(allocp);
} /* PSMORECORE */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*								*/
/*	Pfree(ap) - return char block 'ap' to free store list	*/
/*	previously allocated with Pmalloc().			*/
/*	Derived from K&R free() page 177.			*/
/*								*/
void PROCEDURE Pfree(ap)	/* put block ap in free list */
	STRING ap;
{
#ifdef HASANSIC
	void free();
#define hasALLOC 1
#endif

#ifdef HASCFREE
	int cfree();
#define hasALLOC 1
#endif

#ifdef HASMALLOC
	int free();
#define hasALLOC 1
#endif

	register HEADER *p, *q;
	INTEGER v;

	GC_POPS(ap);	/* get arg from string var. PDL */

#ifdef HASANSIC
	free((void *)ap);
#define hasALLOC 1
#endif

#ifdef HASCFREE
	cfree(ap);
#define hasALLOC 1
#endif

#ifdef HASMALLOC
	free(ap);
#define hasALLOC 1
#endif

#ifndef hasALLOC        /* we need to deallocate it ourselves */
	p = (HEADER *)ap -1; 	/* point to header */
	for (q=allocp; !(p > q && p < q->s.ptr); q=q->s.ptr)
		if (q >= q->s.ptr && (p>q || p<q->s.ptr))
			break; /* at one end or other */

	if (p+(v=p->s.size) == q->s.ptr) 
				/* added 'v' since some C compilers 
				 * barf on this construction */
		{ /* join to upper nbr */
		p->s.size += q->s.ptr->s.size;
		p->s.ptr = q->s.ptr->s.ptr;
		} /* join to upper nbr */
	else p->s.ptr = q->s.ptr;

	if (q+(v=q->s.size) == p) 
		{ /* join to lower nbr */ 
		q->s.size += p->s.size;
		q->s.ptr = p->s.ptr;
		} /* join to lower nbr */
	else	q->s.ptr = p;

	allocp = q;
#endif          /* end of ! hasALLOC */

#ifdef hasALLOC
#undef hasALLOC
#endif
}
/* ---> END OF PSRUN1.C <--- */
