/* 	File: PSRUN7.C 						*/
/*								*/
/*	SAIL RUNTIME  I/O PROCEDURES				*/
/*								*/
/*								*/
/*	P. Lemkin						*/
/*	Image Processing Section				*/
/*	National Cancer Institute, DCBD, LTB			*/
/*	FCRF, Build 469 Room 150B				*/
/*	Frederick, MD 21701					*/
/*
*    COPYRIGHT NOTICE - Copyright (c) 1983-1987 by Peter F. Lemkin.
*                     All rights reserved.
*       Permission is granted to any individual or institution to
*       copy, use or modify this program, except for explicitly
*       commercial purposes, provided this copyright notice is
*       included in its entirety in all derived works.  No warranty
*       of the software or of the accuracy of any documentation
*       surrounding it is expressed or implied, and the author does
*       not acknowledge any liability resulting from program or
*       documentation errors.
*/
/*								*/
/*	Version: 57.10 						*/
/*								*/
/*      Revised December 1, 1987                                */
/*      Revised October 10, 1987                                */
/*      Revised October 4, 1987                                 */
/*      Revised September 7, 1987                               */
/*      Revised August 12, 1987                                 */
/*      Revised July 23, 1987                                   */
/*	Revised July 1, 1987 					*/
/*	Revised June 30, 1987 					*/
/*	Revised March 27, 1987 					*/
/*	Revised February 28, 1987 				*/
/*	Revised October 21, 1986 				*/
/*	Revised October 2, 1986 				*/
/*	Revised September 26, 1986 				*/
/*	Revised September 19, 1986 				*/
/*	Revised September 14, 1986 				*/
/*	Revised September 11, 1986 				*/
/*	Revised August 15, 1986 				*/
/*	Revised August 14, 1986 				*/
/*	Revised August 12, 1986 				*/
/*	Revised August 11, 1986 				*/
/*	Revised August 7, 1986 					*/
/*	Revised August 6, 1986 					*/
/*	Revised July 15, 1986 					*/
/*	Revised July 8, 1986 					*/
/*	Revised June 27, 1986 					*/
/*	Revised March 17, 1986 					*/
/*	Revised March 15, 1986 					*/
/*	Revised March 8, 1986 					*/
/*	Revised March 5, 1986 					*/
/*	Revised March 3, 1986 					*/
/*	Revised January 20, 1986 				*/
/*	Revised January 14, 1986 - B.S.				*/
/*	Revised January 9, 1986					*/
/*	Revised January 3, 1986	B.S.				*/
/*	Revised January 3, 1986	 				*/
/*	Revised January 2, 1986 - B.S. 				*/
/*	Revised December 24, 1985 				*/
/*	Revised December 18, 1985 				*/
/*	Revised December 12, 1985 				*/
/*	Revised December 2, 1985 				*/
/*	Revised November 26, 1985 				*/
/*	Revised November 26, 1985 - B.S.			*/
/*	Revised November 21, 1985 - B.S.			*/
/*	Revised November 21, 1985 				*/
/*	Revised November 5, 1985 				*/
/*	Revised October 29, 1985 -- B.S.			*/
/*	Revised October 11, 1985				*/
/*	Revised August 6, 1985					*/
/*	Revised June 27, 1985					*/
/*	Revised June 7, 1985					*/
/*	Revised May 30, 1985					*/
/*	Revised March 8, 1985					*/
/*	June 29, 1984						*/
/*								*/
/*	This procedure package includes the following standard 	*/
/*	runtime functions necessary for easy use of the PSAIL	*/
/*	compiler in a UNIX environment.				*/
/*								*/
/* 7. I/O procedures: sub-module <psrun7.c>			*/
/*	arryin(chn,buf,wordCnt) - do SAIL ARRYIN		*/
/*	chncdb(chn) - do SAIL CHNCDB				*/
/*	arryout(chn,buf,wordCnt) - do SAIL ARRYOUT		*/
/*	PSclose(chn) - do SAIL CLOSE 				*/
/*	closin(chn) - do SAIL CLOSIN 				*/
/*	closo(chn) - do SAIL CLOSO 				*/
/*	enter(chn,file,*err) - do SAIL ENTER 			*/
/*	PSgetchan() - do SAIL GETCHAN				*/
/*	*getprint() - do SAIL GETPRINT			 	*/
/*	*inchwl() - do SAIL INCHWL				*/
/*	inchrw() - do SAIL INCHRW				*/
/*	inchrs() - do SAIL INCHRS				*/
/*	*input(chn,brkTbl) - do SAIL INPUT			*/
/*	intin(chn,brkChar) - do SAIL INTIN			*/
/*	lookup(chn,file,*err) - do SAIL LOOKUP 			*/
/*	PSopen(chn,dev,IOmod,nIb,nOb,*cnt,*brk,*eof)-do SAIL OPEN*/
/*	out(chn,sPtr) - do SAIL OUT				*/
/*	outchr(intVal) - do SAIL OUTCHR				*/
/*	PSprintf(ptr list) - print list of string pointers      */
/*	realin(chn,brkChar) - do SAIL REALIN			*/
/*	relchan(chan) - do SAIL RELCHAN				*/
/*	release(chn) - do SAIL RELEASE 				*/
/*	PSrename(chn,name) - do SAIL RENAME			*/
/*	senter(chn,file,protection,*err) - do SAIL ENTER w/prot.*/
/*	setprint(file,mode) - do SAIL SETPRINT 			*/
/*	ttyup(flag) - set tty input case conv & return old value*/
/*	usererr(value,code,msg) - do SAIL USERERR		*/
/*	useti(chn,blkNbr) - do SAIL USETI 			*/
/*	useto(chn,blkNbr) - do SAIL USETO 			*/
/*	wordin(chn) - do SAIL WORDIN				*/
/*	wordout(chn,data) - do SAIL WORDOUT			*/



/*	++++++++++++++++++++++++++++++++++++++++++++++++++++	*/
/*	+    E X T E R N A L   F I L E S   F U N C T I O N S    */
/*	++++++++++++++++++++++++++++++++++++++++++++++++++++	*/

#ifndef HASCONFIG
#include "config.h"	  /* declare HAS... macros */
#endif

#ifndef PNULL
#include "psrdef.h"	  /* need <sairun.c> & <psrung.h> compile-time macros */
#include "psrglb.h"	  /* need <sairun.c> global variables */


/*	The following are found in PSRUN1.C			*/
void Pfree();      /* return string to HEAP storage */
STRING Pmalloc();  /* return string from HEAP storage */
STRING salloc();	  /* return string from dynamic GC storage */

/*	The following are found in PSRUN3.C			*/
double Patod();    /* return double value of string # s*/
float Patof();     /* return float value of string # s */
int Patoi();       /* return int value of string # s */
INTEGER Patol();   /* return long value of string # s*/
INTEGER Patoo();   /* return long octal value of string # s*/
INTEGER Patou();   /* return long unsigned value of string # s*/
INTEGER Patox();   /* return long hex value of string # s*/
STRING cncat2();   /* return Pmalloc() generated concat(p,q) */
STRING Pcpystr();	  /* return Pmalloc() string copy */

/*	The following are found in PSRUN4.C			*/
void Pdtoa();      /* return string number of double value  */
void Pdetoa();     /* return string number of double E value */
void Petoa();      /* return string number of float E value */
void Pftoa();      /* return string number of float value */
void Pitoa();      /* return string number of int value */
void Pltoa();      /* return string number of long value */
void Potoa();      /* return string number of long octal value */
void Putoa();      /* return string # of long unsigned value */
void Pxtoa();      /* return string number of long hex value */

/*	The following are found in PSRUN5.C			*/
INTEGER PgetBrkBit();  /* test if (brkTbl,chr) chr In brkTbl */
INTEGER PgetOmitBit(); /* test if (omitTbl,chr) chr In omitTbl*/
extern INTEGER PmodeTbl[];   /* BREAK mode-bits table. 0 means that
			      * it was never assigned.
			      */
#endif			/* end of code brought in if compiling alone */

/*	The following are FORWARD definitions in PSRUN7.C	*/
int chkChan();   	/* return FALSE if legal else PRINT error 
			 * message and return TRUE Args:
			 *	(INTEGER chan; STRING msg)
			 */
void out();             /* do SAIL OUT */
void outchr();          /* do SAIL OUTCHR */
INTEGER PfillBuf();     /* local fill buffer function */
INTEGER PflushBuf();    /* local flush buffer function */

#ifndef __SABER__
void PSprintf();	/* takes variable # args (fmt,s1,s2,...,sn) */
#else
void PSprintf(char *, ...);
#endif

void usererr();         /* do SAIL USERERR */

/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/
/*	+    G L O B A L    V A R I A B L E S / M A C R O S	*/
/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/


#if (maxBITS==36)
#define PACKINGFACTOR 5         /* 7-bits/char, use in buffered I/O */
#define CHRSPERBLOCK 640	/* 128 words/block x 5 chars/word */
#define MAXCHAN 15	        /* max allowed under TOPS10 */
#endif

#if (maxBITS==32)
#define PACKINGFACTOR 4         /* 8-bits/char, use in buffered I/O */
#define CHRSPERBLOCK 512	/* 128 words/block x 4 chars/word */
#define MAXCHAN 50	        /* max allowed under other systems*/
#endif

#if (maxBITS==64)
#define PACKINGFACTOR 8         /* 8 8-bits/char, use in buffered I/O */
#define CHRSPERBLOCK 1024	/* 128 words/block x 8 chars/word */
#define MAXCHAN 200	        /* max want under UNICOS*/
#endif

#define CPYSTR(q,p) {if(p==0||*p==0) *q='\0'; else while(*q++ = *p++);}

/* 	The following tables are used for the emulated SAIL I/O  */
static INTEGER	freeChan[MAXCHAN]={0};	/* 0 for free channel */
static INTEGER *mapCBrkVar[MAXCHAN];	/* DEC10 brk char var ptr */
static INTEGER *mapCCDBptr[MAXCHAN];	/* DEC10 CDB array pointer */
static INTEGER  mapCcount[MAXCHAN];	/* DEC10 INPUT fn count*/
static STRING   mapCDevice[MAXCHAN];    /* DEC10 device name */ 
static STRING   mapCEName[MAXCHAN];     /* DEC10 ENTER name */
static INTEGER *mapCEofVar[MAXCHAN];	/* DEC10 eof var ptr */
static INTEGER  mapCerrCode[MAXCHAN];   /* DEC10 OPEN error Code */
#ifdef HASFILES
static FILE    *mapCFILE[MAXCHAN];      /* 'FILE' typedef file-dscptr*/
#endif
static INTEGER 	mpCFdI[MAXCHAN]; 	/* UNIX input file descriptr*/
static INTEGER 	mpCFdO[MAXCHAN]; 	/* UNIX output file descriptr*/
static INTEGER	mapCiCtr[MAXCHAN];	/* DEC10 input buf Ctrs */
static INTEGER	mapCioMode[MAXCHAN];	/* DEC10 IO mode */
static STRING   mapCiPtr[MAXCHAN];	/* DEC10 input buf ptrs */
static STRING   mapCLName[MAXCHAN];     /* DEC10 LOOKUP name */
static INTEGER	mapCnIbuf[MAXCHAN];	/* DEC10 # input buffers */
static INTEGER	mapCnObuf[MAXCHAN];	/* DEC10 # output buffers */
static INTEGER	mapCoCtr[MAXCHAN];	/* DEC10 output buf Ctrs */
static STRING   mapCoPtr[MAXCHAN];	/* DEC10 output buf ptrs */
static INTEGER  mapCprotect[MAXCHAN];   /* DEC10 9-bit protections */
static INTEGER  mapCsawEof[MAXCHAN];    /* saw EOF on last read() */

static struct cdb {             /* cdb is the Channel Data Block */
		  INTEGER *cdbBrk;	/* brk char var ptr */
		  INTEGER *cdbCDBptr;   /* CDB array pointer */
		  INTEGER *cdbCount;	/* INPUT fn count*/
		  STRING   cdbDevice;   /* device name */ 
		  STRING   cdbEName;    /* ENTER name */
		  INTEGER *cdbEofVar;	/* eof var ptr */
		  INTEGER  cdbErrCode;	/* open() error code */
#ifdef HASFILES
		  FILE     cdbFILE;     /* 'FILE' file-dscptr*/
#endif
		  INTEGER  cdbCFdI;     /* UNIX input file des*/
		  INTEGER  cdbCFdO; 	/* UNIX output file des*/
		  INTEGER  cdbIctr;	/* input buf Ctrs */
		  INTEGER  cdbIOmode;	/* IO mode */
		  STRING   cdbIptr;	/* input buf ptrs */
		  STRING   cdbLName;    /* LOOKUP name */
		  INTEGER  cdbNibuf;	/* # input buffers */
		  INTEGER  cdbNobuf;	/* # output buffers */
		  INTEGER  cdbOctr;	/* output buf Ctrs */
		  STRING   cdbOptr;	/* output buf ptrs */
		  INTEGER  cdbSawEof;   /* saw EOF last read() */
		 };
typedef struct cdb CDB;			/* used by chncdb() */

static char     pMode='t';		/*SETPRINT modes see [REISER]*/
static INTEGER  pChan= -1;		/* SETPRINT I/O channel */
static INTEGER  pCnt, pBrk, pEof, pErr; /* SETPRINT I/O channel */

static INTEGER  iBrkTable=0;		/* INTIN() break table */
static INTEGER  fBrkTable=0;		/* REALIN() break table */
static INTEGER  sosLineNbr=0;		/* SOS line number if DEC10 */
static INTEGER  sosPageNbr=0;		/* SOS page number if DEC10 */
				/* SOS is a line oriented text editor
				 * for TOPS10/20 and is 36-bit
				 * dependent - not portable! */
static INTEGER  ttyCase=0;		/* 0 NO lower-case to
					 * upper-case conv, 1 to conv*/


/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/
/*	+    I / O          P R O C E D U R E S   		*/
/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/

/*	See PSREF.MEM Section 5.3 for details on coding		*/
/*	methods used here.					*/



/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL arryin						*/
/* 	Map		ARRYIN(chan,buf,wordCnt)		*/
/*	depending on whether it is dump or buffered I/O mode:	*/
/*	(a) DUMP mode:						*/
/*	to		read(int fd, *buf, byteCnt)		*/
/*	 	or	fread(*buf,size, int byteCnt, FILE fd)	*/
/*	(b) BUFFERED I/O mode:					*/
/*	    to use PfillBuf() to fetch the actual data and then	*/
/*	    copy it to the user's buffer.			*/
/*								*/
void PROCEDURE arryin(chan,buf,wordCnt)
	INTEGER chan;
	INTEGER *buf;
	INTEGER wordCnt;
{ /* ARRYIN */
	int ioMode,		/* TOPS10 I/O mode */
		bufSize,	/* total PfillBuf() buffer size */
		i, j,		/* temp variable */
	        nRead;          /* # bytes/words actually read */
	INTEGER *pI;		/* INTEGER pointer to PfillBuf() data */
	STRING p;		/* char *==>start of PfillBuf() data */

	if (chkChan(chan,"ARRYIN"))
		return;			/* bad Channel #? */
	if (buf==0)
		{usererr(chan,1L,
			GC_PUSHS("ARRYIN no 'buffer' specified"));
		 return;
		}
	if (wordCnt==0)
		{usererr(chan,1L,
			GC_PUSHS("ARRYIN no 'word count' specified"));
		 return;
		}
	if (*mapCEofVar[chan])
		{usererr(chan,1L,
			GC_PUSHS("ARRYIN can't read past EOF"));
		 return;
		}
	ioMode = mapCioMode[chan];
	if (ioMode!=010 && ioMode<=015)
		{usererr(chan,1L,
	GC_PUSHS("ARRYIN illegal I/O MODE specified in PSopen() call"));
		 return;
		}

	if (ioMode >= 015)
		{/* DUMP-MODE */
		if ((wordCnt%128) > 0)
			{usererr(chan,1L,GC_PUSHS(
   "ARRYIN dump mode wordCount must be mult. of 128 for channel #"));
			return;
			}
#ifdef HASREAD
		nRead=read((int)mpCFdI[chan],(char *)buf,
			   (int)PACKINGFACTOR*wordCnt);
		          /* reading #bytes=PACKINGFACTOR*#long words */
		nRead /= sizeof(INTEGER);   /* cvt bytes to words */
#endif
#ifdef HASCIO
		for(nRead=0; wordCnt>0; buf+=128, wordCnt-=128)
		    {
		    nRead += read(mpCFdI[chan],buf);
                                         /* DEC10 128 words/read*/
		    }
#endif
#ifdef HASFREAD
		nRead=fread((char *)buf, PACKINGFACTOR, (int)wordCnt, 
			    mapCFILE[chan]);  
			/* reading #bytes=PACKINGFACTOR*#long words */
		nRead /= sizeof(INTEGER);   /* cvt bytes to words */
#endif
#ifdef HASANSIC
		nRead=fread((void *)buf, (size_t)sizeof(INTEGER),
			    (size_t)wordCnt, mapCFILE[chan]);  
			/* reading #bytes=PACKINGFACTOR*#long words */
		nRead /= sizeof(INTEGER);   /* cvt bytes to words */
#endif

#ifdef HASEOF
	*mapCEofVar[chan] = eof(mpCFdI[chan]);
#endif
#ifdef HASFEOF
	*mapCEofVar[chan] = feof(mapCFILE[chan]);
#endif
#ifdef HASANSIC
	*mapCEofVar[chan] = feof(mapCFILE[chan]);
#endif

                             /* save error bits */
#ifdef HASERROR
	mapCerrCode[chan] = error(mpCFdI[chan]);
#endif
#ifdef HASFERROR
	mapCerrCode[chan] = ferror(mapCFILE[chan]);
#endif
#ifdef HASANSIC
	mapCerrCode[chan] = ferror(mapCFILE[chan]);
#endif
		} /* DUMP-MODE */

	else	{ /* BUFFERED-IMAGE-MODE */
		bufSize=mapCnIbuf[chan]*CHRSPERBLOCK;
		p=mapCiPtr[chan];
		for (i=1; i<=wordCnt; i++)
			{j=mapCiCtr[chan];
			if (j>=bufSize)
				{if (mapCsawEof[chan]== -1)
					{*mapCEofVar[chan]=TRUE;
					break;	/* NO MORE DATA */
					}
				mapCsawEof[chan]=PfillBuf(chan);
				j=mapCiCtr[chan];
				}
			pI = (INTEGER *)(p+j);   /* cast INTEGER ptr */
			mapCiCtr[chan] += PACKINGFACTOR;
			*buf = *pI;	/* copy INTEGER of data */
			}
		} /* BUFFERED-IMAGE-MODE */
} /* ARRYIN */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL arryout						*/
/* 	Map		ARRYOUT(chan,buf,wordCnt)		*/
/*	depending on whether it is dump or buffered I/O mode:	*/
/*	(a) DUMP mode:						*/
/*	to		write(fd, *buf, byteCnt)		*/
/*	 	or	fwrite(*buf,size, int byteCnt, FILE fd)	*/
/*	(b) BUFFERED I/O mode:					*/
/*	    to use PflushBuf() to put the actual data and then	*/
/*	    copy it to the file.				*/
/*								*/
void PROCEDURE arryout(chan,buf,wordCnt)
	INTEGER chan;
	INTEGER *buf;
	INTEGER wordCnt;
{ /* ARRYOUT */
	int ioMode,		/* TOPS10 I/O mode */
		bufSize,	/* total PfillBuf() buffer size */
		i, j,		/* temp variable */
	        nWrite;         /* # bytes/words written */
	INTEGER *pI;		/* INTEGER pointer==>PflushBuf() data*/
	STRING p;		/* char*==>start of PflushBuf() data*/

	if (chkChan(chan,"ARRYOUT")) 
		return;				/* bad channel #? */
	if (buf==0)
		{usererr(chan,1L,
			GC_PUSHS("ARRYOUT no 'buffer' specified"));
		 return;
		}
	if (wordCnt==0)
		{usererr(chan,1L,
			GC_PUSHS("ARRYOUT no 'word count' specified"));
		 return;
		}

	ioMode = mapCioMode[chan];
	if (ioMode!=010 && ioMode<=015)
		{usererr(chan,1L,GC_PUSHS(
		"ARRYOUT illegal I/O MODE specified in PSopen() call"));
		 return;
		}

	if (ioMode >= 015)
		{/* DUMP-MODE */
		if ((wordCnt%128) > 0)
			{usererr(chan,1L,
	GC_PUSHS("ARRYOUT dump mode wordCount must be mult. of 128"));
			return;
			}
#ifdef HASWRITE
		nWrite=write((int)mpCFdO[chan],(char *)buf,
			     (int)PACKINGFACTOR*wordCnt);
		nWrite /= sizeof(INTEGER);   /* cvt bytes to words */
#endif
#ifdef HASCIO
		for(nWrite=0; wordCnt>0; buf+=128, wordCnt-=128)
		    {
		    nWrite += write(mpCFdO[chan],buf);
                                     /* DEC10 128 words/write*/
		    }
#endif
#ifdef HASFWRITE
		nWrite=fwrite((char *)buf, PACKINGFACTOR, (int)wordCnt,
			      mapCFILE[chan]); 
				/* PACKINGFACTOR bytes/INTEGER */
		nWrite /= sizeof(INTEGER);   /* cvt bytes to words */
#endif
#ifdef HASANSIC
		nWrite=fwrite((void *)buf, (size_t)sizeof(INTEGER),
			      (size_t)wordCnt, mapCFILE[chan]); 
				/* PACKINGFACTOR bytes/INTEGER */
		nWrite /= sizeof(INTEGER);   /* cvt bytes to words */
#endif

                              /* Saver error status of I/O operation */
#ifdef HASERROR
	mapCerrCode[chan] = error(mpCFdO[chan]);
#endif
#ifdef HASFERROR
	mapCerrCode[chan] = ferror(mapCFILE[chan]);
#endif
#ifdef HASANSIC
	mapCerrCode[chan] = ferror(mapCFILE[chan]);
#endif
		}/* DUMP-MODE */

	else	{ /* BUFFERED-IMAGE-MODE */
		bufSize=mapCnIbuf[chan]*CHRSPERBLOCK;
		p=mapCiPtr[chan];
		for (i=1; i<=wordCnt; i++)
			{j=mapCiCtr[chan];
			pI = (INTEGER *)(p+j);   /* cast INTEGER ptr */
			mapCiCtr[chan] += PACKINGFACTOR;
			*pI = *buf;	/* copy INTEGER of data */
			if (j>=bufSize)
				PflushBuf(chan);
			}
		} /* BUFFERED-IMAGE-MODE */
} /* ARRYOUT */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL chncdb.						*/
/*	Return a pointer to the channel data block array.	*/
/*								*/
INTEGER PROCEDURE *chncdb(chan)
	INTEGER chan;
{ /* CHNCDB */
	INTEGER *p;

	union	{/*for doing coercions */
		STRING s;
		INTEGER *ip;
		INTEGER i;
		} eqv;

	if (chkChan(chan,"CHNCDB"))
		return(0L);		/* bad channel #? */
	p=mapCCDBptr[chan];
	if (p==0)
	   {usererr(chan,1L,
		GC_PUSHS("CHNCDB no CDB allocated for channel #"));
	    return(0L);
	   }
#ifdef DEBUGGING
/* PRINT OUT THE CDB */
printf("CHNCDB chan= %d\n",chan);
printf("CHNCDB POINTER p= %d\n",p);
printf("CHNCDB.1 *mapCBrkVar[chan]= %d\n",*mapCBrkVar[chan]);
printf("CHNCDB.1 *mapCCDBptr[chan]= %d\n",*mapCCDBptr[chan]);
printf("CHNCDB.1 mapCcount[chan]= %d\n",mapCcount[chan]);
printf("CHNCDB.1 mapCDevice[chan]= %s\n",mapCDevice[chan]);
printf("CHNCDB.1 mapCEName[chan]= %s\n",mapCEName[chan]);
printf("CHNCDB.1 ptr mapCEofVar[chan]= %d\n",mapCEofVar[chan]);
printf("CHNCDB.1 mapCerrCode[chan]= %d\n",mapCerrCode[chan]);
#ifdef HASFILES
printf("CHNCDB.1 &mapCFILE[chan]= %d\n",(INTEGER)(&mapCFILE[chan]));
#endif
printf("CHNCDB.1 mpCFdI[chan]= %d\n",mpCFdI[chan]);
printf("CHNCDB.1 mpCFdO[chan]= %d\n",mpCFdO[chan]);
printf("CHNCDB.1 mapCiCtr[chan]= %d\n",mapCiCtr[chan]);
printf("CHNCDB.1 mapCIMODE[chan]= %d\n",mapCioMode[chan]);
printf("CHNCDB.1 ptr mapCiPtr[chan]= %d\n",mapCiPtr[chan]);
printf("CHNCDB.1 mapCLName[chan]= %s\n",mapCLName[chan]);
printf("CHNCDB.1 mapCnIbuf[chan]= %d\n",mapCnIbuf[chan]);
printf("CHNCDB.1 mapCnObuf[chan]= %d\n",mapCnObuf[chan]);
printf("CHNCDB.1 mapCoCtr[chan]= %d\n",mapCoCtr[chan]);
printf("CHNCDB.1 ptr mapCoPtr[chan]= %d\n",mapCoPtr[chan]);
printf("CHNCDB.1 mapCprotect[chan]=0 o\n",mapCprotect[chan]);
printf("CHNCDB.1 mapCsawEof[chan]= %d\n",mapCsawEof[chan]);
#endif  /* end of DEBUGGING */

	eqv.ip = mapCBrkVar[chan];	/* DEC10 brk char var ptr */
	*(p++) = eqv.i;

	eqv.ip = mapCCDBptr[chan];	/* DEC10 CDB array pointer */
	*(p++) = eqv.i;

	*(p++) = mapCcount[chan];	/* DEC10 INPUT count */

	eqv.s = mapCDevice[chan];       /* DEC10 device name */ 
	*(p++) = eqv.i;

	eqv.s = mapCEName[chan];        /* DEC10 ENTER name */
	*(p++) = eqv.i;

	eqv.ip = mapCEofVar[chan];	/* DEC10 eof var ptr */
	*(p++) = eqv.i;

	*(p++) = mapCerrCode[chan];     /* DEC10 open error code*/

#ifdef HASFILES
	eqv.ip = (INTEGER *)mapCFILE[chan]; /* 'FILE' typedef file-dscptr*/
	*(p++) = eqv.i;
#endif

	*(p++) = mpCFdI[chan];		/* UNIX input file descriptor*/

	*(p++) = mpCFdO[chan];		/* UNIX output file descriptor*/

	*(p++) = mapCiCtr[chan];	/* DEC10 input buf Ctrs */

	*(p++) = mapCioMode[chan];	/* DEC10 IO mode */

	eqv.s = mapCiPtr[chan];	        /* DEC10 input buf ptrs */
	*(p++) = eqv.i;

	eqv.s = mapCLName[chan]; 	/* DEC10 LOOKUP name */
	*(p++) = eqv.i;

	*(p++) = mapCnIbuf[chan];	/* DEC10 # input buffers */

	*(p++) = mapCnObuf[chan];	/* DEC10 # output buffers */

	*(p++) = mapCoCtr[chan];	/* DEC10 output buf Ctrs */

	eqv.s = mapCoPtr[chan];	        /* DEC10 output buf ptrs */
	*(p++) = eqv.i;

	*(p++) = mapCprotect[chan];	/* DEC10 9-bit protection code */

	*(p++) = mapCsawEof[chan];      /* saw EOF last read()*/

	return(mapCCDBptr[chan]);
} /* CHNCDB */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL close.						*/
/*								*/
void PROCEDURE PSclose(chan)
	INTEGER chan;
{ /* CLOSE */
	closin(chan);
	closo(chan);
} /* CLOSE */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL closin.						*/
/*								*/
INTEGER PROCEDURE closin(chan)
	INTEGER chan;
{ /* CLOSIN */
	int fd;

	if (chkChan(chan,"CLOSIN") || (fd=mpCFdI[chan])==0) 
		return(FALSE);		/* bad channel */

	if (*mapCLName[chan]!='\0') 
		{Pfree(mapCLName[chan]); /* free the name */
		mapCLName[chan]=PNULL;
		}
	mpCFdI[chan]=0;			 /* mark as unused */
#ifdef HASCLOSE
	close(fd);
#endif
#ifdef HASFCLOSE
	fclose(mapCFILE[chan]);
#endif
#ifdef HASANSIC
	fclose(mapCFILE[chan]);
#endif

	if (fd==mpCFdO[chan])
		mpCFdO[chan]=0;		 /* mark as unused as well */
	mapCiCtr[chan]=0;		 /* mark as unused */
	return(TRUE);
} /* CLOSIN */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL closo.						*/
/*								*/
INTEGER PROCEDURE closo(chan)
	INTEGER chan;
{ /* CLOSEO */
	int fd,				/* file descriptor */
		ioMode;			/* TOPS10 I/O mode */
	INTEGER PflushBuf();		/* forward reference */

	if (chkChan(chan,"CLOSO") || (fd=mpCFdO[chan])==0) 
		return(FALSE);		/* bad channel */
	ioMode=mapCioMode[chan];

	if (ioMode <= 01) 
		{char temp[2];
		temp[0]=CTRLZ;
		temp[1]='\0';		/* force string */
		out(chan,&temp[0]);	/* TOPS10 close of file */
		if (mapCoCtr[chan] > 0) 
			PflushBuf(chan);    /* only if need it */
		}

	if (*mapCEName[chan]!='\0') 
		{Pfree(mapCEName[chan]); /* free the name */
		mapCEName[chan]=PNULL;
		}
	mpCFdO[chan]=0;			/* free it */
#ifdef HASCLOSE
	close(fd);
#endif
#ifdef HASFCLOSE
	fclose(mapCFILE[chan]);
#endif
#ifdef HASANSIC
	fclose(mapCFILE[chan]);
#endif

	if (mpCFdI[chan]==fd)
		mpCFdI[chan]=0;	/* mark as unused */
	return(TRUE);
} /* CLOSEO */


/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
/*	Check if channel number is valid and do USERERR if not	*/
/*	If we continue, then return TRUE. If it is legal return */
/*	FALSE.							*/
/*								*/
static int chkChan(chan,msg)
	INTEGER chan;	/* channel number to check */
	STRING  msg;	/* name of procedure where called from */
{ /* CHKCHAN */
	if (chan<0 || chan>MAXCHAN || freeChan[chan]==0)
		{PSprintf("\nIllegal channel #%d for '%s'.",chan,
			  GC_PUSHS(msg));
		usererr(0L,0L,
			GC_PUSHS("CHKCHAN press return to continue?"));
		return(FALSE);
		}
	return(TRUE);
} /* CHKCHAN */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL enter.						*/
/*	Check whether the file exists and if not do a creat()	*/
/*	UNIX 'creat(name,pmode)' call (see K&R page 162).	*/
/*	If we are doing an ENTER on a channel with the LOOKUP	*/
/*	NEQ 0, then if it is a different file then just open	*/
/*	up another (different) creat() file. If it is the same,	*/
/*	then it gets tricky. Close the input file and re open()	*/
/*	it in READWRITE mode. Set the mpCFdI[chan] to same fd.	*/
/*								*/
void PROCEDURE enter(chan,fileName,err)
	INTEGER chan;
	STRING fileName;
	INTEGER *err;
{ /*ENTER*/
	int rwMode,			/* READ-WRITE mode
					*	0 = READ only 
					*	1 = WRITE only
					*	2 = READ & WRITE
					*/
	 	fd,			/* file descriptor */
		ioMode,			/* TOPS10 I/O mode */
		nObuf,			/* # output buffers */
		failedFlag;		/* set TRUE if open() failed */
	STRING	s,			/* used to build FILENAME */
                fMode;                  /* fopen() file mode: "w" or "w+b" */
#ifdef HASFILES
	FILE    *ffd;			/* file descriptor for fopen()*/
#endif

	GC_POPS(fileName);	/* get arg from temp string var. PDL */

	*err = FALSE;			/* default is NO-ERROR */
	if (chkChan(chan,"ENTER"))
		return;			/* bad channel #? */

	fd=mpCFdO[chan];

	if ((fd=mpCFdO[chan]) != 0)
		{usererr(chan,1L,
	GC_PUSHS("ENTER on previously ENTERed file for channel #"));
		return;
		}
	nObuf=mapCnObuf[chan];
	ioMode=mapCioMode[chan];

	if (nObuf==0 && ioMode<015)
		{usererr(chan,1L,GC_PUSHS(
	"ENTER no buffers specified for buffered-I/O, channel #"));
		return;
		};

	s=mapCDevice[chan];		/* make complete file name */

#ifdef HASDEC10
	s = GC_EPOPS(catlist(2L,GC_PUSHS(s),GC_PUSHS(":")));
#endif
#ifndef HASDEC10
	s = GC_EPOPS(catlist(2L,GC_PUSHS(s),GC_PUSHS("/")));
	                               /* UNIX style file system */
#endif
	s = GC_EPOPS(catlist(2L,GC_PUSHS(s),GC_PUSHS(fileName)));
 	                               /* output file*/
	mapCEName[chan]=s;

	if (mpCFdI[chan]==0)  
		rwMode=1;  		/* do create - ENTER only */

	else	{if (equ(GC_PUSHS(mapCLName[chan]),GC_PUSHS(s)))
			{rwMode=2; 	/* same names */
			 closin(chan);	/* close old input fd */
			}
		else  rwMode=1; 	/* different names - create */
		}

	if (rwMode==2)
		{ /* READ AND WRITE */
#ifdef HASOPEN
		fd=open(s,rwMode);	 /* return -1 if fails */
		failedFlag = (fd== -1) ? (*err=TRUE) : FALSE;
#endif
#ifdef HASCIO
		fd=open(s,IO_SHARED,IO_DUMP); /* returns OPEN error 
					      * bits if fail */
		failedFlag = (fd<0) ? (*err=fd, TRUE) : FALSE;
#endif
#ifdef HASFOPEN
		fd = 1;                  /* make it > 0  for compatibility*/
		fMode="w+b";			/* read-write */
		ffd=fopen(s,fMode); /* returns NULL FILE ffd if fails*/
		failedFlag = (ffd==0) ? (*err=TRUE) : FALSE;
#endif
#ifdef HASANSIC
		fd = 1;                  /* make it > 0  for compatibility*/
		fMode="w+b";			/* read-write */
		ffd=fopen(s,fMode); /* returns NULL FILE ffd if fails*/
		failedFlag = (ffd==0) ? (*err=TRUE) : FALSE;
#endif
		} /* READ AND WRITE */

	else if (rwMode==1)
		{ /* WRITE ONLY */
#ifdef HASCREAT
		fd = creat(s,rwMode);	/* returns -1 if fails */
		failedFlag = (fd== -1) ? (*err=TRUE) : FALSE;
#endif
#ifdef HASCIO
		fd=open(s,IO_WRITE,IO_DUMP);   /* returns TOPS10
						* OPEN err bits
						* if fails.
						*/
		failedFlag = (fd<0) ? (*err=fd, TRUE) : FALSE;
#endif
#ifdef HASFOPEN
		fd = 1;                 /* make it > 0  for compatibility*/
		fMode="w";		/* write only */
		ffd=fopen(s,fMode); /* returns NULL FILE ffd if fails*/
		failedFlag = (ffd==0) ? (*err=TRUE) : FALSE;
#endif
#ifdef HASANSIC
		fd = 1;                 /* make it > 0  for compatibility*/
		fMode="w";		/* write only */
		ffd=fopen(s,fMode); /* returns NULL FILE ffd if fails*/
		failedFlag = (ffd==0) ? (*err=TRUE) : FALSE;
#endif
		} /* WRITE ONLY */
	mapCerrCode[chan] = *err;	/* copy into CDB too */

                              /* Saver error status  of I/O operation */
#ifdef HASERROR
	mapCerrCode[chan] = error(mpCFdO[chan]);
#endif
#ifdef HASFERROR
	mapCerrCode[chan] = ferror(mapCFILE[chan]);
#endif
#ifdef HASANSIC
	mapCerrCode[chan] = ferror(mapCFILE[chan]);
#endif

	if (failedFlag)
		fd=0;		/* clear it if trouble */
	mpCFdO[chan]=fd; 	/* save the actual file descriptor */


	if (failedFlag)
		return;		/* get out now if trouble */

				/* SUCCESS if get here */

#ifdef HASFILES
	mapCFILE[chan]=ffd;	/* update real file descr. as well */
#endif
	mapCoCtr[chan]=0; 	/* reset character count */
	if (rwMode==2)
		{mpCFdI[chan]=fd;  /* also save IN actual file desc */
		mapCiCtr[chan]=mapCnIbuf[chan]*CHRSPERBLOCK; /* reset */
		}
} /* ENTER */

/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
/*	Fill input buffer for channel if allowed.		*/
/*	Return	Condition					*/
/*	------	---------					*/
/*	0	If failed.					*/
/*	+1	If succeed and not EOF.				*/
/*	-1	If succeed and file system EOF.			*/
/*	Assuming a legal I/O channel and buffered I/O mode.	*/
/*	Note: the number of characters currently in the buffer	*/
/*	is in 'mapCiCtr[chan]' while the base pointer address	*/
/*	is in 'mapCiPtr[chan].					*/
/*								*/
static INTEGER PROCEDURE PfillBuf(chan)
	INTEGER chan;
{ /* PFILLBUF */
	int	bufSize,		/* # chars/buffer load */
		fd,			/* file descriptor */
		ioMode,			/* # I/O mode*/
		nIbuf,			/* # input blocks */
                nRead,                  /* # bytes/words read */
                rtnFlag;                /* -1, 0, +1 return value */
	STRING	p;			/* base buffer pointer */

	fd=mpCFdI[chan];		/* file descriptor */
	p=mapCiPtr[chan];		/* pointer to base of buffer */
	nIbuf=mapCnIbuf[chan];		/* # input blocks */
	bufSize=nIbuf*CHRSPERBLOCK;	/* total size of input buffer */
	ioMode=mapCioMode[chan];

	if (mapCsawEof[chan]== -1) 
			return(0L);	/* already have EOF */

				/* Assume chan and ioMode are valid */
	if (mapCiCtr[chan] >= bufSize)	/* if full then get next*/
		{mapCiCtr[chan]=0;	/* reset char cnt in buffer */
#ifdef HASREAD
		nRead = read((int)mpCFdI[chan],(STRING)p,bufSize);
		nRead /= sizeof(INTEGER);   /* cvt bytes to words */
#endif
#ifdef HASCIO
		for(i=1, nRead=0; i<=nIbuf; i++,p+=CHRSPERBLOCK)
		 	nRead += read(fd, p);   /* 128 words/read*/
#endif
#ifdef HASFREAD
		nRead = fread((STRING)p,sizeof(p),bufSize,mapCFILE[chan]);
						 /* 512 bytes */
		nRead /= sizeof(INTEGER);   /* cvt bytes to words */
#endif
#ifdef HASANSIC
		nRead = fread((void *)p,(size_t)sizeof(p),
			      (size_t)bufSize,mapCFILE[chan]);
						 /* 512 bytes */
		nRead /= sizeof(INTEGER);   /* cvt bytes to words */
#endif

                             /* save error bits */
#ifdef HASERROR
	mapCerrCode[chan] = error(mpCFdI[chan]);
#endif
#ifdef HASFERROR
	mapCerrCode[chan] = ferror(mapCFILE[chan]);
#endif
#ifdef HASANSIC
	mapCerrCode[chan] = ferror(mapCFILE[chan]);
#endif

rtnFlag=1L;
#ifdef HASEOF
		if (*mapCEofVar[chan]=eof(fd))

		  rtnFlag= -1L;
#endif
#ifdef HASFEOF
		if (*mapCEofVar[chan]=feof(mapCFILE[chan]))
		  rtnFlag= -1L;
#endif
#ifdef HASANSIC
		if (*mapCEofVar[chan]=feof(mapCFILE[chan]))
		  rtnFlag= -1L;
#endif
		}

	return(rtnFlag);		/* return 1 if OK */
} /* PFILLBUF */


/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
/*	Flush output buffer for channel if allowed.		*/
/*	Assuming a legal I/O channel and buffered I/O mode.	*/
/*	If there is an output error (i.e. disk full etc) then	*/
/*	return FALSE. OTtherwise return TRUE. 			*/
/*								*/
static INTEGER PROCEDURE PflushBuf(chan)   /* see K&R page 168 */
	INTEGER chan;
{ /* PFLUSHBUF */
	int bufSize,			/* # chars/buffer load */
		fd,			/* file descriptor */
		ioMode,			/* # I/O mode*/
		nObuf,			/* # output blocks */
                nWrite;                 /* # bytes/words written */
	STRING p;

	fd=mpCFdO[chan];		/* file descriptor */
	p=mapCoPtr[chan];		/* pointer to base of buffer */
	nObuf=mapCnObuf[chan];		/* # output blocks */
     	bufSize=nObuf*CHRSPERBLOCK;
	ioMode=mapCioMode[chan];
			/* Assume channel # and mode are valid */
#ifdef HASWRITE
	nWrite = write((int)mpCFdO[chan],(STRING)p,bufSize);
	nWrite /= sizeof(INTEGER);   /* cvt bytes to words */
#endif
#ifdef HASCIO
	for(i=1, nWrite=0; i<=nObuf; i++,p+=CHRSPERBLOCK)
		nWrite += write(fd,p);	/* writes 1 block at a time */
#endif
#ifdef HASFWRITE
	nWrite = fwrite((STRING)p,sizeof(p),bufSize,mapCFILE[chan]);
	nWrite /= sizeof(INTEGER);   /* cvt bytes to words */
#endif
#ifdef HASANSIC
	nWrite = fwrite((void *)p,(size_t)sizeof(p),
			(size_t)bufSize,mapCFILE[chan]);
	nWrite /= sizeof(INTEGER);   /* cvt bytes to words */
#endif

                              /* Saver error status  of I/O operation */
#ifdef HASERROR
	mapCerrCode[chan] = error(mpCFdO[chan]);
#endif
#ifdef HASFERROR
	mapCerrCode[chan] = ferror(mapCFILE[chan]);
#endif
#ifdef HASANSIC
	mapCerrCode[chan] = ferror(mapCFILE[chan]);
#endif

	mapCoCtr[chan]=0;		/* reset count */
/* @V.53.92 -- add code to return FALSE if output error.	*/
	return(TRUE);
} /* PFLUSHBUF */

/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL GETCHAN.					*/
/*	If there are no more free channels, then return -1.	*/
/*	Otherwise, mark a free channel as busy and return the	*/
/*	index (i.e. channel) number.				*/
/*								*/
INTEGER PROCEDURE PSgetchan()
{ /* PSGETCHAN */
	int i,
		chan;

	chan = -1;		/* default  -1 as no channel avail */
	for (i=0; i<=MAXCHAN; i++)
		 if (freeChan[i]==0) 
			{freeChan[i]=1;
			 chan = i;
			break;
			}
	return(chan);
} /* PSGETCHAN */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL inchrs.						*/
/*								*/
INTEGER PROCEDURE inchrs()
{ /* INCHRS */
	INTEGER ch;

/*	Add C compiler specific code if necessary */
	ch=getchar();		/* get whatever is there if any */
	if (ttyCase)
	        ch=cvupper(ch);
	return(ch);
} /* INCHRS */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL inchrw.						*/
/*								*/
INTEGER PROCEDURE inchrw()
{ /* INCHRW */
	INTEGER ch;

/*	Add C compiler specific code if necessary */
	while ((ch=getchar())=='\0')
	        ;	/* wait until something there */
	if (ttyCase)
	        ch=cvupper(ch);
	return(ch);
} /* INCHRW */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL inchwl.						*/
/*	Input a line terminated by CR or LR or ESC or if the	*/
/*	line is > MAXTTYLINE characters.			*/
/*								*/
STRING PROCEDURE inchwl()
{ /* INCHWL */
	INTEGER i;
	char s[MAXTTYLINE+1];		/* maximum input line */
	STRING sResult, s1, s2;
	char ch;

	s[i=0]='\0';
	while ((ch=getchar())!='\n' && (ch!='\15') && (ch!='\33') &&
		(i < MAXTTYLINE))
		s[i++]=(ttyCase) ? cvupper(ch) : ch;
	s[i]='\0';			/* end of string */
	if (ch=='\15') 
		{/* handle CRLF problem */
#ifdef HASSARGASSOC
		getchar();    	/* need to eat the LF as well */
		outchr((INTEGER)'\r');	/* echo CR */
#endif
		outchr((INTEGER)'\n');
		} /* handle CRLF problem */
	else outchr((INTEGER)ch);
	s1 = &s[0];		    /* copy string ==> salloc() str*/
	sResult = s2 = salloc(i+2); /* get string space */
	while ((*s2++ = *s1++) != '\0')
			;	    /* copy it to G.C. space string */
	return(GC_PUSHS(sResult));
} /* INCHWL */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL input.						*/
/*	IFF ioMode is ASCII mode, i.e. < 02!!!		*/
/*	See [Reiser] page 39. Scan non-dump mode input file	*/
/*	controlled by the break field and file EOF.		*/
/*	The reason for break can be found by analyzing following*/
/*	EOF	BRCHAR	Reason					*/
/*	----	------	------					*/
/*	TRUE	0	 EOF found				*/
/*	FALSE	0	 no brk char found in COUNT # characters*/
/*	FALSE	<0	 (NOT USED, Scanned SOS line #)		*/
/*	FALSE	>0	 found break character			*/
/*								*/
/*	Operation						*/
/*	---------						*/
/*	[1] Check for valid channel and modes.			*/
/*	[2] Fill buffer if not EOF and it is empty.		*/
/*	[3] Get next character and build string in TMPBUF	*/
/*	    if string size < TMPBUFSIZE. If it is greater,	*/
/*	    then get a string of size 'count' from Pmalloc()	*/
/*	    and continue building the string in it.		*/
/*	[4] When done, get a G.C. space string of the required	*/
/*	    size from salloc() and copy first the tmpBuf[] and	*/
/*	    then the Pmalloc() (i.e. oldS0 & oldS1) to it.	*/
/*	[5] Free the Pmalloc() string if it was used.		*/
/*								*/
STRING PROCEDURE input(chan,breakTable)
	INTEGER chan,
		breakTable;
{ /* INPUT */
	int 	count,			/* max allowd output str size */
		nChar,			/* # chars read from file */
		sChar,			/* # chars save in output str*/
		fd,			/* file descriptor */
		ioMode,			/* TOPS10 I/O mode */
		ls,			/* sizeof current out buffer */
		nIbuf,			/* number of input buffers */
		bufSize,		/* sizeof packed input buffer*/
		sawEofFlag,		/* saw EOF on read flag */
		useTMPBUFflag;		/* if set use static buffer
					 * else use dynamic buffer
					 * borrowed from Pmalloc() */
	char	c;			/* current char from input*/
	STRING	p,			/* ptr==>base of input buffer*/
		s,			/* ptr==> current char out Buf*/
		s1,			/* ptr used in string copying*/
		oldS,			/* ptr==>string returned */
		oldS0,			/* ptr==>tmpBuf[] string */
		oldS1;			/* ptr==>Pmalloc() string used*/
	static char tmpBuf[TMPBUFSIZE+1]; /* where TRY save string 1st*/
	INTEGER Amode,		/* APPEND break char to output string*/
		Imode,		/* specify brk char by INCLUSION */
		Kmode,		/* convert a:z to A:Z */
		Rmode,		/* RETAIN break char on input string*/
		Smode,		/* SKIP break character */
		Xmode,		/* Specify break char by eXCLUSION */
		mBits;	  /* SETBREAK bits from PmodeTbl[breakTable]*/
/* @@@ @V.51.98 NOTE -- these are currently local to PSRUN5.C so */
/* we must regenerate them here.				*/

	GC_MARKSSTKFRAME;
	GC_NOTESTRING(p);
	GC_NOTESTRING(s);
	GC_NOTESTRING(s1);
	GC_NOTESTRING(oldS);
	GC_NOTESTRING(oldS0);
	GC_NOTESTRING(oldS1);


	if (chkChan(chan,"INPUT")) 
		GC_SRETURN(PNULL)  /* check legal chan # */

	fd=mpCFdI[chan];		/* file descriptor */

	if (fd==0)
		{usererr(chan,1L,
		GC_PUSHS("INPUT channel never did LOOKUP, channel #"));
		GC_SRETURN(PNULL)
		}

	if (*mapCEofVar[chan])
		{usererr(chan,1L,
			GC_PUSHS("INPUT can't read past EOF"));
		 GC_SRETURN(PNULL)
		}

	p=mapCiPtr[chan];		/* pointer to base of buffer */
	nIbuf=mapCnIbuf[chan];
	if (p==0 || nIbuf==0)
		{usererr(chan,1L,
	    GC_PUSHS("INPUT no input buffers specified, channel #"));
		GC_SRETURN(PNULL)
		}

	bufSize=nIbuf*CHRSPERBLOCK;	/* max Buffer size */
	ioMode=mapCioMode[chan];	/* I/O mode to be used */
	count=mapCcount[chan];   	/* chars to scan before brk*/
	sawEofFlag=mapCsawEof[chan];

	if (ioMode>02 || count==0)
		{usererr(chan,1L,
			GC_PUSHS("INPUT Illegal I/O Mode, channel #"));
		GC_SRETURN(PNULL)
		}

	nChar=0;	/* # characters actually read from file */
	sChar=0;	/* # characters actually saved in string */
			/* need this since buf cnt does not count */
			/* omitted chars			*/

	oldS0 = s = &tmpBuf[0];	/* default! probably < count! */
	ls=TMPBUFSIZE-1;	/* size of string we grew */
	useTMPBUFflag=TRUE;	/* start off with our own stuff */

	mBits=PmodeTbl[breakTable]; 	/* set up SCAN mode flags */
	if (mBits==0)
		{usererr(chan,1L,
   GC_PUSHS("INPUT never initialized SETBREAK table for channel #"));
		GC_SRETURN(PNULL)
		}
					/* DUPL code from PSRUN5.c */
					/* static getScanMode() */
	Amode = (mBits & Abit);
/*	Fmode = (mBits & Fbit);	*/
	Imode = (mBits & Ibit);
	Kmode = (mBits & Kbit);
/*	Lmode = (mBits & Lbit);	*/
/*	Omode = (mBits & Obit);	*/
	Rmode = (mBits & Rbit);
	Smode = (mBits & Sbit);
	Xmode = (mBits & Xbit);
/*	Zmode = (mBits & Zbit);	*/

	*mapCBrkVar[chan]='\0'; 	/* default brk char */

	while (sChar <= count)
		{/* scan loop */
		if (((int)mapCiCtr[chan]) >= bufSize)
			{ /* Need more input */
			if (! *mapCEofVar[chan])
				break;  /* ALL DONE */
			if (sawEofFlag== -1)
				{*mapCEofVar[chan]=TRUE;
				 *mapCBrkVar[chan]='\0';
				}
			else 	{ /* Refill-buffer*/
				sawEofFlag=PfillBuf(chan);
				mapCsawEof[chan]=sawEofFlag;
				} /* Refill-buffer*/
			} /* Need more input */

#ifdef HASDEC10
		/* Pick 7-bit byte from PDP10 packed word which */
		/* is left justified and test for SOS line #	*/
		/* 'flag' in Rightmost bit (35).		*/
		wPtr = p;	/* copy STRING to INTEGER  ptr */
		if (nbrFlag=(*wPtr & 1))
			{ /* save line # in sosLineNbr */
			sosLineNbr = 0;
			for (j=1; j<=5; j++)
				{
				c = *(p+mapCiCtr[chan]++); /* get byte 
							from buffer*/
				c = ('0'<=c && c<='9') ? (c-'0') : 0;
				sosLineNbr = (10 * sosLineNbr) + c;
				}
			} /* save line # in sosLineNbr */
#endif

		c = *(p + mapCiCtr[chan]++);   /* get byte from buffer*/
		nChar++;			/* # characters read */

		if (c==CTRLZ) 
			*mapCEofVar[chan]=TRUE;

		else if ((Imode && PgetBrkBit(breakTable,c)==1) ||
		          (Xmode && PgetBrkBit(breakTable,c)==0)) 
			{ /* found-BRK-char*/
			*mapCBrkVar[chan]=c;	/* save brk char */
			if (Amode) 
				{*(s++)=c; /* APPEND to output */
				*s='\0';
				sChar++;
				}
			 else if (Rmode)
				{ /* RETAIN in input string */
				 mapCiCtr[chan]--; /* backup */
				}
			/* NOTE: Smode == SKIP requires NO-OP! */
			 break;
			} /* found-BRKchar*/

		else if (PgetOmitBit(breakTable,c)==0) 
			{ /* Build non-brk non-omit char */
			*(s++) = (Kmode) ? cvupper(c) : c;
			*s = '\0';	/* end of string */
			sChar++;
			} /* Build non-brk non-omit char */

	if (c==CTRLZ || (sChar >= count)) 
		{ /* forced-exit */
		*mapCBrkVar[chan]=0;
		break; /* NO brk char */
		} /* forced-exit */

	else if (sChar==ls && useTMPBUFflag)
		{ /* need larger temporary string */
		useTMPBUFflag=FALSE;      /* don't come here again */
		ls=(count-TMPBUFSIZE+1);  /* how much more we need */
		oldS1=s=Pmalloc(ls+1);    /* go for a GIANT buffer!*/
		} /* need larger temporary string */
	} /* scan loop */
				/* copy string to make exact fit */
	oldS=s=salloc(sChar+1);	/* get it from STRING GC space */
	s1=oldS0;		/* TMPBUF */
	while(*s++ = *s1++)
	        ;	/* first copy it from tmpBuf[]*/

	if (!useTMPBUFflag) 
		{s--;		/* backup over NULL char */
		s1=oldS1;	/* Pmalloc() buffer */
		while(*s++ = *s1++)
		        ;	/* 2nd copy it <==Pmalloc buf*/
		Pfree(oldS1); 	/* get rid of temp buffer */
		}
	*s='\0';			/* close it with C EOS */

	GC_SRETURN(oldS)
} /* INPUT */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL intin.						*/
/*								*/
INTEGER PROCEDURE intin(chan)
	INTEGER chan;
{ /* INTIN */
	STRING nbr;		/* string read from file */
	INTEGER n;		/* number constructed from string */

	if (chkChan(chan,"INTIN")) 
		return(0L);		/* bad channel #? */
	if (iBrkTable==0)
		{iBrkTable=56;		/* setup internal SCAN table */
		setbreak(iBrkTable,GC_PUSHS("0123456789+-"),
			     GC_PUSHS(" \t\r\n\14"), GC_PUSHS("XNR"));
					/* to scan an integer */
		}
	nbr = input(chan,iBrkTable);    /* scan until non integer */
	n = Patol(nbr);			/* CVT numeric str to INTEGER */
	return(n);
} /* INTIN */



/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL lookup.						*/
/*	Open the file in READONLY mode. If we do an ENTER later	*/
/*	on the same file, then ENTER will take care of the 	*/
/*	tricky stuff which has to be done.			*/
/*								*/
void PROCEDURE lookup(chan,fileName,err)
	INTEGER chan;
	STRING fileName;
	INTEGER *err;
{ /* LOOKUP */
	int	count,			/* max string size on INPUT */
		ioMode,			/* TOPS10 I/O mode */
		nIbuf,			/* number of input buffers */
		rwMode;			/* UNIX read/write mode */
	INTEGER fd,			/* file descriptor */
		failedFlag;		/* set TRUE if open() failed */
	STRING	s;			/* used to build FILENAME */
#ifdef HASFILES
	FILE   *ffd;			/* needed in case use fopen()*/
#endif

	GC_POPS(fileName);	/* get arg from temp string var. PDL */

	*err=FALSE;			/* default as NO-ERROR */
	if (chkChan(chan,"LOOKUP"))
		return;			/* bad channel #? */

	nIbuf=mapCnIbuf[chan];
	ioMode=mapCioMode[chan];
	count=mapCcount[chan];

	if (ioMode < 015)
		{ /* setup for buffered-mode */
		if (nIbuf==0)
			{usererr(chan,1L,GC_PUSHS(
	"LOOKUP no buffers specifed for buffered-mode, channel #"));
			*err=TRUE;
			return;
			}
		if (ioMode<02 && count==0)
			{usererr(chan,1L,GC_PUSHS(
	"LOOKUP no count specifed in OPEN for ASCII-mode, channel #"));
			*err=TRUE;
			return;
			}
		} /* setup for buffered-mode */

	fd=mpCFdI[chan];		/* check file descriptor */

	if (fd == mpCFdO[chan])
		{ /* Note: READ-WRITE channel with same file name was
		  * requested to LOOKUP a new file. This is illegal -
		  * I think. Check and if so then give them a 
		  * USERERR().
		 */
		usererr(chan,1L,GC_PUSHS(
    "LOOKUP illegal for new file on already READ-WRITE file, chan #"));
		*err=TRUE;		/* NOTE: error */
		return;
		}
	if (fd != 0) 
		closin(fd);		/* release older LOOKUP file */

	mapCiCtr[chan]=mapCnIbuf[chan]*CHRSPERBLOCK; /* preset full */

	rwMode=0;			/* default to READ ONLY */

	s = mapCDevice[chan];		/* construct FILENAME */
#ifdef HASDEC10
	s = GC_EPOPS(catlist(2L,GC_PUSHS(s),GC_PUSHS(":")));
#endif
#ifndef HASDEC10
	s = GC_EPOPS(catlist(2L,GC_PUSHS(s),GC_PUSHS("/")));
                                        /* UNIX style file system */
#endif
	s = GC_EPOPS(catlist(2L,GC_PUSHS(s),GC_PUSHS(fileName)));
 	                                /* output file*/
	mapCLName[chan] = s;

				/* Open a NEW file */
#ifdef HASOPEN
	fd = open(mapCLName[chan],rwMode); /* returns -1 if fails */
	failedFlag = (fd== -1) ? (*err=TRUE) : FALSE;
#endif
#ifdef HASCIO
/* NOTE: on the DEC10, we are using DUMP mode because we are 	*/
/* doing our own  buffered I/O.					*/
	fd = open(mapCLName[chan],IO_READ,IO_DUMP); /* return 
					* TOPS10 open() error bits
					* if fail else 0.
					*/
	failedFlag = (fd<0) ? (*err=fd, TRUE) : FALSE;
#endif
#ifdef HASFOPEN
	ffd = fopen(s,"r");	/* returns NULL FILE ffd if failed */
	failedFlag = (ffd==0) ? (*err=TRUE) : FALSE;
#endif
#ifdef HASASCIC
	ffd = fopen(s,"r");	/* returns NULL FILE ffd if failed */
	failedFlag = (ffd==0) ? (*err=TRUE) : FALSE;
#endif

	mapCerrCode[chan] = *err;	/* keep a copy of ERROR bits */

	if (failedFlag)
		fd=0;			/* force it to fail too */
	mpCFdI[chan] = fd;		/* update it */

	if (failedFlag) 
		return;			/* failed OPEN,LOOKUP */

			/* If we get here - we are OK */
#ifdef HASFILES
	mapCFILE[chan] = ffd;		/* update this as well */
#endif

                             /* save error bits */
#ifdef HASERROR
	mapCerrCode[chan] = error(mpCFdI[chan]);
#endif
#ifdef HASFERROR
	mapCerrCode[chan] = ferror(mapCFILE[chan]);
#endif
#ifdef HASANSIC
	mapCerrCode[chan] = ferror(mapCFILE[chan]);
#endif
} /*LOOKUP */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL open.						*/
/*	Errors are denoted by non-zero in the 'eofVar' as 	*/
/*	follows:						*/
/*	ERR		FUNCTION				*/
/*	---		--------				*/
/*	04000000	improper mode (catch all)		*/
/*	02000000	parity error				*/
/*	01000000	data error				*/
/*	00400000	record # out of bounds			*/
/*	00200000	EOF found on input only			*/
/*		The following codes are PSAIL extensions 	*/
/*	00100000	illegal channel number 			*/
/*	00040000	channel number already in use 		*/
/*	00020000	no buffers specified for buffered mode	*/
/*	00010000	0 count specified for ASCII INPUT mode	*/
/*								*/
/*	DATA I/O MODE	FUNCTION				*/
/*	-------------	--------				*/
/*	0 		 ASCII sequential			*/
/*	1 		 ASCII line sequential			*/
/*	2 		 Packed Image sequential		*/
/*	3 		 Byte sequential			*/
/*	4-7 		  <Not assigned>			*/
/*	10 		 Image sequential			*/
/*	11-12 		  <Not assigned>			*/
/*	13 		 Image Binary sequential		*/
/*	14 		 Binary sequential			*/
/*	15 		 Image Dump mode 			*/
/*	16 		 Dump Record mode 			*/
/*	17 		 Dump mode 				*/
/*								*/
void PROCEDURE PSopen(chan,dev,ioMode,nIbuf,nObuf,count,brkChr,eofVar)
	INTEGER chan;	 /* sail I/O channel 0 to MAXCHAN decimal */
	STRING  dev;	 /* legal TOPS10 device name no ':' */
	INTEGER ioMode;  /* legal TOPS10 I/O modes 00 to 017 */
	INTEGER nIbuf;   /* number of input buffers for buffered I/O */
	INTEGER nObuf;   /* number of output buffers for buffered I/O */
	INTEGER *count;  /* maximum string (char count) size on INPUT */
	INTEGER *brkChr; /* address of user break character variable */
	INTEGER *eofVar; /* address of user EOF variable */
{ /* PSOPEN */
	INTEGER cCount;		/* local character count limit */

	GC_POPS(dev);	/* get arg from temp string var. PDL */

	if (chan < 0 || chan > MAXCHAN)
		{usererr(chan,1L,
			GC_PUSHS("OPEN illegal channel #"));
		*eofVar=0100000;
		return;
		}

	if (freeChan[chan])	/* get a channel if not specified */
		{usererr(chan,1L,GC_PUSHS(
		   "OPEN illegal channel already in use, channel #"));
		*eofVar=040000;
		return;
		}
	else freeChan[chan] = 1;	/* set channel in use flag */

	if (ioMode < 0 || ioMode > 017)
		{usererr(chan,1L,
			GC_PUSHS("OPEN illegal IO-MODE, channel #"));
		*eofVar=04000000;
		return;
		}
	if (ioMode<015 && nIbuf==0 && nObuf==0)
		{usererr(chan,1L,GC_PUSHS(
	"OPEN no buffers specified for buffered-mode, channel #"));
		*eofVar=020000;
		return;
		}
	if (ioMode<02 && nIbuf>0 && count==0)
		{usererr(chan,1L,GC_PUSHS(
	"OPEN zero count specified for ASCII INPUT mode, channel #"));
		*eofVar=010000;
		return;
		}
	*eofVar=0;			/* OK */

	dev = Pcpystr(dev);	/* get a copy in Pmalloc() space 
				 * so no problem with G.C. */

	cCount = ((count==0 || *count==0) ? CHRSPERBLOCK : *count);
					/* default if 0 */

	mapCBrkVar[chan] = brkChr;	/* ptr==>user's break var */
	mapCCDBptr[chan] = 0;		/* Channel Data Block */
	mapCcount[chan] = cCount;	/* max char count for INPUT*/
	mapCDevice[chan] = dev;  	/* String ptr==>device name! */
	mapCEName[chan] = PNULL;	/* String ptr ENTER filename*/
	mapCEofVar[chan] = eofVar;	/* ptr==> user's EOF variable*/
	mapCerrCode[chan] = 0;		/* open() etc err bits */
	mpCFdI[chan] = 0; 		/* LOOKUP file descriptor # */
	mpCFdO[chan] = 0; 		/* ENTER file descriptor # */
	mapCiCtr[chan]=nIbuf*CHRSPERBLOCK; /* chars left in input buf*/
	mapCioMode[chan] = ioMode;	/* TOPS10 I/O mode {0:017} */
	mapCiPtr[chan] = 0;		/* pointer to input buffer */
	mapCLName[chan] = PNULL;	/* String ptr LOOKUP filename*/
	mapCnIbuf[chan] = nIbuf;        /* # of input blocks/buffer */
	mapCnObuf[chan] = nObuf;        /* # of output blocks/buffer */
	mapCoCtr[chan] = 0;		/* chars put in output buffer*/
	mapCoPtr[chan] = 0;		/* pointer to output buffer */
	mapCsawEof[chan] = 0;		/* saw EOF on read() */

	if (ioMode < 015)
		{ /* allocate dynamic buffer space if needed */
		if (nIbuf>0) 
		    mapCiPtr[chan]=Pmalloc(nIbuf*CHRSPERBLOCK);
		if (nObuf>0) 
		    mapCoPtr[chan]=Pmalloc(nObuf*CHRSPERBLOCK);
		} /* allocate dynamic buffer space if needed */

	if (mapCCDBptr[chan]==0)
	    mapCCDBptr[chan] = (INTEGER *)Pmalloc(sizeof(CDB));

	chncdb(chan);			/* set up the CDB contents */

} /* PSOPEN */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL out.						*/
/*	IFF ioMode is ASCII I/O mode < 02!!!			*/
/*								*/
void PROCEDURE out(chan,str)
	INTEGER chan;
	STRING	str;		/* string to output */
{ /* OUT */
	int	bufSize,	/* maximum output buffer size */
	 	fd,		/* file descriptor */
		i,		/* offset into output buffer */
		ioMode,		/* TOPS10 I/O mode */
		n,		/* octal # nnn if '\nnn' */
		nObuf;		/* number of output buffers */
	char 	c;		/* current character being moved */
	STRING	p;		/* string pointer to output buffer */

	GC_POPS(str);	/* get arg from temp string var. PDL */

	if (chkChan(chan,"OUT"))
		return;			/* bad channel #? */

	fd=mpCFdO[chan];
	if (fd==0)
		{usererr(chan,1L,GC_PUSHS(
			"OUT channel never ENTERed, channel #"));
		return;
		}

	p=mapCoPtr[chan];
	nObuf=mapCnObuf[chan];
	if (p==0 || nObuf==0)
		{usererr(chan,1L,
		GC_PUSHS("OUT no output buffer specified, channel #"));
		return;
		}

	ioMode=mapCioMode[chan];
	if (ioMode < 02)
		{usererr(chan,1L,
		   GC_PUSHS("OUT non-ASCII I/O mode for channel #"));
		return;
		}

	bufSize = nObuf*CHRSPERBLOCK;  		/* max count */ 

	while ((c = *(str++)) != '\0')
		{ /* Stuff chars from str into output buffer */
		/* If c='\' then expand it to single ASCII char */
		if (c=='\\')
			{ /* '\<code>' to ASCII character */
			c = *(str++);	/* get next char */
			if (isoctal(c))
				{ /*get octal number*/
				n = c -'0';
				while (isoctal(*str))
					n = n*8 + (*(str++) - '0');
				c = n;	/* is actual character */
				} /*get octal number*/
			else if (c=='n') c=012;
			else if (c=='r') c=015;
			else if (c=='f') c=014;
			else if (c=='t') c=011;
			} /* '\<code>' to ASCII character */
		i=mapCoCtr[chan]++;		/* byte index */
		*(p+i) = c;			/* save single byte */
		if (mapCoCtr[chan] == bufSize)
			PflushBuf(chan);	/* empty it*/
		} /* Stuff chars from str into output buffer */
} /* OUT */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL outchr						*/
/*								*/
void PROCEDURE outchr(intVal)
	INTEGER intVal;
{ /* OUTCHR */
#ifndef HASANSIC
	putchar((char)intVal);
#endif
#ifdef HASANSIC
	putchar((int)intVal);
#endif

/*  @@@ OR
	putc((int)intVal,STDIO);
*/
} /* OUTCHR */


/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
/*	Do output to terminal or SETPRINT file if previously	*/
/*	set up.							*/
/*								*/
static void PROCEDURE outprint(c)
	char c;
{ /* OUTPRINT */
	static char c2[2] ={'\0', '\0'};

	if ((pMode=='t') || (pMode=='c') || (pMode=='o') ||
	    (pMode=='b'))
		outchr((INTEGER)c);
	if ((pMode=='f') || (pMode=='b'))
		{c2[0]=c; 	/* build single char string */
		 out(pChan,c2);
		}
} /* OUTPRINT */



/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*
.LABEL [<PSRUN7-PSPRINTF>]
*/
/*	PSAIL formatted print function similar to K&R's 	 */
/*	printf() function desribed in K&R page 146.		 */
/*								 */
/*	This procedure is derived from the printf() function	 */
/*	written for the midiC <stdio.c> package, the printf()	 */
/*	written by Hendrix (DDJ #75) for the small-C V.2 library,*/
/*	and specifications for the proposed X3J11 ANSI C	 */
/*	standard. These were the basis for the PSAIL PSprintf()  */
/*	function.						 */
/*	NOTE: Any '%<spec>' where <spec> is illegal is ignored	 */
/*	and printed as a comment string.			 */
/*	Note that the formal control string is NOT pushed onto	*/
/*	the temp string var PDL while all other string args are. */
/*								 */
/*	The variable number of arguments is fetched using the	 */
/*      variable argument list macros. Their definitions are     */
/*      taken from a discussion of ANSI C by Allen Holub         */
/*      in DDJ, Aug 1987 pp100-108 entitled:                     */
/*          "Subroutines with A Variable Number of Arguments"    */
/*								 */
/*	It handles all C format types and outputs to either the  */
/*	terminal or channel using the 'outprint()' function.	 */
/*								 */
/*	The major differences between this function and that of  */
/*      K&R are:                                                 */
/*          (1) the width and precision need not be specified    */
/*              in the %format spec. as they are by SETFORMAT(). */
/*          (2) the output device may be set to the TTY and or   */
/*              FILE using SETPRINT().                           */
/*								 */
/*	Rather they are sticky and specified as in SAIL using 	 */
/*		SETFORMAT(width,precision)			 */
/*	which sets the <sairun.c> global variables:		 */
/*		p_width and p_prec				 */
/*								 */
/*	Format specifications:					 */
/*	----------------------					 */
/*	<control-string>::= <conversn-spec> | 			 */
/*			    <conversn-spec><control-string>	 */
/*	<conversn-spec>::= %<format-spec><convrsn-char> |	 */
/*			   <text>				 */
/*	<format-spec>::=('-' if left justify to width)		 */
/*			('0' = pad with leading zeros) 		 */
/*			(field width decimal number) 		 */
/*			('.' if will specify precision field)	 */
/*			(optional precision decimal number)	 */
/*			('l' or 'L' if field is long instead int)*/
/*	<convrsn-char>::= i or I (decimal signed int)		 */
/*			| l Or L (decimal signed long INTEGER)	 */
/*			| o Or O (unsigned octal w/o leading 0)	 */
/*			| x or X (unsigned hex w/o leading 0X)	 */
/*			| u or U (unsigned decimal)		 */
/*			| c or C (single character)		 */
/*			| b or B (8-bit unsigned char)		 */
/*			| p or P (generic pointer)		 */
/*			| s or S (string up to NULL i.e. '\0')   */
/*			| e (float cvt to [-]m.nnnnn[+/-]xx 	 */
/*				where length of n's is precision)*/
/*			| f (float cvt to [-]mmm.nnnnn 		 */
/*				where length of n's is precision)*/
/*			| g (print %e or %f whichever is shorter)*/
/*			| E (double cvt to [-]m.nnnnn[+/-]xx	 */
/*				where length of n's is precision)*/
/*			| d or F (double cvt to [-]mmm.nnnnn 	 */
/*				where length of n's is precision)*/
/*			| G (print %E or %F whichever is shorter)*/
/*								 */
/*	Example: PSprintf("..ctrl str...",v1,v2,v3);		 */
/*	eg. PSprintf("%d%s%f%s",i," is not EQU to ",f,CRLF);	 */
/*								 */
/*	The number of arguments is determined by counting '%' in */
/*	the format control string 'ctl'. If you can't count YOU  */
/*      WILL PROBABLY DIE.                                       */
/*
.ENDLABEL
*/
/*								 */
void PROCEDURE PSprintf(ctl)
	PS_VA_DCL ctl;		/* points to arg stack & <ctrl-string> */
{ /* PSPRINTF */
	PS_VA_LIST argp;	/* pointer to current arg */
	int	i,		/* temp variable */
		k,		/* temp variable */
		len,		/* length of cvted arg to print */
		n,		/* working string stack arg count*/
		nArgs,		/* # of '%' found in format string */
		nStrArgs,	/* count of string stack's count */
	 	prec,		/* current argument precision */
		width;		/* current argument width */
	STRING	cx,		/* current <conversion-spec> string */
		sPtr;		/* pointer to cvted string to print */
	char	c,		/* working control character */
		pad,		/* padding character '0' or ' ' */
		right;		/* right justify FLAG */
#define MAXDIGITS 29		/* Note: 2**64 is about 19 digits,
				 * then '+0.<19-digits>E+<4-digits>' */
   static char	s1[MAXDIGITS],	/* e/E-format convsn buffer */
		s2[MAXDIGITS];  /* g/G-format convsn buffer */

/*      [1] Setup control string counters and print what we can. */
        PS_VA_START(argp,ctl);  /* setup variable arg list pointer */
	nStrArgs = n = 0;	/* count # string stack args by %s's */
	nArgs = n = 0;		/* count # '%'s */
	sPtr = ctl;		/* scan the string for '%s' */
	while (c = *(sPtr++))
		if (c='\\') 
		        sPtr++; 	/* skip special characters */
		else if (c=='%') 
			{/* handle '%' */
			if (*sPtr == '%') 
			       sPtr++;
			else nStrArgs++;
			}/* handle '%' */


/*	[2] For each argument, get the corresponding control	*/
/*	    string. Then process the argument accoringly.	*/
	while (((c = *(ctl++))!=0) && (c!='\0'))   /*i.e. spec exists*/
		{ /* PROCESS next argument */

/*	[2.1] Reset the default print format width and precision */
/*	      in case they are not specified in <format-spec>.	*/
		width=p_width;	/* default to 13, use setformat(w,-) */
		prec=p_prec;	/* default to 8, use setformat(-,p) */

/*	[2.2] Print <text> NOT part of <format-spec>.		*/
		if (c!='%')
			{ /* FORMAT-COMMENT*/
			outprint(c);
			continue;
			} /* FORMAT-COMMENT*/

/*	[2.3] Handle special case of '%%' printed as '%'.	*/
		if (*ctl=='%')
			{outprint(*(ctl++)); continue;}

/*	[2.4] Process next arg pointer using current format	*/
/*	      specification pointed to by 'ctl'.		*/
		cx=ctl; 	/* copy conversion spec ptr */

/*	[2.4.1] Test if LEFT or RIGHT justify output string.	*/
		if (*cx=='-')
			{right=FALSE; ++cx; /* LEFT justify */} 
		else right=TRUE;	/* right justification */

/*	[2.4.2] Test if pad output string with spaces or '0's.	*/
		if (*cx=='0') 
			{pad='0'; ++cx;} 
		else pad=' ';		/* SPACE padding character */

/*	[2.4.3] If <width> specified, then get it.		*/
		if (isdigit(*cx))
			{ /* GET <width>-spec */
			if ((width=Patoi(cx)) >= 0)
			while (isdigit(*cx))
				cx++; 		/* skip past it */
			else continue;  /* get number width */
			} /* GET <width>-spec */

/*	[2.4.4] The '.' indicates have a <precision> specification. */
		if (*cx=='.')
			{ /* GET-<prec>-spec */
			if ((prec=Patoi(++cx))>=0)
				while (isdigit(*cx)) 
				        cx++;
			else continue; /* get float precision */
			} /* GET-<prec>-spec */


/*	[2.5] Now convert number arg by format type		*/
		sPtr = &s1[0];	/* set ptr to output buffer string */
		c = *cx++;	/* get format-type character */

/*	[2.5.1] Now convert the argument according to format-type */
/*		NOTE: ORDER these tests by frequency of usage.	*/
/*		I.e. in PSAIL it would be %l, %s, %c, %f and %d	*/
/*		which are set by PSAIL compiler procedure 	*/
/*		CV!PRINT!ARGLIST by the type of the evaluated	*/
/*		argument.					*/
		switch (c)
		  { /* EVAL %<type> */
		    case 'l': case 'L':    /*LONG */
			{Pltoa(PS_VA_ARG(argp,INTEGER),sPtr);
			 c='l'; break;
		        }

		    case 's': case 'S':    /* STRING */
			{ /* STRING */
			 sPtr=PS_VA_ARG(argp,STRING);
			 GC_POPS(sPtr);     /* get n'th temp string PDL*/
			 c='s'; break;
			}

		    case 'c': case 'C':    /* CHAR */
			{s1[0] = PS_VA_ARG(argp,int);
			 s1[1]='\0';
			 c='c'; break;
			}

		    case 'f': case 'F':    /* FLOAT */
			{Pftoa((float)PS_VA_ARG(argp,double),s1,width,prec);
			c='f'; break;
			}

		    case 'd': case 'D':    /* DOUBLE */
			{Pdtoa(PS_VA_ARG(argp,double),s1,width,prec);
			c='d'; break;
			}

/*	>>> The following conversions are frosting on the cake. <<<
*	>>> They are not used by PSAIL PRINT statement. 	<<<
*/
		    case 'x': case 'X':    /* HEX */
			{Phtoa(PS_VA_ARG(argp,INTEGER),sPtr); c='x'; break;}

		   case 'o': case 'O':     /* OCTAL */
			{Potoa(PS_VA_ARG(argp,INTEGER),sPtr); c='o'; break;}

		   case 'i': case 'I':     /* INT */
			{Pitoa(PS_VA_ARG(argp,int),sPtr); c='i'; break;}

		   case 'b': case 'B':     /* BYTE */
			{i= PS_VA_ARG(argp,int);
			Pitoa(i,sPtr); c='b'; break;
			}

		   case 'p': case 'P':     /* POINTER */
			{Potoa(PS_VA_ARG(argp,INTEGER),sPtr); c='p'; break;}

		   case 'u': case 'U':     /* UNSIGNED */
			{Putoa(PS_VA_ARG(argp,INTEGER),sPtr);
			c='u'; break;
			}
			
		   case 'e':               /* E-FLOAT */
			{Petoa((float)PS_VA_ARG(argp,double),s1,width,prec);
			 break;
		        }

		   case 'g':               /* G-FLOAT */
			{Pftoa((float)PS_VA_ARG(argp,double),s1,width,prec);
			 Petoa((float)PS_VA_ARG(argp,double),s2,width,prec);
			 if (length(GC_PUSHS(s2))<length(GC_PUSHS(s1)))
				 sPtr = &s2[0]; /* use other buf-ptr */
			 break;
			}

		   case 'E':               /* E-DOUBLE */
			{Pdetoa(PS_VA_ARG(argp,double),s1,width,prec); break;}

		   case 'G':               /* G-DOUBLE */
			{Pdtoa(PS_VA_ARG(argp,double),s1,width,prec);
			 Pdetoa(PS_VA_ARG(argp,double),s2,width,prec);
			 if (length(GC_PUSHS(s2))<length(GC_PUSHS(s1)))
				 sPtr = &s2[0]; /* use other buf-ptr */
			 break;
			}

		default: continue;		/* if we get here then 
					 * invalid &<spec>.
					 */
		  } /* EVAL %<type> */


/*	[2.6] We have accepted the conversion string and now 	*/
/*	      advance the 'ctl' string.				*/
		ctl=cx; /*accept conversion spec */

/*	[2.6.1] If the arg is NOT a STRING then ignore leading	*/
/*	spaces in the output string 'sPtr' since we will put	*/
/*	them in ourselves.					*/
		if (c!='s')
			while (*sPtr==' ')
			        ++sPtr; /* skip spaces*/

/*	[2.6.2] Get the actual length of the output string.	*/
		len = -1;	/* Will be > 0 for Non-strings */
		if (c!='s') 
			while (sPtr[++len])
			        ; /* get actual length */

/*	[2.6.3] If not a STRING set the length of string to print. */
		if ((c!='s') && (len>prec))
			len=prec;	/* use the shorter value */

/*	[2.6.4] Do RIGHT-JUSTIFY if required - but not for STRINGS */
		if (right && (c!='s')) 
			{ /* RIGHT-JUSTIFY */
			while (((width--)-len)>0)
				outprint(pad);
			} /* RIGHT-JUSTIFY */

/*	[2.6.5] Now print the buffer.				*/
		while (len && (*sPtr!='\0'))
			{char c;	/* copy so can test it */
			c = *(sPtr++);
			/* If c='\' then expand it to single ASCII 
			 * character.
			*/
			if (c=='\\')
				{ /* '\<code>' to ASCII character */
				c = *(sPtr++);	/* get next char */
				if (isoctal(c))
					{ /*get octal number*/
					n = c -'0';
					while (isoctal(*sPtr))
						n = n*8+(*(sPtr++)-'0');
					c = n;  /* is actual char */
					} /*get octal number*/
				else if (c=='n') c=012;
				else if (c=='r') c=015;
				else if (c=='f') c=014;
				else if (c=='t') c=011;
				} /* '\<code>' to ASCII character */
			outprint(c);
			--len;
			--width;
			}

/*	[2.6.6] If there is any width left, then right-fill with */
/*	spaces.							 */
		if (c!='s')
			while (((width--)-len)>0)
				outprint(pad); 
		} /* PROCESS next argument */
if (n>0)
        GC_SADJN(n);  /* remove string args from temp string PDL */
} /* PSPRINTF */



/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL realin.						*/
/*								*/
float PROCEDURE realin(chan)
	INTEGER chan;
{ /* REALIN */
	STRING nbr;			/* string input from file */
	float n;			/* number scanned from string*/

	if (chkChan(chan,"REALIN"))
		return(0.0); 		/* bad channel #? */
	if (fBrkTable==0)
		{fBrkTable=55;	/* set up internal SCAN table */
		setbreak(fBrkTable,GC_PUSHS("0123455789+-.Ee@"),
				GC_PUSHS(" \t\r\n\14"),GC_PUSHS("XNR"));
						/* to scan a real */
		}
	nbr = input(chan,fBrkTable);    /* scan until NON-float */
	n = Patof(nbr);			/* CVT numeric str to float */
	return(n);
} /* REALIN */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL relchan.					*/
/*								*/
void PROCEDURE relchan(chan)
	INTEGER chan;
{ /* RELCHAN */
	if (0<=chan && chan<=MAXCHAN && freeChan[chan])
		{ /* free the channel number */
/* ===> ??? possible conflict if don't do a PSclose() !!! ??? <===
		close(chan);
*/
		freeChan[chan]=0; 	/* clear flag */
		} /* free the channel number */
} /* RELCHAN */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL release.					*/
/*								*/
void PROCEDURE release(chan)
	INTEGER chan;
{ /* RELEASE */
	STRING	p;		/* buffer ptr for I/O buffers */

	if (chkChan(chan,"RELEASE"))
		return; 		/* bad channel #? */
	PSclose(chan);		/* close both input and output channels */
	if (mapCiPtr[chan] != 0) 
		{p=mapCiPtr[chan];
		Pfree(p);
		mapCiPtr[chan]=0;
		}
	if (mapCoPtr[chan] != 0) 
		{p=mapCoPtr[chan];
		Pfree(p);
		mapCoPtr[chan]=0;
		}
	if (mapCCDBptr[chan] != 0) 
		{Pfree((STRING)mapCCDBptr[chan]);   /*free up CDB*/
		mapCCDBptr[chan]=0;
		}
				/* Clear rest of CDB */
	freeChan[chan]=0;
	mapCBrkVar[chan] = 0;
	mapCcount[chan] = 0;
	mapCDevice[chan] = PNULL;
	mapCEName[chan] = PNULL;
	mapCEofVar[chan] = 0;
	mapCerrCode[chan] = 0;
	mpCFdI[chan] = 0;
	mpCFdO[chan] = 0;
	mapCiCtr[chan] = 0;
	mapCioMode[chan] = 0;
	mapCiPtr[chan]=0;
	mapCLName[chan] = PNULL;
	mapCnIbuf[chan] = 0;
	mapCnObuf[chan] = 0;
	mapCoCtr[chan] = 0;
	mapCoPtr[chan]=0;
	mapCprotect[chan]=0;
	mapCsawEof[chan]=0;
} /* RELEASE */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL rename.						*/
/*								*/
void PROCEDURE PSrename(chan,filename)
	INTEGER chan;
	STRING filename;	/* filename to rename current channel */
{ /* PSRENAME */
	int	didRenameFlag;	/* in case a problem */

	GC_POPS(filename);	/* get arg from temp string var. PDL */

	if (chkChan(chan,"RENAME"))
		return; 		/* bad channel #? */

	if (*mapCEName[chan] == '\0')
		{ /* No file was entered */
		usererr(chan,1L,GC_PUSHS(
		   "RENAME illegal, need previous ENTER, channel #"));
		} /* No file was entered */

	didRenameFlag=FALSE;
#ifdef HASRENAME
	rename(mapCEName[chan],filename);
	didRenameFlag=TRUE;
#endif
#ifdef HASCIO
	rename(chan,filename);
	didRenameFlag=TRUE;
#endif

#ifdef HASANSIC
/* If no function to do it, then possibly do it with a file copy */
	didRenameFlag=FALSE;
#endif

	if (! didRenameFlag)
		{usererr(chan,1L,
		   GC_PUSHS("RENAME(chan,file) not implemented yet!"));
		return;
		}
mapCEName[chan] = filename;	/* use new name */
} /* RENAME */



/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/* Do extended ENTER setting the protection bits.                    */
/* Note that the low 9-bits for TOPS-10 are the same as for UNIX -   */
/* LUCK-OUT!!! This simulates doing an extended TOPS-10 ENTER UUO on */
/* the file but with protection bits being specified.                */
/*                                                                   */
void senter(chan,file,protection,err)
	INTEGER chan;
	STRING file;
	INTEGER protection;
        INTEGER *err;
{ /* SENTER */

        GC_POPS(file); /* from GC string PDL */
	GC_MARKSSTKFRAME;   /* Mark G.C. STACK-FRAME */
	GC_NOTESTRING(file); /* for G.C. */

/*  -- NOTE use UNIX chmod(char *path,int mode) or fchmod(fd,mode)  */
	mapCprotect[chan] = protection;     /* save in state */
	enter(chan,GC_PUSHS(file),&err);
	chmod(file,(int)protection);

	GC_UNMARKSSTKFRAME;
}/* SENTER */



/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL setprint.					*/
/*	Implements SETPRINT function [REISER] pages 53-55	*/
/*	MODE	Function					*/
/*	----	--------					*/
/*	T	terminal gets all PRINT output. Close output	*/
/*		file if it was opened. T is default mode.	*/
/*	F	File gets PRINT output. Open file if needed.	*/
/*	B	Both terminal and file get PRINT out. Open file	*/
/*		if needed.					*/
/*	N	Neither file nor terminal get. Close file if 	*/
/*		it was open.					*/
/*	S	Suppress all output, but open file if not open.	*/
/*	O	a file is open, but terminal is getting all 	*/
/*		output. If not file is open then open one.	*/
/*	C	the terminal gets output, but ignore whether or	*/
/*		not a file is open and whether or not it is	*/
/*		getting output.					*/
/*	I	terminal does not get output. Ignore whether or	*/
/*		not a file is open and whether it gets output.	*/
/*								*/
void PROCEDURE setprint(file,mode)
	STRING file, mode;
{ /* SETPRINT */
	char ch;

	GC_POPS(file);
	GC_POPS(mode);
	pMode = *mode;
	if (('A' <= pMode)&&(pMode<='Z')) 
		pMode=cvlower(pMode);	/* lower case only */

	if((pMode=='n') || (pMode=='t'))
		{if (pChan != -1) release(pChan);
		 return;
		}

	if((pMode=='f') || (pMode=='o') || (pMode=='b') ||
	   (pMode=='s'))
		{if (pChan != -1) return;
		 pChan = PSgetchan();	/* get new channel */
		 if(*file == '\0')
			{STRING msg;
			 msg="File for PRINT output *";
			 while ((ch = *(msg++)) !='\0') 
					outchr((INTEGER)ch);
			 file = inchwl();	/* get file name */
			}
		PSopen(pChan,GC_PUSHS("DSK"),0L,0L,
					1L,&pCnt,&pBrk,&pEof);
		if (pEof) 
		  {return;}
		enter(pChan,file,&pErr);
		if (pErr)
		  {close(pChan); return;}
		}
} /* SETPRINT */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL ttyup.						*/
/*	Set tty input case conversion true or false, return old */
/*	value 							*/
/*								*/
INTEGER PROCEDURE ttyup(flag)
	INTEGER flag;
{ /* TTYUP */
	INTEGER oldValue;

	oldValue = ttyCase;
	ttyCase = flag;
	return(oldValue);
} /*TTYUP */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL usererr.					*/
/* NOTE: would be nice to be able to pass PSprintf() lists on	*/
/*	to give us more flexible and better messages.		*/
/*								*/
void PROCEDURE usererr(value,code,msg)
	INTEGER value,			/* value to be printed */
		code;			/* dispostion code:
					*	0 = call 'exit'
					*	1 = return to user 
					*	    after CR<==TTY.
					*/
	STRING	msg;			/* message to be printed */
{ /* USERERR */
	STRING answer;			/* response */

	GC_POPS(msg);	/* get arg from temp string var. PDL */
	PSprintf("\nUSERERR[0L%o, %s]\n",value,GC_PUSHS(msg));
	if (code==0)
	        PEXIT;	        	/* return to the system */
	else if (code==1)
		{PSprintf("Type RETURN to continue?");
		answer=inchwl();	/*wait for return */
		return;
		}
} /* USERERR */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL useti.						*/
/*	map 	USETI(chan,blkNbr) 	 			*/
/*	to	lseek(fd,(INTEGER)bytePtr,relMode)		*/
/*								*/
void PROCEDURE useti(chan,blkNbr)
	INTEGER chan, blkNbr;
{ /* USETI */
	if (chkChan(chan,"USETI"))
		return;			/* bad channel #? */
	if (mapCioMode[chan]==017)
		{
#ifdef HASANSIC
		fseek(mapCFILE[chan],(long int)(blkNbr*512),0);
#endif
#ifdef HASFSEEKBYTE
		fseek(mapCFILE[chan],(int)(blkNbr*512),0);
#endif
#ifdef HASLSEEKBYTE
		lseek((int)mpCFdI[chan],(int)(blkNbr*512),0);
#endif
#ifdef HASSEEKBYTE
		seek(mpCFdI[chan],(int)(blkNbr*512),0);
#endif
#ifdef HASSEEKBLOCK
		seek(mpCFdI[chan],blkNbr);  /* sargasso */
#endif
#ifdef HASLSEEKBLOCK
		lseek(mpCFdI[chan],blkNbr);  /* sargasso */
#endif
		}
	else 	{usererr(chan,1L,
		   "USETI illegal since NOT in DUMP mode, channel #");
		return;		/* only do USETI/O in DUMP mode */
		}
} /* USETI */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL useto.						*/
/*	map 	USETO(chan,blkNbr) 	 			*/
/*	to	lseek(fd,(INTEGER)bytePtr,relMode)		*/
/*								*/
void PROCEDURE useto(chan,blkNbr)
	INTEGER chan, blkNbr;
{ /* USETO */
	if (chkChan(chan,"USETO"))
		return;			/* bad channel #? */
	if ((mapCioMode[chan] & 017) == 017)
		{
#ifdef HASANSIC
		fseek(mapCFILE[chan],(long int)(blkNbr*512),0);
#endif
#ifdef HASLSEEKBYTE
		fseek(mapCFILE[chan],(int)(blkNbr*512),0);
#endif
#ifdef HASLSEEKBYTE
		lseek((int)mpCFdO[chan],(int)(blkNbr*512),0);
#endif
#ifdef HASSEEKBYTE
		seek(mpCFdO[chan],(int)(blkNbr*512),0);
#endif
#ifdef HASSEEKBLOCK
		seek(mpCFdO[chan],blkNbr);  /* sargasso */
#endif
#ifdef HASLSEEKBLOCK
		lseek(mpCFdO[chan],blkNbr);  /* sargasso */
#endif
		}
	else 	{usererr(chan,1L,
		   "USETO illegal since NOT in DUMP mode, channel #");
		return;	/* only do USETI/O in DUMP mode */
		}
} /* USETO */

/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL wordin.						*/
/*	Map	WORDIN(chan)					*/
/*	to		arryin(fd, &buf, 1)			*/
/*								*/
INTEGER PROCEDURE wordin(chan)
	INTEGER chan;
{ /* WORDIN */
	INTEGER data;

	if (chkChan(chan,"WORDIN")) 
		return(0L);		/* bad channel #? */
	arryin(chan,&data,1L);
	return(data);
} /* WORDIN */


/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*	Do SAIL wordout.					*/
/*	Map	WORDOUT(chan)					*/
/*	to		arryout(fd, &buf, 1)			*/
/*								*/
void PROCEDURE wordout(chan,data)
	INTEGER chan;
	INTEGER data;
{ /* WORDOUT */
	if (chkChan(chan,"WORDIN")) 
		return;			/* bad channel #? */
	arryout(chan,&data,1L);
} /* WORDOUT */


#undef PACKINGFACTOR
#undef CHRSPERBLOCK
#undef MAXCHAN
/* ---> END OF PSRUN7.C <--- */
