/*         File: PSRUNL.H                                 */
/*                                                         */
/*        SAIL LEAP compatibility package for PSAIL        */
/*                                                         */
/*                                                         */
/*        P. Lemkin                                        */
/*        Image Processing Section                         */
/*        National Cancer Institute, DCBD, LTB             */
/*        FCRF, Build 469 Room 150B			   */
/*        Frederick, MD 21701				   */
/*                                                         */
/*        Version: 57.10                                   */
/*                                                         */
/*        Revised September 7, 1986                        */
/*        Revised June 30, 1987                            */
/*        Revised November 11, 1986                        */
/*        Revised September 20, 1986                       */
/*        Revised September 19, 1986                       */
/*        Revised August 12, 1986                          */
/*        Revised April 6, 1986                            */
/*        Revised March 8, 1986                            */
/*        Revised March 5, 1986                            */
/*        Revised November 20, 1985                        */
/*        Revised July 26, 1985                            */
/*        Revised June 30, 1985                            */
/*        Revised June 25, 1985                            */
/*        Revised June 7, 1985                             */
/*        Revised March 18, 1985                           */
/*        November 13, 1984                                */
extern char *v_psrunl;	/*Version of PSAIL expected */

/*
*    COPYRIGHT NOTICE - Copyright (c) 1983-1987 by Peter F. Lemkin.
*                     All rights reserved.
*       Permission is granted to any individual or institution to
*       copy, use or modify this program, except for explicitly
*       commercial purposes, provided this copyright notice is
*       included in its entirety in all derived works.  No warranty
*       of the software or of the accuracy of any documentation
*       surrounding it is expressed or implied, and the author does
*       not acknowledge any liability resulting from program or
*       documentation errors.
*/
/*                                                        */
#define LEAP_RUN 1		/* needed for testing with #includes */
/*                                                        */
#ifndef HASCONFIG 	/* primary configurations */
#include "config.h"  /* get it from this area when compile runtimes! */
#endif
/*                                                        */
ITEMVAR catLLIST();   /* concat LEAP lists (iv1, iv2, ...,0)*/
ITEMVAR copLIST();    /* return the first item of the list iv*/ 
ITEMVAR copSET();     /* return the first item of the set iv*/
LIST copyLIST();      /* return a copy of LIST iv*/
SET copySET();        /* return a copy of SET iv*/
INTEGER cvi();        /* convert ITEM i to INTEGER type*/
STRING cvis();        /* convert ITEM i==>STRING, flag if err.*/
ITEM cvn();           /* convert INTEGER number n to ITEM type*/
LIST cvlist();        /* convert SET to a LIST*/
SET cvset();          /* convert LIST to a SET*/
ITEM cvsi();          /* convert STRING *s==>ITEM, flag if err*/
INTEGER *datum();     /* return datum assoc. with item iv*/
STRING *datumC();     /* return STRING datum assoc. w/ITEM iv */
double *datumD();     /* return double datum assoc. w/ITEM iv*/
EVENT *datumE();      /* return EVENT datum assoc. w/ITEM iv*/
float *datumF();      /* return float datum assoc. w/ITEM iv*/
INTEGER *datumI();    /* return INTEGER datum assoc. w/ITEM iv*/
LIST *datumL();       /* return LIST datum assoc w/ITEM iv*/
OBJECT *datumO();     /* return OBJECT datum assoc. w/ITEM iv*/
void *(datumP());     /* return PROCED. datum assoc. w/ITEM iv*/
INTEGER *datumQ();    /* return REC PTR datum assoc. w/ITEM iv*/
SET *datumS();        /* return SET datum assoc. w/ITEM iv*/
ITEMVAR *datumV();    /* return ITEMVAR datum assoc. w/ITEM iv*/
ITEMVAR *datumX();    /* return ITEM datum assoc. w/ITEM iv*/
SET defSET();         /* construct explicit Leap SET*/
LIST defLIST();       /* construct explicit Leap LIST*/
void delItem();       /* delete ITEM iv*/
void erase();         /* erase triple (att,obj,value)*/
LIST explicitLIST();  /* construct explicit list*/
ITEM fetchIndexed();  /* return n'th ITEM from list iv*/
ITEMVAR fndIN();      /* find any itemvar x in set or list S*/
ITEMVAR fndT();       /* find any itemvar A XOR O EQU V else 0*/
SET fnd1T();          /* find any set of a XOR O EQU V else PHI*/
SET fnd2T();          /* find any set of A XOR o EQU V else PHI*/
SET fnd3T();          /* find any set of A XOR O EQU v else PHI*/
SET fnd12T();         /* find any set of a XOR o EQU V else PHI*/
SET fnd13T();         /* find any set of a XOR O EQU v else PHI*/
SET fnd23T();         /* find any set of A XOR o EQU v else PHI*/
SET fnd123T();        /* find any set of a XOR o EQU v else PHI*/
ITEMVAR first();      /* return attribute of triple iv*/
INTEGER foreach();    /* SAIL FOREACH loop generator*/
INTEGER inLIST();     /* test if ITEM ivE in list ivList*/
INTEGER inSET();      /* test if ITEM ivE in set ivSet*/
INTEGER istriple();   /* return TRUE if ITEMVAR iv==brkt-triple*/
INTEGER lenLIST();    /* return length of list iv*/
INTEGER lenSET();     /* return length of set iv*/
LIST listDiff();      /* return list difference of iv1 and iv2*/
INTEGER listEqu();    /* return TRUE if iv1 and iv2 are same*/
LIST listInter();     /* return intersection of iv1 and iv2*/
LIST listUnion();     /* return Union of lists iv1 and iv2*/
ITEMVAR lopITEM();    /* return 1st ITEM, shorten list/set iv*/
ITEMVAR lopLIST();    /* return 1st ITEM of list iv, shorten iv*/
ITEMVAR lopSET();     /* return 1st ITEM of set iv, shorten iv*/
void make();          /* make triple (att,obj,value)*/
void mkItem();        /* create SET, LIST, ITEM id w/descr-word*/
ITEMVAR newitem();    /* return a new ITEM number*/
ITEMVAR newExample(); /* return new ITEM copy of id w/same type&size*/
void new_pname();     /* set ITEM i's print name to STRING s*/
INTEGER props();      /* return INTEGER value of ITEM iv*/
void put();           /* put ITEM x in set  or list y*/
void putafter();      /* put ITEM x in set y after z*/
void putbefore();     /* put ITEM x in set y before z*/
void putIndexed();    /* put ITEM x in set y before element n*/
void remAll();        /* remove all element x from list ivList*/
void remIndexed();    /* remove element n from list ivList*/
void remList();       /* remove ITEM x from list ivList*/
void remListAll();    /* remove All of ITEM x from list ivList*/
void remSet();        /* remove ITEM x from set ivSet*/
INTEGER sameiv();     /* return true if ITEM iv1 = ITEM iv2 */
void saveDatum();     /* save value into datum of ITEM iv*/
SET setDiff();        /* return set difference of sets iv1&iv2*/
INTEGER setEqu();     /* return TRUE if iv1 and iv2 are same*/
SET setInter();       /* return intersection of sets iv1&iv2*/
SET setUnion();       /* return Union of sets iv1 and iv2*/
ITEMVAR second();     /* return object of triple iv*/
ITEMVAR third();      /* return value of triple iv*/
INTEGER typeit();     /* return type code of datum of ITEM iv*/
/* ---> END OF PSRUNL.H <--- */
