/*         File: PSRUNP.H                                    */
/*                                                           */
/*        PSAIL PROCESSES, EVENTS and INTERRUPTS package     */
/*                                                           */
/*                                                           */
/*        P. Lemkin                                          */
/*        Image Processing Section                           */
/*        National Cancer Institute, DCBD, LTB               */
/*        National Institutes of Health                      */
/*        FCRF Bld 469 Rm 150B                               */
/*        Frederick, MD 21701                                */
/*                                                           */
/*        Revised September 7, 1987                          */
/*        Revised January 26, 1987                           */
/*							     */
extern char *v_psrunp;	/*Version of PSAIL expected */

/*
*    COPYRIGHT NOTICE - Copyright (c) 1983-1987 by Peter F. Lemkin.
*                     All rights reserved.
*       Permission is granted to any individual or institution to
*       copy, use or modify this program, except for explicitly
*       commercial purposes, provided this copyright notice is
*       included in its entirety in all derived works.  No warranty
*       of the software or of the accuracy of any documentation
*       surrounding it is expressed or implied, and the author does
*       not acknowledge any liability resulting from program or
*       documentation errors.
*/
/*                                                                */
#ifndef HASCONFIG               /* primary configurations */
#include "config.h"             /* get it from this area when compile runtimes*/
#endif

/* P. PROCESSES, EVENTS and INTERRUPTS package */
INTEGER answer(); /* wake up procedure */
void apply();     /* apply procedures to arglist */
ITEM arg_list();  /* return variable length arg list item */
void asktnc();    /* interrogate event type */
void assign();    /* assign procedure name to item */
ITEM caller();    /* return calling process of process item arg */
void cause();     /* eval wait queue */
void cause1();    /* wakeup process */
void dfrint();    /* queue deferred interrupt */
void dfr1in();    /* record deferred interrupt pointer */
ITEM interrogate(); /* examine event queue */
void intpro();    /* interrupt process */
void intset();    /* sprout interrupt process intpro() */
void inttbl();    /* change size of deferred interrupt queue */
void join();      /* wait until all process items terminate */
void mkevtt();    /* return item as event notice type item */
ITEM myproc();    /* return process item it is being executed in */
void priset();    /* set priority of process */
INTEGER pstatus(); /* return scheduling state of process */
ITEM ref_item();  /* set type of item to 'reference' */
ITEM resume();    /* restore suspended process */
void setcp();     /* associate process with 'cause' event type */
void setip();     /* associate process with 'interrogate' event type */
void sprout();    /* fork a process */
ITEM suspend();   /* suspend a running process */
void terminate(); /* terminate a running process */
void urschd();    /* force SAIL process scheduler to schedule */

/* ----> END OF PSRUNP.H < ---- */



