/* 	File: PSRUNW.H 						*/
/*								*/
/*	SAIL PROFILING compatibility package for PSAIL 		*/
/*								*/
/*								*/
/*        P. Lemkin                                               */
/*        Image Processing Section                                */
/*        National Cancer Institute, DCBD, LTB                    */
/*        FCRF, Build 469 Room 150B			   	*/
/*        Frederick, MD 21701				   	*/
/*								*/
/*	Version: 57.10						*/
/*								*/
/*	Revised September 7, 1987   				*/
/*	Revised June 30, 1987   				*/
/*	Revised November 13, 1986 				*/
/*	Revised September 20, 1986 				*/
/*	Revised September 19, 1986 				*/
/*	Revised September 11, 1986 				*/
/*	Revised August 15, 1986 				*/
/*	Revised August 12, 1986 - set up psrunW.c		*/
/*	Revised April 6, 1986					*/
/*	Revised March 16, 1986					*/
/*	Revised March 17, 1986					*/
/*	Revised March 8, 1986					*/
/*	Revised March 5, 1986					*/
/*	Revised May 30, 1984					*/
/*	November 3, 1984					*/

/*
*    COPYRIGHT NOTICE - Copyright (c) 1983-1987 by Peter F. Lemkin.
*                     All rights reserved.
*       Permission is granted to any individual or institution to
*       copy, use or modify this program, except for explicitly
*       commercial purposes, provided this copyright notice is
*       included in its entirety in all derived works.  No warranty
*       of the software or of the accuracy of any documentation
*       surrounding it is expressed or implied, and the author does
*       not acknowledge any liability resulting from program or
*       documentation errors.
*/
/*								*/
#define PROF_RUN		/* needed for testing with #includes */
/*								*/
#ifndef HASCONFIG 	/* primary configurations */
#include "config.h"  /* get it from this area when compile runtimes! */
#endif
/*								*/
/* ---------------------------------------------------- */
/*	P R O F I L E   M A C R O S			*/
/* ---------------------------------------------------- */

#define P_MAX_PROFILES 301	/* must be > maximum number of 
				 * procedures in all of the modules
				 * being linked for which PROFILING is
				 * used.
				*/

#ifndef ISRUNW_C        	/* so <psrunw.c> can get P_MAX_PROFILES */
extern INTEGER w_time[];	/* array to hold the times */
extern STRING w_proc[];		/* array to hold the names */
extern INTEGER w_count[];	/* array to hold the counts */
extern INTEGER w_startCpuTime;		/* when first start up */
extern INTEGER w_stopCpuTime;		/* when finally stop */
extern INTEGER w_idxFree;		/* next free procedure index */

void w_profil_print();	/* print STRING msg and then profile */
#define PROFIL_PRINT(msg) w_profil_print(msg);

#define PROFIL_START w_startCpuTime = callsys(0,"RUNTIM");

#define PROFIL_ON(name) INTEGER p_clock;  /* local time variable */ \
			/* initial starting time of main() */ \
			static INTEGER w_idxFct;  /* profile index */ \
			p_clock = callsys(0,"RUNTIM"); \
						/* initial time */ \
			if (p_idxFct==0) \
				{STRING s,t;\
				p_idxFct = ++w_idxFree; \
				s=Pmalloc(length(GC_PUSHS(name)+1);\
				w_proc[p_idxFct]=s; \
				for(t=name;(*s++ = *t++)!='\0';);\
				}

#define PROFIL_OFF	{\
			w_time[p_idxFct] += callsys(0,"RUNTIM") - \
						 p_clock;\
			w_count[p_idxFct]++;\
			}\;

void w_profil_print();	/* STRING x; print summary */
#define PROFIL_PRINT(x)	w_profil_print(x)
/* ---------------------------------------------------- */
#endif
/* ---> END OF PSRUNW.H <--- */
