/*         File: PSRUNX.H                                     */
/*                                                           */
/*        PSAIL EXTENDED MATH FUNCTION package 			*/
/*                                                           */
/*                                                           */
/*        P. Lemkin                                               */
/*        Image Processing Section                                */
/*        National Cancer Institute, DCBD, LTB                    */
/*        FCRF, Build 469 Room 150B			   	*/
/*        Frederick, MD 21701				   	*/
/*                                                           */
/*	Version: 56.10						*/
/*                                                           */
/*	Revised September 7, 1987				*/
/*	Revised November 13, 1986				*/
/*	Revised September 20, 1986				*/
/*	Revised August 12, 1986 - moved from pmath.c to psrunx.c*/
/*        Revised March 16, 1986                          */
/*        Revised March 8, 1986                          */
/*        Revised March 5, 1986                          */
/*        Revised December 14, 1985                          */
/*        Revised November 14, 1984                          */
/*        Revised August 5, 1984                             */
/*        Revised May 30, 1984                               */
/*        November 13, 1983                                  */
/*								*/
extern char *v_psrunx;	/*Version of PSAIL expected */

/*
*    COPYRIGHT NOTICE - copyright (c) 1983-1986 by Peter F. Lemkin.
*                     All rights reserved.
*       Permission is granted to any individual or institution to
*       copy, use or modify this program, except for explicitly
*       commercial purposes, provided this copyright notice is
*       included in its entirety in all derived works.  No warranty
*       of the software or of the accuracy of any documentation
*       surrounding it is expressed or implied, and the author does
*       not acknowledge any liability resulting from program or
*       documentation errors.
*/
/*                                                                */
#define XMTH_RUN		/* needed for testing with #includes */
/*                                                                */
#ifndef HASCONFIG 	/* primary configurations */
#include "config.h"  /* get it from this area when compile runtimes! */
#endif
/*                                                                */

/*  X. Portable extended numberic funtions : sub-module <psrunX.c>*/
INTEGER packermann(); /* return INTEGER Ackermann's function */
INTEGER pcombin(); /* return combinations n thngs k at time*/
float ploggamma(); /* return float loggamma fct of float x */
INTEGER pfactrl(); /* return INTEGER n! (n factorial) */
INTEGER pfibonacci(); /* return Fibonacci # of n, BYTE 8/83*/ 
float perf(); /* return float ((sw) ? erf(x) : gauss(x)) */
INTEGER pprmtatn(); /* return permutations n thngs k at time*/
float pqsrtf(); /* float quicksort from BYTE 8/83 */
INTEGER pqsrti(); /* INTEGER quicksort from BYTE 8/83 */
STRING pqsrts(); /* string quicksort from BYTE 8/83 */
/* ---> END OF PSRUNX.H <--- */
