/*         File: <sairun.h>                                       */
/*                                                                */
/*        SAIL RUNTIME Compatibility package for PSAIL            */
/*                                                                */
/*                                                                */
/*        P. Lemkin                                               */
/*        Image Processing Section                                */
/*        National Cancer Institute, DCBD, LTB                    */
/*        FCRF, Build 469 Room 150B			   	  */
/*        Frederick, MD 21701				   	  */
/*                                                                */
/*        Version: 57.10                                          */
/*                                                                */
/*        Revised December 1, 1987                                */
/*        Revised October 10, 1987                                */
/*        Revised October 9, 1987                                 */
/*        Revised October 4, 1987                                 */
/*        Revised September 7, 1987                               */
/*        Revised July 6, 1987                                    */
/*        Revised June 30, 1987                                   */
/*        Revised February 14, 1987                               */
/*        Revised November 13, 1986                               */
/*        Revised August 14, 1986                                 */
/*        Revised August 13, 1986                                 */
/*        Revised August 11, 1986                                 */
/*        Revised May 15, 1986                                    */
/*        Revised April 28, 1986                                  */
/*        Revised April 6, 1986                                   */
/*        Revised March 21, 1986                                  */
/*        Revised March 19, 1986                                  */
/*        Revised March 17, 1986                                  */
/*        Revised March 15, 1986                                  */
/*        Revised March 5, 1956                                   */
/*        Revised February 26, 1986                               */
/*        Revised January 18, 1986                                */
/*        Revised January 8, 1986                                 */
/*        Revised January 3, 1986                                 */
/*        Revised December 19, 1985                               */
/*        Revised December 18, 1985                               */
/*        Revised December 14, 1985                               */
/*        Revised December 12, 1985                               */
/*        Revised December 2, 1985                                */
/*        Revised November 26, 1985                               */
/*        Revised November 22, 1985                               */
/*        Revised November 21, 1985                               */
/*        Revised November 5, 1985                                */
/*        Revised October 31, 1985                                */
/*        Revised October 11, 1985                                */
/*        Revised August 6, 1985                                  */
/*        Revised July 19, 1985                                   */
/*        Revised June 27, 1985                                   */
/*        Revised June 19, 1985                                   */
/*        Revised June 10, 1985                                   */
/*        Revised June 7, 1985                                    */
/*        Revised May 30, 1985                                    */
/*        Revised April 26, 1985                                  */
/*        Revised March 7, 1985                                   */
/*        May 5, 1984                                             */
/*                                                                */

		        /* NOTE: need previous #include <config.h> */
extern char *v_sairun;	/* Version of PSAIL expected */
/*                                                                */
#define SAI_RUN		/* needed for testing with #includes */
/*
*    COPYRIGHT NOTICE - copyright (c) 1983-1986 by Peter F. Lemkin.
*                     All rights reserved.
*       Permission is granted to any individual or institution to
*       copy, use or modify this program, except for explicitly
*       commercial purposes, provided this copyright notice is
*       included in its entirety in all derived works.  No warranty
*       of the software or of the accuracy of any documentation
*       surrounding it is expressed or implied, and the author does
*       not acknowledge any liability resulting from program or
*       documentation errors.
*/
/*                                                                */

#ifndef HASCONFIG 	/* primary configurations */
#include "config.h"  /* get it from this area when compile runtimes! */
#endif

/*  1. Storage allocation procedures: sub-module <psrun1.c>        */
INTEGER *aAdr();     /* compute array datum ptr */
LISP_ATOM *aAdrB();  /* compute array LISP!ATOM datum ptr */
STRING *aAdrC();     /* compute array STRING datum ptr */
double *aAdrD();     /* compute array DOUBLE datum ptr */
EVENT *aAdrE();      /* compute array EVENT datum ptr */
float *aAdrF();      /* compute array REAL datum ptr */
INTEGER *aAdrI();    /* compute array INTEGER datum ptr */
OBJECT *aAdrJ();     /* compute array OBJECT datum ptr */
LISP_SEXPR *aAdrK(); /* compute array LISP!SEXPR datum ptr */
LIST *aAdrL();       /* compute array LIST datum ptr */
SET *aAdrS();        /* compute array SET datum ptr */
ITEMVAR *aAdrV();    /* compute array ITEMVAR datum ptr */
ITEM *aAdrX();       /* compute array ITEM datum ptr */
INTEGER *aChk();     /* check against bounds&compute array arg*/
LISP_ATOM *aChkB();  /* compute/chk array LISP!ATOM datum ptr */
STRING *aChkC();     /* compute/chk array STRING datum ptr */
double *aChkD();     /* compute/chk array DOUBLE datum ptr */
EVENT *acheckE();    /* compute/check array EVENT datum ptr */
float *aChkF();      /* compute/chk array REAL datum ptr */
INTEGER *aChkI();    /* compute/chk array INTEGER datum ptr */
OBJECT *aChkJ();     /* compute/chk array OBJECT datum ptr */
LISP_SEXPR *aChkK(); /* compute/chk array LISP!SEXPR datum ptr*/
LIST *aChkL();       /* compute/chk array LIST datum ptr */
SET *aChkS();        /* compute/chk array SET datum ptr */
ITEMVAR *aChkV();    /* compute/chk array ITEMVAR datum ptr */
ITEM *aChkX();       /* compute/chk array ITEM datum ptr */
void arrblt();       /* do SAIL ARRBLT of arrays with count */
void arrclr();       /* do SAIL ARRCLR of dynamic array */
INTEGER arrinfo();   /* do SAIL ARRINFO of dynamic array*/
void arrtran();      /* do SAIL ARRTRAN of dynamic arrays */
void aryel();        /* free dynamically allocated array type */
void aryfree();      /* free dynamically allocated arrays list*/
INTEGER *aryHdr();   /* Create dynamic header in static array */
LISP_ATOM *aryHdrB();  /* Create static array dyn-hdr LISP!ATOM*/
STRING *aryHdrC();     /* Create static array dyn-hdr STRING*/
double *aryHdrD();     /* Create static array dyn-hdr DOUBLE*/
EVENT *aryHdrE();      /* Create static array dyn-hdr EVENT*/
float *aryHdrF();      /* Create static array dyn-hdr REAL*/
INTEGER *aryHdrI();    /* Create static array dyn-hdr INTEGER*/
OBJECT *aryHdrJ();     /* Create static array dyn-hdr OBJECT*/
LISP_SEXPR *aryHdrK(); /* Create static arry dyn-hdr LISP!SEXPR*/
LIST *aryHdrL();       /* Create static array dyn-hdr LIST*/
SET *aryHdrS();        /* Create static array dyn-hdr SET*/
ITEMVAR *aryHdrV();    /* Create static array dyn-hdr ITEMVAR*/
ITEM *aryHdrX();       /* Create static array dyn-hdr ITEM*/
INTEGER *aChk();     /* check against bounds&compute array arg*/
INTEGER *arymk();    /* Dynamically allocate array type */
LISP_ATOM *arymkB();  /* Create dynamic array LISP!ATOM*/
STRING *arymkC();     /* Create dynamic array STRING*/
double *arymkD();     /* Create dynamic array DOUBLE*/
EVENT *arymkE();      /* Create dynamic array EVENT*/
float *arymkF();      /* Create dynamic array REAL*/
INTEGER *arymkI();    /* Create dynamic array INTEGER*/
OBJECT *arymkJ();     /* Create dynamic array OBJECT*/
LISP_SEXPR *arymkK(); /* Create static arry dyn-hdr LISP!SEXPR*/
LIST *arymkL();       /* Create dynamic array LIST*/
SET *arymkS();        /* Create dynamic array SET*/
ITEMVAR *arymkV();    /* Create dynamic array ITEMVAR*/
ITEM *arymkX();       /* Create dynamic array ITEM*/
void Carrclr();      /* do C ARRCLR of array w/INTEGER count*/
void Carrtran();     /* do C ARRTRAN of arrays w/INTEGER count*/
void chkversion();   /* check module version nbr consistency*/
void del_record();   /* delete record allocated with new_record*/
INTEGER *new_record(); /* allocate a record size nBytes */
INTEGER Phash();     /* lookup/enter string s in tbl t size m*/
STRING salloc();     /* alloc nbyte string GC'able string space*/
STRING Pmalloc();    /* allocate nbyte storage from heap */
INTEGER Pfree();     /* return block (by *ptr) to heap. */

/*  2. Program control procedures: sub-module <psrun2.c>        */
INTEGER PSlongjmp(); /* goto address by long newsp stack ptr */
INTEGER PSsetjmp();  /* rtn this stack ptr for later longjump */
INTEGER callsys();   /* Emulate SAIL 'CALL' DEC10 UUOs */

/*  3. STRING procedures: sub-module <psrun3.c>                     */
double Patod();      /* return double value of string # s*/
float Patof();       /* return float value of string # s */
int Patoi();         /* return int value of string # s */
INTEGER Patol();     /* return INTEGER value of string # s*/
INTEGER Patoo();     /* return INTEGER octal val of string # s*/
INTEGER Patou();     /* return INTEGER unsigned val string # s */
INTEGER Patox();     /* return INTEGER hex value of string # s*/
STRING catlist();    /* concatenate list of string ptrs */
STRING cncat2();     /* return Pmalloc() alloc STRING of (a&b)*/
STRING concat();     /* return SAIL style STRING  of (a&b) */
STRING Pcpystr();    /* return copy of string s. */
INTEGER length();    /* return length of string s. */
STRING strsub();     /* return STRING s[a,fn,b] substring */
STRING subsr();      /* return STRING s[a For b] substring */
STRING subst();      /* return STRING s[a To b] substring */

/*  4. STRING conversion functions: sub-module <psrun4.c>        */
void Pdtoa();        /* return string # of double value */
void Pdetoa();       /* return string # of double E value */
void Petoa();        /* return string # of float E value */
void Pftoa();        /* return string # of float value */
void Pitoa();        /* return string # of int value */
void Pltoa();        /* return string # of INTEGER value */
void Potoa();        /* return string # of INTEGER octal value*/
void Putoa();        /* return string # of long unsigned value*/
void Pxtoa();        /* return string # of INTEGER hex value */
INTEGER copstr();    /* return first char of string s else 0*/
STRING cv6str();     /* cvt sixbit INTEGER n to string s */
INTEGER cvasc();     /* cvt 5-chars string s==>7-bit long word*/
STRING cvastr();     /* cvt ASCII INTEGER n to string s */
INTEGER cvd();       /* return decimal INTEGER value string s*/
STRING cvf();        /* cvt float f to decimal string */
STRING cve();        /* cvt float f ==> E-fmt string */
STRING cvg();        /* cvt float f ==> G-fmt string */
INTEGER cvo();       /* return octal value of string s */
STRING cvos();       /* cvt octal INTEGER n to str, return ptr*/
STRING cvs();        /* cvt decimal INTEGER n==>string */
INTEGER cvsix();     /* cvt 6 char string s==>sixbit INTEGER */
STRING cvstr();      /* cvt sixbit INTEGER n==>return string s*/
STRING cvxstr();     /* cvt 7-bit/ ASCII INTEGER n==>string s*/
INTEGER equ();       /* return (s1[1:inf]==s2[1:inf]) ? 1 : 0 */
INTEGER getformat(); /* get default field width & precision */
STRING makstr();     /* make 2 character string<==LSB 7bits n*/
INTEGER lopstr();    /* return&advance first char of string s*/
INTEGER setformat(); /* set default field width & precision */

/*  5. SCAN procedures: sub-module <psrun5.c>                        */
void breakset();     /* modify break table */
INTEGER getbreak();  /* get free break tbl INTEGER idx [1:54] */
INTEGER intscan();   /* scan INTEGER # <== *, set long *brk */
float realscan();    /* scan real # <== *s, set INTEGER *brk */
INTEGER relbreak();  /* release break table number 1 to 54 */
STRING scan();    /* rtn scan'd string *s w/brk tbl, set *bChr*/
STRING scanc();    /* do SAIL SCANC function */
void setbreak();     /* define break table */
void stdbrk();       /* set break tbl [1:18] see pg38[ReisJ76]*/

/*  6. Special 32-bit Numeric functions: sub-module <psrun6.c>       */
INTEGER ash();       /* return INTEGER v arith. shifted n bits*/
INTEGER lsh();       /* return INTEGER v logic. shifted n bits*/
INTEGER rot();       /* return INTEGER v rotated n bits */

/* 7. I/O procedures: sub-module <psrun7.c>                        */
INTEGER arryin();    /* do SAIL ARRYIN */
INTEGER chncdb();    /* do SAIL CHNCDB */
INTEGER arryout();   /* do SAIL ARRYOUT */
INTEGER PSclose();   /* do SAIL CLOSE */
INTEGER closin();    /* do SAIL CLOSIN */
INTEGER closo();     /* do SAIL CLOSO */
INTEGER enter();     /* do SAIL ENTER */
INTEGER PSgetchan(); /* do SAIL GETCHAN */
STRING getprint();   /* do SAIL GETPRINT */
STRING inchwl();     /* do SAIL INCHWL */
INTEGER inchrw();    /* do SAIL INCHRW */
INTEGER inchrs();    /* do SAIL INCHRS */
STRING input();      /* do SAIL INPUT */
INTEGER intin();     /* do SAIL INTIN */
INTEGER lookup();    /* do SAIL LOOKUP */
INTEGER PSopen();    /* do SAIL OPEN */
INTEGER out();       /* do SAIL OUT */
INTEGER outchr();    /* do SAIL OUTCHR */
void PSprintf();     /* machine independent printf() function */
float realin();      /* do SAIL REALIN */
INTEGER relchan();   /* do SAIL RELCHAN */
INTEGER release();   /* do SAIL RELEASE */
void PSrename();     /* do SAIL RENAME */
void senter();       /* do SAIL ENTER w/prot.*/
void setprint();     /* do SAIL SETPRINT*/
INTEGER ttyup();     /* set tty input case conv&rtn old value*/
INTEGER usererr();   /* do SAIL USERERR */
INTEGER useti();     /* do SAIL USETI */
INTEGER useto();     /* do SAIL USETO */
INTEGER wordin();    /* do SAIL WORDIN */
INTEGER wordout();   /* do SAIL WORDOUT */
/*								*/
/*  8. Float-point transendental and degree-argument trig functions */
INTEGER paprovf(); /* compute (a/b) return 0 OK, 1 OVF, 2 UNDF*/
INTEGER pflexp(); /* return INTEGER exponent e in x=f*(2^e) */
FAKEFLOAT pflfract(); /* return float fraction f in x=f*(2^e)*/
FAKEFLOAT pflval(); /* return float value f*(2^e)	*/
float pabs(); /* convert INTEGER n absolute integer 	*/
float pabsf(); /* convert float f absolute value 	*/
float pexp(); /* return exponential (e) to float x power */
float plog(); /* return log (base e) of float x		*/
float plog10(); /* return log (base 10) of float x	*/
INTEGER ppowii(); /* raise INTEGER i to n-th power. n >= 0 */
float ppowif(); /* raise INTEGER i to float f-th power.   */
float ppowfi(); /* raise float f to INTEGER n-th power. n>=0 */
float ppowff(); /* raise float x to float y power	*/
float prand(); /* return float random number of x	*/
float psqrt(); /* return float square root of x		*/
float pdegtorad(); /* return float radian value of degrees */
float pcosd(); /* return float value of cos of d (degrees) */
float pradtodeg(); /* return float degree value of radians */
float psind(); /* return float value of sin of d (degrees) */
float ptand(); /* return float value of tan of d (degrees) */
/*								*/
/*  9. Portable trig procedures (using either <pmath.h> or <psrun9.c> */
/*   NOTE: if not HASPMATH then use <pmath.h> with macros to map fcts */
#ifdef HASPMATH
float pacos(); /* return float value of acos of r (radians) */
float pasin(); /* return float value of asin of r (radians) */
float patan(); /* return float value of atan of r (radians) */
float patan2(); /* return float value of atan(a/b) (rads) */
float pcos(); /* return float value of cos of r (radians) */
float pcosh(); /* return float value of cosh(x)		*/
float psin(); /* return float value of sin of r (radians) */
float psinh(); /* return float value of sinh(x)		*/
float ptan(); /* return float value of tan of r (radians) */
float ptanh(); /* return float value of tanh(x)		*/
#endif
/*	 							*/
/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/
/*	+    G L O B A L    V A R I A B L E S / M A C R O S	*/
/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/

/*	The following macros are used to implement symbols 	*/
/*	emitted by the translator 				*/
#define MXSTRSIZ 132		/* used where ??? else trash!! */
#ifndef ABS
#define ABS(x) (((x)<0) ? (-x) : (x))
#define ABSF(x) (((x)<0.0) ? (-x) : (x))
#endif
#define CTRLZ	027
#ifndef EQV
#define EQV(x,y) ( ((x) & (y)) | (~(x) & ~(y)) ) 
#endif
#define FALSE	((INTEGER)0)
#ifndef FLOOR
#define FLOOR(x) ((INTEGER)(x))	/* ... do floor() fnct */
#endif
#define INULL (INTEGER *)0
#define IPPOW(x,y) (((x)==0) ? 1 \
		: (INTEGER)exp((double)(y)*log((double)(x)))
#ifndef LOP
#define LOP(x) ((x==0||*x=='\0') ? '\0' : (*(x++)))
		/* LOP() is a macro, lopstr() is in <sairun.c> */
#endif
#ifdef HASLOGICALSHIFT
#ifndef LSH
#define LSH(a,b) ((a) << (b))
#endif
#endif 
#ifndef HASLOGICALSHIFT
#ifndef LSH
#define LSH(a,b) lsh((a),(b))
#endif
#endif
#ifndef MAX
#define MAX(x,y) (((x)>(y)) ? (x) : (y))
#endif
#ifndef MIN
#define MIN(x,y) (((x)<(y)) ? (x) : (y))
#endif
#define Pfmod(x,y) ((y==0.0)?0:(x-((long)(x/y))*y)*((x>0.0)?1:-1))
#define PNULL ""
#define PPOW(x,y) (((x)==0.) ? 1.0 : exp((double)(y)*log((double)(x)))
                            /* NOTE: see redefine of PPOW ifndef HASPMATH */
#define PPOW2(x) ((x)*(x))
#define PPOW3(x) ((x)*(x)*(x))
#ifdef HASLOGICALSHIFT
#ifndef RSH
#define RSH(a,b) ((a) >> (b))
#endif
#endif
#ifndef HASLOGICALSHIFT
#ifndef RSH
#define RSH(a,b) lsh((a),-(b))
#endif
#endif
#define SWAP(a,b) {INTEGER t; t=a; a=b; b=t;}  /* generic default */
#define SWAPC(a,b) {STRING t; t=a; a=b; b=t;}
#define SWAPD(a,b) {double t; t=a; a=b; b=t;}
#define SWAPF(a,b) {float t; t=a; a=b; b=t;}
#define SWAPI(a,b) {INTEGER t; t=a; a=b; b=t;}
#define TRUE ((INTEGER)1)




#include <stdio.h>

#ifdef HASSARGASSOC		/* use with DEC10 SARGASSO C */
#ifndef IO_READ
#include <iodefs.hdr>
#endif
#endif

#ifdef HASX3J11			/* ANSI X3J11 C standard */
#ifdef HASLOCALFILE
#include "ctype.h" 
#include "setjmp.h"
#include "signal.h"
#include "stdarg.h"
#include "stdefs.h"
#include "stdlib.h"
#include "string.h"
#include "time.h"
#endif
#ifndef HASLOCALFILE
#include <ctype.h> 
#include <setjmp.h>
#include <signal.h>
#include <stdarg.h>
#include <stdefs.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#endif
#endif             /* end of HASX3J11 */


#ifdef HASSYSTEMV		   /* SYSTEM V - C standard */
#ifdef HASLOCALFILE
#include "ctype.h" 
#include "setjmp.h"
#include "signal.h"
#include "stdefs.h"
#include "string.h"
#include "time.h"
#include "types.h"		  
#endif
#ifndef HASLOCALFILE
#include <ctype.h> 
#include <setjmp.h>
#include <signal.h>
#include <stdefs.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#endif
#endif             /* end of SYSTEM V */


#ifdef HASBSD			/* BSD C standard */
#ifdef HASLOCALFILE
#include "ctype.h" 
#include "setjmp.h"
#include "signal.h"
#include "string.h"
#include "time.h"
#include "types.h"
#endif
#ifndef HASLOCALFILE
#include <ctype.h> 
#include <setjmp.h>
#include <signal.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#endif
#endif             /* end of BSD */

#ifndef HASPMATH	/* to define trig fcts in terms of <pmath.h> */
			/* We assume that your <pmath.h> pkg has the
			 * following functions - if not, then use 
			 * PSAIL's. Note: that PSAIL will assume
			 * (double) and cast accordingly.
			*/

/* NOTE: <pmath.h> is <math.h> edited to remove the Bessel functions
   j0(), j1(), y1(), and y2().
*/
#ifndef M_PI_4
#include "pmath.h"
#endif
#undef PPOW
#define PPOW(x,y) (float)pow((double)x,(double)y)
#define pacos(r) acos(r)
#define pasin(r) asin(r)
#define patan(r) atan(r)
#define patan2(a,b) atan(a,b)
#define pcos(r) cos(r)
#define pcosh(x) cosh(x)
#define psin(r) sin(r)
#define psinh(x) sin(x)
#define ptan(r) tan(r)
#define ptanh(r) tanh(r)
#define plog(r) log(r)
#define pexp(r) exp(r)
#define psqrt(r) sqrt(r)
#endif
